﻿BACKPACK_CONTAINER = 0  --~~ REMOVE ONCE 2.2 COMES OUT

ArkInventory = AceLibrary( "AceAddon-2.0" ):new( "AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceHook-2.1" )

ArkInventory.Localise = AceLibrary( "AceLocale-2.2" ):new( "ArkInventory" )

ArkInventory.Lib = { -- libraries live here
	PeriodicTable = AceLibrary( "PeriodicTable-3.0" ),
	DewDrop = AceLibrary( "Dewdrop-2.0" ),
}

ArkInventory.Table = { } -- table functions live here

ArkInventory.Const = { -- constants

	Program = {
		Name = "ArkInventory",
		Version = 2.09,
		Beta = nil, -- "2007-JUN-28-21-45",
		Frame = "ARKINV_Frame",
	},

	PTR = false,
	Debug = false,

	Location = {
		Bag = 1, -- hardcoded, do not change, should match xml id
		Bank = 2, -- hardcoded, do not change, should match xml id
		Key = 3, -- hardcoded, do not change, should match xml id
	},

	Slot = {
	
		Type = { -- slot type numbers, do not change this order, just add new ones to the end of the list
			Unknown = 0,
			Bag = 1,
			Key = 3,
			Soulshard = 5,
			Herb = 6,
			Enchanting = 7,
			Engineering = 8,
			Gem = 9,
			Mining = 10,
			Bullet = 11,
			Arrow = 12,
		},

		New = {
			None = 0,
			New = 1,
			Increased = 2,
			Decreased = 3,
		},

		DefaultColour = {
			r = 0.3,
			g = 0.3,
			b = 0.3
		},

		Data = nil,
		
	},

	Anchor = {
		BottomRight = 1,
		BottomLeft = 2,
		TopLeft = 3,
		TopRight = 4,
	},
	
	Direction = {
		Horizontal = 1,
		Vertical = 2,
	},
	
	Window = {
	
		Offset = 9, -- hardcoded padding size for gap inside container
		
		Min = {
			Rows = 1,
			Columns = 6,
			Width = 500,
			Height = 40,
		},
		
		Draw = {
			Init = 0, -- first time
			Recalculate = 1, -- calculate
			Resort = 2, -- sort
			Refresh = 3, -- item changes
			None = 4, -- nothing
		},

	},

	Fade = 0.6,

	BAR_DEFAULT_COLOUR = { r = 0.0, g = 0.0, b = 0.4, a = 0.4 },

	Categories = {
	
		Default = -401,

		System = { -- do NOT change the indicies - if you have to then see the ConvertOldOptions() function to remap it
			[-401] = ArkInventory.Localise["CATEGORY_DEFAULT"],
			[-402] = ArkInventory.Localise["CATEGORY_TRASH"],
			[-403] = ArkInventory.Localise["CATEGORY_SOULBOUND"],
			[-404] = ArkInventory.Localise["CATEGORY_CONSUMABLE"],
			[-405] = ArkInventory.Localise["CATEGORY_CONTAINER"],
			[-406] = ArkInventory.Localise["CATEGORY_KEY"],
			[-407] = ArkInventory.Localise["CATEGORY_MISCELLANEOUS"],
			[-408] = ArkInventory.Localise["CATEGORY_REAGENT"],
			[-409] = ArkInventory.Localise["CATEGORY_RECIPE"],
			[-410] = ArkInventory.Localise["CATEGORY_PROJECTILE"],
			[-411] = ArkInventory.Localise["CATEGORY_QUEST"],
			[-412] = ArkInventory.Localise["CATEGORY_TRADE_GOODS"],
			[-413] = ArkInventory.Localise["CATEGORY_SOULSHARD"],
			[-414] = ArkInventory.Localise["CATEGORY_EQUIPMENT"],
			[-415] = ArkInventory.Localise["CATEGORY_MOUNT"],
			[-416] = ArkInventory.Localise["CATEGORY_EQUIPMENT_SOULBOUND"],
			[-417] = ArkInventory.Localise["CATEGORY_FOOD"],
			[-418] = ArkInventory.Localise["CATEGORY_DRINK"],
			[-419] = ArkInventory.Localise["CATEGORY_POTION_MANA"],
			[-420] = ArkInventory.Localise["CATEGORY_POTION_HEAL"],
			[-421] = ArkInventory.Localise["CATEGORY_PROJECTILE_BULLET"],
			[-422] = ArkInventory.Localise["CATEGORY_PROJECTILE_ARROW"],
			[-423] = ArkInventory.Localise["CATEGORY_PET_NONCOMBAT"],
			[-424] = ArkInventory.Localise["CATEGORY_POTION"],
			[-428] = ArkInventory.Localise["CATEGORY_REPUTATION"],
		},
		Skill = { -- do NOT change the indicies
			[-101] = ArkInventory.Localise["CATEGORY_SKILL_ALCHEMY"],
			[-102] = ArkInventory.Localise["CATEGORY_SKILL_BLACKSMITHING"],
			[-103] = ArkInventory.Localise["CATEGORY_SKILL_COOKING"],
			[-104] = ArkInventory.Localise["CATEGORY_SKILL_ENGINEERING"],
			[-105] = ArkInventory.Localise["CATEGORY_SKILL_ENCHANTING"],
			[-106] = ArkInventory.Localise["CATEGORY_SKILL_FIRST_AID"],
			[-107] = ArkInventory.Localise["CATEGORY_SKILL_FISHING"],
			[-108] = ArkInventory.Localise["CATEGORY_SKILL_HERBALISM"],
			[-109] = ArkInventory.Localise["CATEGORY_SKILL_JEWELCRAFTING"],
			[-110] = ArkInventory.Localise["CATEGORY_SKILL_LEATHERWORKING"],
			[-111] = ArkInventory.Localise["CATEGORY_SKILL_MINING"],
			[-112] = ArkInventory.Localise["CATEGORY_SKILL_SKINNING"],
			[-113] = ArkInventory.Localise["CATEGORY_SKILL_TAILORING"],
		},
		Class = { -- do NOT change the indicies
			[-201] = ArkInventory.Localise["CATEGORY_CLASS_DRUID"],
			[-202] = ArkInventory.Localise["CATEGORY_CLASS_HUNTER"],
			[-203] = ArkInventory.Localise["CATEGORY_CLASS_MAGE"],
			[-204] = ArkInventory.Localise["CATEGORY_CLASS_PALADIN"],
			[-205] = ArkInventory.Localise["CATEGORY_CLASS_PRIEST"],
			[-206] = ArkInventory.Localise["CATEGORY_CLASS_ROGUE"],
			[-207] = ArkInventory.Localise["CATEGORY_CLASS_SHAMAN"],
			[-208] = ArkInventory.Localise["CATEGORY_CLASS_WARLOCK"],
			[-209] = ArkInventory.Localise["CATEGORY_CLASS_WARRIOR"],
		},
		Empty = { -- do NOT change the indicies
			[-312] = ArkInventory.Localise["CATEGORY_EMPTY_UNKNOWN"],
			[-301] = ArkInventory.Localise["CATEGORY_EMPTY"],
			[-302] = ArkInventory.Localise["CATEGORY_EMPTY_BAG"],
			[-303] = ArkInventory.Localise["CATEGORY_EMPTY_KEY"],
			[-304] = ArkInventory.Localise["CATEGORY_EMPTY_SOULSHARD"],
			[-305] = ArkInventory.Localise["CATEGORY_EMPTY_HERB"],
			[-306] = ArkInventory.Localise["CATEGORY_EMPTY_ENCHANTING"],
			[-307] = ArkInventory.Localise["CATEGORY_EMPTY_ENGINEERING"],
			[-308] = ArkInventory.Localise["CATEGORY_EMPTY_GEM"],
			[-309] = ArkInventory.Localise["CATEGORY_EMPTY_MINING"],
			[-310] = ArkInventory.Localise["CATEGORY_EMPTY_PROJECTILE_BULLET"],
			[-311] = ArkInventory.Localise["CATEGORY_EMPTY_PROJECTILE_ARROW"],
		},
		Other = { -- do NOT change the indicies - if you have to then see the ConvertOldOptions() function to remap it
			[-425] = ArkInventory.Localise["CATEGORY_TRADE_GOODS_DEVICES"],
			[-426] = ArkInventory.Localise["CATEGORY_TRADE_GOODS_EXPLOSIVES"],
			[-427] = ArkInventory.Localise["CATEGORY_TRADE_GOODS_PARTS"],
			[-901] = ArkInventory.Localise["CATEGORY_CORE_MATS"],
			[-902] = ArkInventory.Localise["CATEGORY_FOOD_PET"],
		},
	
	},

	Texture = {
		Missing = [[Interface\Icons\Temp]],
		Empty = {
			Bag = [[Interface\PaperDoll\UI-PaperDoll-Slot-Bag]],
			Slot = [[Interface\PaperDoll\UI-Backpack-EmptySlot]],
		},
	},
	
	SortKeys = {
		category = true,
		location = true,
		itemuselevel = true,
		itemtype = true,
		quality = true,
		name = true,
	},

	Skills = "ALCHEMY,BLACKSMITHING,COOKING,ENCHANTING,ENGINEERING,FIRST_AID,FISHING,HERBALISM,JEWELCRAFTING,LEATHERWORKING,MINING,SKINNING,TAILORING,RIDING",

	Classes = "DRUID,HUNTER,MAGE,PALADIN,PRIEST,ROGUE,SHAMAN,WARLOCK,WARRIOR",
	
	
	SlashCommandOptions = {
		type = "group",
		args = {
	
			gui = {
				type = "group",
				name = "gui",
				desc = "gui options",
				args = {
					reset = {
						type = "execute",
						name = "reset",
						desc = "centers the interface on the screen",
						func = function()
							for loc_id in pairs( ArkInventory.Global.Location ) do
								getglobal( ArkInventory.Const.Program.Frame .. loc_id ):SetPoint( "TOPLEFT", UiParent, "CENTER" )
							end
						end
					},
				},
			},
			
			db = {
				type = "group",
				name = "db",
				desc = "db options",
				args = {
					reset = {
						type = "group",
						name = "reset",
						desc = "resets all options back to the defaults",
						args = {
							confirm = {
								type = "execute",
								name = "confirm",
								desc = "confirms the database reset",
								func = function() ArkInventory.DatabaseReset() end
							},
						},
					},
				},
			},
			
			cache = {
				type = "group",
				name = "cache",
				desc = "cache options",
				args = {
					erase = {
						type = "group",
						name = "erase",
						desc = "erases all cached data",
						args = {
							confirm = {
								type = "execute",
								name = "confirm",
								desc = "confirms the cache erase",
								func = function() ArkInventory.OfflineCacheErase() end
							},
						},
					},
				},
			},
			
		},
	},
	
}

ArkInventory.Global = { -- globals

	Mode = {
		Edit = false,
		Bank = false,
		Combat = false,
	},

	ScanTooltip = nil,
	
	Skills = { },

	Category = { }, -- see Category_Generate() for how this gets populated

	Location = {
		
		[ArkInventory.Const.Location.Bag] = {
			NAME = ArkInventory.Localise["LOCATION_BAG"],
			TEXTURE = [[Interface\Buttons\Button-Backpack-Up]],
			BAGS = { },
			player = "UNKNOWN",
	
			bar_max = 0,
			slot_max = { },
			anchor = { },
		
			offline = false,
			rescan = { },
		
			draw_state = ArkInventory.Const.Window.Draw.Init,
		},
	
		[ArkInventory.Const.Location.Bank] = {
			NAME = ArkInventory.Localise["LOCATION_BANK"],
			TEXTURE = [[Interface\Icons\INV_Box_03]],
			BAGS = { },
			player = "UNKNOWN",
	
			bar_max = 0,
			slot_max = { },
			anchor = { },
	
			offline = true,
			rescan = { },

			draw_state = ArkInventory.Const.Window.Draw.Init,
		},
	
		[ArkInventory.Const.Location.Key] = {
			NAME = ArkInventory.Localise["LOCATION_KEY"],
			TEXTURE = [[Interface\Icons\INV_Misc_Key_04]],
			BAGS = { },
			player = "UNKNOWN",
	
			bar_max = 0,
			slot_max = { },
			anchor = { },
	
			offline = false,
			rescan = { },
	
			draw_state = ArkInventory.Const.Window.Draw.Init,
		},

	},

	Cache = {
		Current = { },
		Default = { },
	},
	
	BAG_SLOT_SIZE = 32,

	Me = { },
	
}

ArkInventory.Const.Slot.Data = {
	[ArkInventory.Const.Slot.Type.Unknown] = {
		["name"] = ArkInventory.Localise["STATUS_NAME_UNKNOWN"],
		["long"] = ArkInventory.Localise["CATEGORY_EMPTY_UNKNOWN"],
		["colour"] = { r = 1.0, g = 0.0, b = 0.0 }, -- red
	},
	[ArkInventory.Const.Slot.Type.Bag] = {
		["name"] = ArkInventory.Localise["STATUS_NAME_BAG"],
		["long"] = ArkInventory.Localise["CATEGORY_EMPTY_BAG"],
		["type"] = ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_BAG"],
		["colour"] = ArkInventory.Const.Slot.DefaultColour,
	},
	[ArkInventory.Const.Slot.Type.Key] = {
		["name"] = ArkInventory.Localise["STATUS_NAME_KEY"],
		["long"] = ArkInventory.Localise["CATEGORY_EMPTY_KEY"],
		["colour"] = { r = 1.0, g = 1.0, b = 0.0 }, -- yellow,
	},
	[ArkInventory.Const.Slot.Type.Soulshard] = {
		["name"] = ArkInventory.Localise["STATUS_NAME_SOULSHARD"],
		["long"] = ArkInventory.Localise["CATEGORY_EMPTY_SOULSHARD"],
		["type"] = ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_SOULSHARD"],
		["colour"] = { r = 1.0, g = 0.0, b = 1.0 }, -- magenta
		["pt"] = "Container.ItemsInType.Soul Shard",
	},
	[ArkInventory.Const.Slot.Type.Herb] = {
		["name"] = ArkInventory.Localise["STATUS_NAME_HERB"],
		["long"] = ArkInventory.Localise["CATEGORY_EMPTY_HERB"],
		["type"] = ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_HERB"],
		["colour"] = { r = 0.0, g = 1.0, b = 0.0 }, -- green
		["pt"] = "Container.ItemsInType.Herb",
	},
	[ArkInventory.Const.Slot.Type.Enchanting] = {
		["name"] = ArkInventory.Localise["STATUS_NAME_ENCHANTING"],
		["long"] = ArkInventory.Localise["CATEGORY_EMPTY_ENCHANTING"],
		["type"] = ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_ENCHANTING"],
		["colour"] = { r = 0.0, g = 0.0, b = 1.0 }, -- blue
		["pt"] = "Container.ItemsInType.Enchanting",
	},
	[ArkInventory.Const.Slot.Type.Engineering] = {
		["name"] = ArkInventory.Localise["STATUS_NAME_ENGINEERING"],
		["long"] = ArkInventory.Localise["CATEGORY_EMPTY_ENGINEERING"],
		["type"] = ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_ENGINEERING"],
		["colour"] = ArkInventory.Const.Slot.DefaultColour,
		["pt"] = "Container.ItemsInType.Engineering",
	},
	[ArkInventory.Const.Slot.Type.Gem] = {
		["name"] = ArkInventory.Localise["STATUS_NAME_GEM"],
		["long"] = ArkInventory.Localise["CATEGORY_EMPTY_GEM"],
		["type"] = ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_GEM"],
		["colour"] = ArkInventory.Const.Slot.DefaultColour,
		["pt"] = "Container.ItemsInType.Gem",
	},
	[ArkInventory.Const.Slot.Type.Mining] = {
		["name"] = ArkInventory.Localise["STATUS_NAME_MINING"],
		["long"] = ArkInventory.Localise["CATEGORY_EMPTY_MINING"],
		["type"] = ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_MINING"],
		["colour"] = ArkInventory.Const.Slot.DefaultColour,
		["pt"] = "Container.ItemsInType.Mining",
	},
	[ArkInventory.Const.Slot.Type.Bullet] = {
		["name"] = ArkInventory.Localise["STATUS_NAME_PROJECTILE_BULLET"],
		["long"] = ArkInventory.Localise["CATEGORY_EMPTY_PROJECTILE_BULLET"],
		["type"] = ArkInventory.Localise["WOW_ITEM_TYPE_QUIVER_BULLET"],
		["colour"] = { r = 1.0, g = 0.5, b = 0.15 }, -- orange
		["pt"] = "Reagent.Ammo.Bullet",
	},
	[ArkInventory.Const.Slot.Type.Arrow] = {
		["name"] = ArkInventory.Localise["STATUS_NAME_PROJECTILE_ARROW"],
		["long"] = ArkInventory.Localise["CATEGORY_EMPTY_PROJECTILE_ARROW"],
		["type"] = ArkInventory.Localise["WOW_ITEM_TYPE_QUIVER_ARROW"],
		["colour"] = { r = 1.0, g = 0.5, b = 0.15 }, -- orange
		["pt"] = "Reagent.Ammo.Arrow",
	}
}


-- Binding Variables
BINDING_HEADER_ARKINV = ArkInventory.Const.Program.Name
BINDING_NAME_ARKINV_TOGGLE_BAG = ArkInventory.Localise["LOCATION_BAG"]
BINDING_NAME_ARKINV_TOGGLE_KEY = ArkInventory.Localise["LOCATION_KEY"]
BINDING_NAME_ARKINV_TOGGLE_BANK = ArkInventory.Localise["LOCATION_BANK"]
BINDING_NAME_ARKINV_TOGGLE_EDIT = ArkInventory.Localise["MOD_MENU_MAIN_EDITMODE"]
BINDING_NAME_ARKINV_RESTACK_BAG = ArkInventory.Localise["MOD_MENU_MAIN_COMPRESS"]


ArkInventory:RegisterChatCommand( { "/arkinventory", "/arkinv", "/ai" }, ArkInventory.Const.SlashCommandOptions )

ArkInventory:RegisterDB( "ARKINVDB" )

ArkInventory:RegisterDefaults( "profile",
	{
		["option"] = {
			["version"] = 0,
			["category"] = { }, -- ["item id"] = category number to put item in - only for system categories, rules are not included
			["rule"] = {
				["*"] = false, --[rule number] = true (enabled) / false (disabled)
			},
			["useglobal"] = true, -- true = use the bag settings for all locations, false = use each locations settings
			["local"] = {
				["*"] = {
					["window"] = {
						["scale"] = 1,
						["width"] = 16,
						["border"] = true,
						["colour"] = {
							["background"] = {
								["r"] = 0,
								["g"] = 0,
								["b"] = 0,
								["a"] = 0.75,
							},
							["border"] = {
								["r"] = 1,
								["g"] = 1,
								["b"] = 1,
							},
							["baghighlight"] = {
								["r"] = 0,
								["g"] = 1,
								["b"] = 0,
							},
						},
						["pad"] = 8,
						["anchor"] = ArkInventory.Const.Anchor.TopLeft,
					},
					["bar"] = {
						["per"] = 5,
						["pad"] = {
							["internal"] = 8,
							["external"] = 8,
						},
						["border"] = true,
						["colour"] = {
							["background"] = ArkInventory.Const.BAR_DEFAULT_COLOUR,
							["border"] = ArkInventory.Const.BAR_DEFAULT_COLOUR,
						},
						["showempty"] = false,
						["anchor"] = ArkInventory.Const.Anchor.BottomRight,
						["direction"] = ArkInventory.Const.Direction.Horizontal,
						["compact"] = false,
						["hide"] = false,
					},
					["slot"] = {
						["empty"] = {
							["alpha"] = 0.1,
							["icon"] = true,
							["border"] = true,
							["clump"] = false,
						},
						["data"] = ArkInventory.Const.Slot.Data,
						["pad"] = 4,
						["border"] = true,
						["ignorehidden"] = false,
					},
					["sort"] = {
						["bagslot"] = true,
						["instant"] = false,
						["reversed"] = false,
						["category"] = false,
						["location"] = false,
						["itemuselevel"] = false,
						["itemtype"] = false,
						["quality"] = false,
						["name"] = false,
					},
					["sortorder"] = { },
					["category"] = { }, -- [category number] = bar number to put rule on
					["rule"] = { }, -- old rule entry
				},
			},
		},
	
	}
)

ArkInventory:RegisterDefaults( "account",
	{
		["option"] = {
			["version"] = 0,
			["offline"] = {
				["bank"] = true, -- keep bank data when leaving the bank
				["alt"] = true, -- keep bag & keyring on logout
				["fade"] = true,
			},
			["auto"] = {
				["open"] = {
					["bank"] = true,
					["mail"] = true,
					["trade"] = true,
					["merchant"] = true,
					["auction"] = true,
				},
				["close"] = {
					["bank"] = true,
					["mail"] = true,
					["trade"] = true,
					["merchant"] = true,
					["auction"] = true,
					["combat"] = true,
				},
			},
			["framehide"] = {
				["blizzard"] = true,
				["status"] = false,
				["header"] = false,
				["changer"] = false,
			},
			["newitem"] = {
				["show"] = false,
				["colour"] = {
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				},
			},
			["rule"] = { }, -- [rule number] = { rule data }
			["nextrule"] = 1,
			["showdisabled"] = true,
		},
		["cache"] = {
			["version"] = 0,
			["who"] = {
				["*"] = {
					["loc"] = {
						["*"] = {
							["bag"] = { },
							["bar"] = { },
							["container"] = { },
							["slot_count"] = 0,
							["bar_count"] = 0,
						},
					},
					["skills"] = { },
				},
			},
		},
	}
)



function ArkInventory.DatabaseReset()

	-- /ai db reset confirm

	ArkInventory.Frame_Main_Hide()

	ArkInventory.ResetDB( "profile" )
	
	ArkInventory.PrintPlus( { GREEN_FONT_COLOR_CODE, "Profile has been reset." } )
	ArkInventory.PrintPlus( { GREEN_FONT_COLOR_CODE, "All options are now back to defaults." } )
	
	ArkInventory.Category_Generate()
	
	ArkInventory.BagSetDirtyAll()
	ArkInventory.Frame_Main_Generate_RecalcAll()

end

function ArkInventory.OfflineCacheErase()

	-- /ai cache erase confirm

	-- hide the main windows
	ArkInventory.Frame_Main_Hide()

	-- hide the item frames already used
	for loc_id, loc in pairs( ArkInventory.Global.Location ) do
		for _, bag_id in pairs( loc.BAGS ) do
			for slot_id = 1, loc.slot_max[bag_id] or 0 do
				local framename = ArkInventory.ContainerItemNameGet( loc_id, bag_id, slot_id )
				local frame = getglobal( framename )
				if frame then
					frame:Hide()
				end	
			end
		end
	end
	
	-- clear the cache
	for k in pairs( ArkInventory.db.account.cache.who ) do
		ArkInventory.db.account.cache.who[k] = nil
	end
	
	ArkInventory:Print( "All cached data has been erased." )
	
	-- init
	ArkInventory.PlayerSet()
	ArkInventory.Category_Generate()
	ArkInventory.BagSetDirtyAll()
	ArkInventory.Frame_Main_Generate_InitAll()
	
end



function ArkInventory.Table.Sum( tbl, fcn )
	local r = 0
	for k, v in pairs( tbl ) do
		r = r + ( fcn( v ) or 0 )
	end
	return r
end

function ArkInventory.Table.Max( tbl, fcn )
	local r = nil
	for k, v in pairs( tbl ) do
		if not r then
			r = ( fcn( v ) or 0 )
		else
			if ( fcn( v ) or 0 ) > r then
				r = ( fcn( v ) or 0 )
			end
		end
	end
	return r
end

function ArkInventory.Table.Elements( tbl )
	local r = 0
	for _, _ in pairs( tbl ) do
		r = r + 1
	end
	return r
end

function ArkInventory.Table.Concat2( t, d )

	if type( t ) ~= "table" then
		return t
	end
	
	local n = { }
	
	for i in pairs( t ) do
	
		if t[i] ~= nil then
		
			local z = type( t[i] )
		
			if z == "boolean" then
				if t[i] == true then
					tinsert( n, i .. "=true" )
				else
					tinsert( n, i .. "=false" )
				end
			elseif z == "table" then
				tinsert( n, i .. "={ " .. ArkInventory.Table.Concat2( t[i], ", " ) .. " }" )
				--tinsert( n, i .. "={table}" )
			elseif z == "string" or z == "number" then
				tinsert( n, i .. "=" .. t[i] )
			else
				tinsert( n, i .. "={" .. z .. "}" )
			end
			
		else
			tinsert( n, i .. "=nil" )
		end
		
	end

	if d then
		return table.concat( n, d )
	else
		return table.concat( n )
	end
	
end

function ArkInventory.Table.Concat( t, d )

	if type( t ) ~= "table" then
		return t
	end
	
	local n = { }
	
	local mx = 0
	for k, v in pairs( t ) do
		if k > mx then mx = k end
	end
	
	if mx == 0 then return "nil" end
	
	for i = 1, mx do
	
		if t[i] ~= nil then
		
			z = type( t[i] )
	
			if z == "boolean" then
				if t[i] == true then
					tinsert( n, "true" )
				else
					tinsert( n, "false" )
				end
			elseif z == "table" then
				tinsert( n, "{ " .. ArkInventory.Table.Concat2( t[i], ", " ) .. " }" )
				--tinsert( n, "{table}" )
			elseif z == "string" or z == "number" then
				tinsert( n, t[i] )
			else
				tinsert( n, "** " .. z .. " **" )
			end
		else
			tinsert( n, "nil" )
		end
	end

	if d then
		return table.concat( n, d )
	else
		return table.concat( n )
	end
	
end

function ArkInventory.spairs( tbl, comparator )

	local sortedKeys = {}
	for k, v in pairs( tbl ) do
		tinsert( sortedKeys, k )
	end
	sort( sortedKeys, comparator )
	local i = 0
	local function _f( _s, _v )
		i = i + 1
		local k = sortedKeys[i]
		if ( k ) then
			return k, tbl[k]
		end
	end
	return _f, nil, nil

end

function ArkInventory.nilStringEmpty( arg )
	if arg == nil then arg = "" end
	return tostring( arg )
end

function ArkInventory.nilStringText( arg )
	if arg == nil then arg = "nil" end
	return tostring( arg )
end

function ArkInventory.round( n, dp )
	local m = 10 ^ ( dp or 0 )
	return math.floor( n * m + 0.5 ) / m
end

function ArkInventory.DebugTimeDiff( t )

	if not t or type( t ) ~= "number" then return -1 end
	
	return math.floor( ( GetTime() - t ) * 1000 + 0.5 )

end


function ArkInventory.PrintPlus( msg_in, debuginfo )

	-- msg = { date( "%X" ), " " }
	if debuginfo then
		msg = { string.sub( string.format( "%05.3f", GetTime() ), -6 ), " " }
	else
		msg = { }
	end
	
	if msg_in == nil then
	
		tinsert( msg, "nil" )
	
	elseif type( msg_in ) == "table" then
	
		tinsert( msg, ArkInventory.Table.Concat( msg_in ) )
	
	else
	
		tinsert( msg, msg_in )
	
	end
	
	if debuginfo and debuginfo["m"] and debuginfo["t"] then
		tinsert( msg, " [" )
		tinsert( msg, gcinfo() - debuginfo.m )
		tinsert( msg, "Kb / " )
		tinsert( msg, ArkInventory.DebugTimeDiff( debuginfo.t ) )
		tinsert( msg, "ms]" )
	end
	
	ArkInventory:Print( table.concat( msg ) )
	
end
	
function ArkInventory.Debug( msgdata, debuginfo )
	if ArkInventory.Const.Debug and DEFAULT_CHAT_FRAME then
		ArkInventory.PrintPlus( msgdata, debuginfo )
	end
end




function ArkInventory.PT_ItemInSets( item, setnames )

	if not item or not setnames then return false end

	for setname in string.gmatch( setnames, "[^,]+" ) do
		
		r = ArkInventory.Lib.PeriodicTable:ItemInSet( item, strtrim( setname ) )
		if r then
			return true
		end
		
	end

	return false
	
end

function ArkInventory.ItemGetTexture( h )
	if h then
		t = select( 10, GetItemInfo( h ) )
		return t
	end
end

function ArkInventory.ItemGetID( h )
	id, enchant, suffix = strmatch( ( h or "" ) , "item:(%-?%d+):(%-?%d+):%-?%d+:%-?%d+:%-?%d+:%-?%d+:(%-?%d+):%-?%d+" )
	return ( id or 0 ) .. ":" .. ( enchant or 0 ) .. ":" .. ( suffix or 0 )
end

function ArkInventory.ItemGetName( h )
	if h then
		t = GetItemInfo( h )
		return t
	end
end

function ArkInventory.ItemGetCacheID( i )

	soulbound = 0
	if i.sb then soulbound = 1 end
	
	return ArkInventory.ItemGetID( i.h ) .. ":" .. soulbound
	
end

function ArkInventory.PlayerSet( w )
	
	if not w then
		w = { }
	end
	
	w["realm"] = GetRealmName()
	w["name"] = UnitName( "player" )
	
	-- system version, localised version
	_, w["faction"] = UnitFactionGroup( "player" )
	
	-- localised version, system version
	_, w["class"] = UnitClass( "player" )
	
	w["id"] = w.name .. " - " .. w.realm
	w["fullname"] = w.realm .. " > " .. w.faction .. " > " .. w.name

	local p = ArkInventory.db.account.cache.who[w.id]
	p.id = w.id
	p.realm = w.realm
	p.name = w.name
	p.class = w.class
	p.faction = w.faction
	p.fullname = w.fullname
	
end

local Restack = { }

function Restack.FindPartial( loc_id, cb, cs, id )

	for _, bag_id in pairs( ArkInventory.Global.Location[loc_id].BAGS ) do
	
		for slot_id = 1, GetContainerNumSlots( bag_id ) do

			if not ( bag_id == cb and slot_id == cs ) then
				
				iLink = GetContainerItemLink( bag_id, slot_id )
				if iLink then

					_, iCount = GetContainerItemInfo( bag_id, slot_id )
					iStack = select( 8, GetItemInfo( iLink ) )
					iID = strmatch( iLink, "item:(%-?%d+)" )
	
					if iID == id and iCount < iStack then
						--ArkInventory.Debug( "found match for partial stack at " .. bag_id .. "." .. slot_id )
						return true, bag_id, slot_id
					end
					
				end
				
			end
			
		end
		
	end

	-- ArkInventory.Debug( "no other partial stacks found" )
	return false

end

function Restack.FindSpecial( loc_id, ct )

	for _, bag_id in pairs( ArkInventory.Global.Location[loc_id].BAGS ) do
	
		local bt = ArkInventory.BagType( bag_id )
		
		-- only match items in normal or unknown bags to move them to profession bags
		if bt == ArkInventory.Const.Slot.Type.Bag or bt == ArkInventory.Const.Slot.Type.Unknown then
		
			for slot_id = 1, GetContainerNumSlots( bag_id ) do

				iLink = GetContainerItemLink( bag_id, slot_id )
				if iLink and ArkInventory.Const.Slot.Data[ct].pt then

					if ArkInventory.PT_ItemInSets( iLink, ArkInventory.Const.Slot.Data[ct].pt ) then
						--ArkInventory.Debug( "found match for special slot at " .. bag_id .. "." .. slot_id )
						return true, bag_id, slot_id
					end
					
				end
				
			end
			
		end
		
	end

	-- ArkInventory.Debug( "no items found for special slot" )
	return false

end

function Restack.Run( loc_id )

	-- DO NOT USE CACHED DATA FOR RESTACKING, PULL THE DATA DIRECTLY FROM WOW AGAIN

	-- ArkInventory.Debug( "ARKINV_Local_ContainerRestack( " .. loc_id .. " )" )

	ArkInventory:Print( ArkInventory.Localise["MOD_MENU_MAIN_COMPRESS"] .. ": " .. ArkInventory.Localise["STATUS_START"] )
	
	changed = true
	
	-- compress stacks
	while changed == true do
		
		changed = false
			
		for _, bag_id in pairs( ArkInventory.Global.Location[loc_id].BAGS ) do
	
			for slot_id = 1, GetContainerNumSlots( bag_id ) do

				--ArkInventory.Debug( "checking bag " .. bag_id .. ", slot " .. slot_id )

				while true do

					_, iCount, locked = GetContainerItemInfo( bag_id, slot_id )
					
					if locked then
						--ArkInventory.Debug( "yielding - primary is locked" )
						coroutine.yield()
						--ArkInventory.Debug( "resumed" )
					else
						break
					end
			
				end

				iLink = GetContainerItemLink( bag_id, slot_id )

				if iLink then
					iStack = select( 8, GetItemInfo( iLink ) )
					iID = strmatch( iLink, "item:(%-?%d+)" )
	
					if iCount < iStack then
				
						--ArkInventory.Debug( "partial stack of item " .. iLink .. " found at " .. bag_id .. "." .. slot_id )
						local locked, ok, sb, ss
						
						while true do
					
							ok, sb, ss = Restack.FindPartial( loc_id, bag_id, slot_id, iID )
							
							if ok then
								_, _, locked = GetContainerItemInfo( sb, ss )
							else
								locked = false
							end
						
							if locked then
								--ArkInventory.Debug( "yielding - secondary is locked" )
								coroutine.yield()
								--ArkInventory.Debug( "resumed" )
							else
								break
							end
							
						end
					
						if ok then
						
							--ArkInventory.Debug( "merging with other partial stack of item " .. iID .. " found at " .. sb .. "." .. ss )
							
							ClearCursor()
							PickupContainerItem( bag_id, slot_id )
							PickupContainerItem( sb, ss )
							ClearCursor()
							
							changed = true
						
						end
						
					end
				
				end
					
			end
				
		end
			
	end

	--ArkInventory.Debug( "Restack " .. ArkInventory.Global.Location[loc_id].NAME .. " - compress completed" )

	
	--ArkInventory.Debug( "Restack " .. ArkInventory.Global.Location[loc_id].NAME .. " - restack started" )
	
	-- move items into appropriate bag types with empty slots
	for _, bag_id in pairs( ArkInventory.Global.Location[loc_id].BAGS ) do
	
		local bt = ArkInventory.BagType( bag_id )
		-- ArkInventory.Debug( "bag " .. bag_id .. " = " .. ArkInventory.Const.Slot.Data[bt].name )
			
		if not ( bt == ArkInventory.Const.Slot.Type.Unknown or bt == ArkInventory.Const.Slot.Type.Bag or bt == ArkInventory.Const.Slot.Type.Key ) then
	
			for slot_id = 1, GetContainerNumSlots( bag_id ) do

				-- ArkInventory.Debug( "checking bag " .. bag_id .. " (" .. ArkInventory.Const.Slot.Data[bt].name .. "), slot " .. slot_id )

				while true do

					_, _, locked = GetContainerItemInfo( bag_id, slot_id )
					
					if locked then
						-- ArkInventory.Debug( "yielding - primary is locked" )
						coroutine.yield()
						-- ArkInventory.Debug( "resumed" )
					else
						break
					end
		
				end

				if not GetContainerItemLink( bag_id, slot_id ) then
					
					local locked, ok, sb, ss
					-- ArkInventory.Debug( "empty special slot found at " .. bag_id .. "." .. slot_id )
				
					while true do
				
						ok, sb, ss = Restack.FindSpecial( loc_id, bt )
							
						if ok then
							_, _, locked = GetContainerItemInfo( sb, ss )
						else
							locked = false
						end
						
						if locked then
							-- ArkInventory.Debug( "yielding - secondary is locked" )
							coroutine.yield()
							-- ArkInventory.Debug( "resumed" )
						else
							break
						end
						
					end
					
					if ok then
						
						-- ArkInventory.Debug( "moving " .. iLink .. " from " .. sb .. "." .. ss .. " to special slot " .. bag_id .. "." .. slot_id )
						
						ClearCursor()
						PickupContainerItem( sb, ss )
						PickupContainerItem( bag_id, slot_id )
						ClearCursor()

					end
					
				end
			
			end
				
		end
			
	end

	ArkInventory:Print( ArkInventory.Localise["MOD_MENU_MAIN_COMPRESS"] .. ": " .. ArkInventory.Localise["STATUS_FINISH"] )

end

function Restack.Resume()

	-- ArkInventory.Debug( "ARKINV_Local_ContainerRestackResume()" )
	
	if type( Restack.Thread ) == "thread" and coroutine.status( Restack.Thread ) == "suspended" then

		-- resume current thread
		coroutine.resume( Restack.Thread )
		
	end
	
end

function Restack.Start( loc_id )

	if ArkInventory.Global.Location[loc_id].offline then

		message( "Cannot restack " .. ArkInventory.Global.Location[loc_id].NAME .. " in offline mode" )
		
	else
	
		if type( Restack.Thread ) ~= "thread" or coroutine.status( Restack.Thread ) == "dead" then
	
			-- thread not active, create a new one
			-- ArkInventory.Debug( "Restack " .. ArkInventory.Global.Location[loc_id].NAME .. " started" )
			Restack.Thread = coroutine.create(
				function ()
					Restack.Run( loc_id )
				end
			)
			coroutine.resume( Restack.Thread )
			
		else
	
			-- restack already in progress
			ArkInventory:Print( RED_FONT_COLOR_CODE .. "Restack " .. ArkInventory.Global.Location[loc_id].NAME .. " is already in progress please wait for completion" )
		
		end
		
	end

end

function ArkInventory.ContainerRestackStart( loc_id )
	Restack.Start( loc_id )
end

function ArkInventory.OnInitialize()
	-- Called when the addon is loaded

	ArkInventory.PlayerSet( ArkInventory.Global.Me )
	
	-- setup bag id's for player
	tinsert( ArkInventory.Global.Location[ArkInventory.Const.Location.Bag].BAGS, BACKPACK_CONTAINER )
	for x = 1, NUM_BAG_SLOTS do
		tinsert( ArkInventory.Global.Location[ArkInventory.Const.Location.Bag].BAGS, x )
	end

	-- setup bag id's for bank
	tinsert( ArkInventory.Global.Location[ArkInventory.Const.Location.Bank].BAGS, BANK_CONTAINER )
	for x = NUM_BAG_SLOTS + 1, NUM_BAG_SLOTS + NUM_BANKBAGSLOTS do
		tinsert( ArkInventory.Global.Location[ArkInventory.Const.Location.Bank].BAGS, x )
	end

	-- setup bag id's for keyring
	tinsert( ArkInventory.Global.Location[ArkInventory.Const.Location.Key].BAGS, KEYRING_CONTAINER )
	
	ArkInventory.Global.ScanTooltip = ARKCORE_Class_ScanTooltip:new( "ARKINV_ScanTooltip" )
	
end

function ArkInventory:OnEnable()
	-- Called when the addon is enabled

	self.ConvertOldOptions()
	self.Category_Generate()
	self.OfflineCacheCleanup()
	
	-- tag all bags as needed to be scanned
	self.BagSetDirtyAll()
	self.BagScanAll()

	-- register events
	self:RegisterBucketEvent( "EVENT_ARKINV_BAG_UPDATE_BUCKET", 0.08 )
	
	self:RegisterEvent( "BAG_UPDATE", "EVENT_ARKINV_BAG_UPDATE" )
	self:RegisterEvent( "PLAYERBANKSLOTS_CHANGED", "EVENT_WOW_PLAYERBANKSLOTS_CHANGED" ) -- a bag_update event for the bank (-1)

	self:RegisterEvent( "PLAYERBANKBAGSLOTS_CHANGED", "EVENT_WOW_PLAYERBANKBAGSLOTS_CHANGED" ) -- triggered when you purchase a new bank bag slot
	
	self:RegisterEvent( "PLAYER_REGEN_DISABLED", "EVENT_WOW_PLAYER_REGEN_DISABLED" ) -- player about to enter combat
	self:RegisterEvent( "PLAYER_REGEN_ENABLED", "EVENT_WOW_PLAYER_REGEN_ENABLED" ) -- player left combat

	self:RegisterEvent( "BANKFRAME_OPENED", "EVENT_WOW_BANKFRAME_OPENED" )
	self:RegisterEvent( "BANKFRAME_CLOSED", "EVENT_WOW_BANKFRAME_CLOSED" )
	
	self:RegisterEvent( "MAIL_SHOW", "EVENT_WOW_MAIL_SHOW" )
	self:RegisterEvent( "MAIL_CLOSED", "EVENT_WOW_MAIL_CLOSED" )

	self:RegisterEvent( "TRADE_SHOW", "EVENT_WOW_TRADE_SHOW" )
	self:RegisterEvent( "TRADE_CLOSED", "EVENT_WOW_TRADE_CLOSED" )

	self:RegisterEvent( "AUCTION_HOUSE_SHOW", "EVENT_WOW_AUCTION_HOUSE_SHOW" )
	self:RegisterEvent( "AUCTION_HOUSE_CLOSED", "EVENT_WOW_AUCTION_HOUSE_CLOSED" )

	self:RegisterEvent( "MERCHANT_SHOW", "EVENT_WOW_MERCHANT_SHOW" )
	self:RegisterEvent( "MERCHANT_CLOSED", "EVENT_WOW_MERCHANT_CLOSED" )
	
	self:RegisterEvent( "SKILL_LINES_CHANGED", "EVENT_WOW_SKILL_LINES_CHANGED" ) -- triggered when you gain or lose a skill
	
	self:RegisterEvent( "PLAYER_LEAVING_WORLD", "EVENT_WOW_PLAYER_LEAVING_WORLD" ) --when the player logs out or the UI is reloaded.

	self.HookBlizzardAPI()
	
	self:Print( string.format( "v%.2f Enabled.  Type /ARKINV or /AI for help.", ArkInventory.Const.Program.Version ) )
	
end

function ArkInventory.OnDisable()
	-- Called when the addon is disabled

	--ArkInventory:UnhookAll()
	
	ArkInventory.Frame_Main_Hide()
	
	ArkInventory.OfflineCacheCleanup()
	
	--ArkInventory.Debug( "Disabled" )
	
end

function ArkInventory.OnProfileEnable()
    -- this is called every time your profile changes (after the change)
	ArkInventory.ConvertOldOptions()
	ArkInventory.ItemCacheClear()
	ArkInventory.PlayerSet()
	ArkInventory.Frame_Main_Generate_InitAll()
end

function ArkInventory.OnProfileDisable()
    -- this is called every time your profile changes (before the change)
	ArkInventory.Lib.DewDrop:Close()
	ArkInventory.Frame_Main_Hide()
	ArkInventory.Frame_Rules_Hide()
end

function ArkInventory:EVENT_ARKINV_BAG_UPDATE_BUCKET( tid )

	--local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }

	--tid is a table in the format containerid = true so we need to look through to pull out the container id's

	local id = { }
	for k in pairs( tid ) do
		tinsert( id, k )
	end
	
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "EVENT_ARKINV_BAG_UPDATE_BUCKET( ", id, " )" } )
	
	ArkInventory.BagSetDirty( id )
	ArkInventory.Frame_Main_Generate_RefreshAll()
	
	ArkInventory.Frame_Changer_Player_Update()
	ArkInventory.Frame_Changer_Bank_Update()

	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "EVENT_ARKINV_BAG_UPDATE_BUCKET() " }, debuginfo )
	
end

function ArkInventory:EVENT_ARKINV_BAG_UPDATE( id )
	--ArkInventory.PrintPlus( { RED_FONT_COLOR_CODE, "EVENT_ARKINV_BAG_UPDATE( ", id, " )" } )
	Restack.Resume()
	ArkInventory:TriggerEvent( "EVENT_ARKINV_BAG_UPDATE_BUCKET", id )
end

function ArkInventory.EVENT_WOW_PLAYERBANKSLOTS_CHANGED()
	--ArkInventory.PrintPlus( { RED_FONT_COLOR_CODE, "PLAYERBANKSLOTS_CHANGED" } )
	ArkInventory:EVENT_ARKINV_BAG_UPDATE( BANK_CONTAINER )
	
end

function ArkInventory.EVENT_WOW_PLAYERBANKBAGSLOTS_CHANGED()
	-- ArkInventory.PrintPlus( { RED_FONT_COLOR_CODE, "PLAYERBANKBAGSLOTS_CHANGED" } )
	-- player just purchased another bank bag slot
	
	ArkInventory.Frame_Changer_Bank_Update()
	
end

function ArkInventory.EVENT_WOW_PLAYER_REGEN_DISABLED()
	-- entered combat
	
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "PLAYER_REGEN_DISABLED()" } )
	
	ArkInventory.Global.Mode.Combat = true
	
	if ArkInventory.db.account.option.auto.close.combat then
		ArkInventory.Frame_Main_Hide()
	end
	
end

function ArkInventory.EVENT_WOW_PLAYER_REGEN_ENABLED()
	-- left combat
	
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "PLAYER_REGEN_ENABLED()" } )
	
	ArkInventory.Global.Mode.Combat = false
	--ArkInventory.Frame_Main_Generate_All()
	
end

function ArkInventory.EVENT_WOW_BANKFRAME_OPENED()

	--ArkInventory.PrintPlus( { RED_FONT_COLOR_CODE, "BANKFRAME_OPENED()" } )
	
	ArkInventory.Global.Mode.Bank = true
	
	--ArkInventory.BagSetDirtyAll()

	if ArkInventory.db.account.option.framehide.blizzard then
	
		if ArkInventory.db.account.option.auto.open.bank then
			ArkInventory.Frame_Main_Show( ArkInventory.Const.Location.Bag )
			ArkInventory.Frame_Main_Show( ArkInventory.Const.Location.Bank )
		else
			-- regenerate the view in case they were looking at the bank "offline", make it "online"
			ArkInventory.Frame_Main_Show( ArkInventory.Const.Location.Bank )
		end

		ArkInventory.Frame_Main_Generate_Refresh( ArkInventory.Const.Location.Bank )
	
	end
	
end

function ArkInventory.EVENT_WOW_BANKFRAME_CLOSED()

	--ArkInventory.PrintPlus( { RED_FONT_COLOR_CODE, "BANKFRAME_CLOSED()" } )
	
	ArkInventory.Global.Mode.Bank = false

	if ArkInventory.db.account.option.auto.close.bank then
		-- close windows on leaving the bank
		ArkInventory.Frame_Main_Hide()
	else
		-- refresh the bank window so it shows offline
		ArkInventory.Frame_Main_Generate_Refresh( ArkInventory.Const.Location.Bank )
	end
	
end

function ArkInventory.EVENT_WOW_MAIL_SHOW()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "MAIL_SHOW" } )
	if ArkInventory.db.account.option.auto.open.mail and ArkInventory.db.account.option.framehide.blizzard then
		ArkInventory.Frame_Main_Show( ArkInventory.Const.Location.Bag )
	end
end

function ArkInventory.EVENT_WOW_MAIL_CLOSED()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "MAIL_CLOSED" } )
	if ArkInventory.db.account.option.auto.close.mail then
		ArkInventory.Frame_Main_Hide( ArkInventory.Const.Location.Bag )
	end
end

function ArkInventory.EVENT_WOW_TRADE_SHOW()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "TRADE_SHOW" } )
	if ArkInventory.db.account.option.auto.open.trade and ArkInventory.db.account.option.framehide.blizzard then
		ArkInventory.Frame_Main_Show( ArkInventory.Const.Location.Bag )
	end
end

function ArkInventory.EVENT_WOW_TRADE_CLOSED()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "TRADE_CLOSED" } )
	if ArkInventory.db.account.option.auto.close.trade then
		ArkInventory.Frame_Main_Hide( ArkInventory.Const.Location.Bag )
	end
end

function ArkInventory.EVENT_WOW_AUCTION_HOUSE_SHOW()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "AUCTION_HOUSE_SHOW" } )
	if ArkInventory.db.account.option.auto.open.auction and ArkInventory.db.account.option.framehide.blizzard then
		ArkInventory.Frame_Main_Show( ArkInventory.Const.Location.Bag )
	end
end

function ArkInventory.EVENT_WOW_AUCTION_HOUSE_CLOSED()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "AUCTION_HOUSE_CLOSED" } )
	if ArkInventory.db.account.option.auto.close.auction then
		ArkInventory.Frame_Main_Hide( ArkInventory.Const.Location.Bag )
	end
end

function ArkInventory.EVENT_WOW_MERCHANT_SHOW()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "MERCHANT_SHOW" } )
	if ArkInventory.db.account.option.auto.open.merchant and ArkInventory.db.account.option.framehide.blizzard then
		ArkInventory.Frame_Main_Show( ArkInventory.Const.Location.Bag )
	end
end

function ArkInventory.EVENT_WOW_MERCHANT_CLOSED()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "MERCHANT_CLOSED" } )
	if ArkInventory.db.account.option.auto.close.merchant then
		ArkInventory.Frame_Main_Hide( ArkInventory.Const.Location.Bag )
	end
end

function ArkInventory.EVENT_WOW_SKILL_LINES_CHANGED()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "SKILL_LINES_CHANGED" } )
	
	ArkInventory.Global.Cache.Default = { }
	ArkInventory.SkillGet()
	ArkInventory.BagSetDirtyAll()
	
end

function ArkInventory.EVENT_WOW_PLAYER_LEAVING_WORLD()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "PLAYER_LEAVING_WORLD" } )
	ArkInventory.OnDisable()
end



function ArkInventory.Frame_Container_Toggle( loc_id )

	local frame = ArkInventory.Frame_Main_Get( loc_id )

	if frame then
		if frame:IsVisible() then
			ArkInventory.Frame_Main_Hide( loc_id )
		else
			ArkInventory.Frame_Main_Show( loc_id )
		end
	end
	
end

function ArkInventory.ItemSortKeyRegenerate()

	-- rebuild sort key for all items
	for loc_id, loc in pairs( ArkInventory.db.account.cache.who[ArkInventory.Global.Me.id].loc ) do
		for bag_id, bag in pairs( loc.bag ) do	
			for slot_id, slot in pairs( bag.slot ) do
				ArkInventory.ItemSortKeyGenerate( loc_id, slot )
			end
		end
	end

end

function ArkInventory.ItemSortKeyGenerate( loc_id, i )

	if not i then
		return ""
	end
	
	
	local s = { }
	s["!bagslot"] = format( "%04i %04i", i.bag_id, i.slot_id )
	

	if not ArkInventory.OptionLocalGet( loc_id, { "sort", "bagslot" } ) then
	
		local t
	
	
		-- slot type (system)
		t = 0
		if not i.h then
			t = ArkInventory.BagType( i.bag_id )
		end
		s["!slottype"] = format( "%04i", t )
		
		
		-- item count (system)
		s["!count"] = format( "%04i", i.count )

	
		-- item name
		t = "!"
		if ArkInventory.OptionLocalGet( loc_id, { "sort", "name" } ) then
			if ArkInventory.OptionLocalGet( loc_id, { "sort", "reversed" } ) then
				t = ArkInventory.ReverseName( ArkInventory.ItemGetName( i.h ) or "!" )
			else
				t = ArkInventory.ItemGetName( i.h ) or "!"
			end
		end
		s["name"] = t


		-- item quality
		t = 0
		if i.q and ArkInventory.OptionLocalGet( loc_id, { "sort", "quality" } ) then
			t = i.q
		end
		s["quality"] = format( "%02i", t )
		

		-- location
		t = "!"
		if i.h and ArkInventory.OptionLocalGet( loc_id, { "sort", "location" } ) then
		
			t = select( 9, GetItemInfo( i.h ) )
				
			if not t or t == "" then
				t = "!"
			else
				t = getglobal( t )
			end

		end
		s["location"] = t

		
		-- item type / subtype
		local item_type = "!"
		local item_subtype = "!"
		
		if i.h and ArkInventory.OptionLocalGet( loc_id, { "sort", "itemtype" } ) then
		
			item_type, item_subtype = select( 6, GetItemInfo( i.h ) )
				
			if not item_type or item_type == "" then
				item_type = "!"
			end
			
			if not item_subtype or item_subtype == "" then
				item_subtype = "!"
			end

		end
		s["itemtype"] = string.format( "%s %s", item_type, item_subtype )

		
		-- item level
		t = 0
		if i.h and ArkInventory.OptionLocalGet( loc_id, { "sort", "itemuselevel" } ) then
			t = select( 5, GetItemInfo( i.h ) )
		end
		s["itemuselevel"] = format( "%04i", t )

		
		-- category
		local c_type = 0
		local c_index = 0
		local c_order = 0
		
		if i.h and ArkInventory.OptionLocalGet( loc_id, { "sort", "category" } ) then
			
			if i.cat > 0 then
				c_type = 1
				c_index = i.cat
				c_order = ArkInventory.db.account.option.rule[i.cat].order
			else
				c_index = abs( i.cat )
			end
			
		end
		s["category"] = format( "%02i %06i %06i", c_type, c_order, c_index )
		
		
		
	end

	
	-- build sort key
	local sx = { }
	if ArkInventory.OptionLocalGet( loc_id, { "sort", "bagslot" } ) then
	
		tinsert( sx, s["!bagslot"] )
		
	else

		for k, v in ipairs( ArkInventory.OptionLocalGet( loc_id, { "sortorder" } ) ) do
			if s[v] then
				tinsert( sx, s[v] )
			end
		end
	
		tinsert( sx, s["!slottype"] )
		tinsert( sx, s["!count"] )
		tinsert( sx, s["!bagslot"] )

	end
	
	i["sort"] = table.concat( sx, " " )

end

function ArkInventory.ItemSortKeyMoveDown( loc_id, s )

	local p = false
	local t = ArkInventory.OptionLocalGet( loc_id, { "sortorder" } )
	
	for k, v in ipairs( t ) do
		if s == v then
			p = k
			break
		end
	end

	if not p then
		return
	end
	
	if not t[p+1] then
		-- already at the bottom
		return
	end
	
	local x, y = t[p+1], t[p]
	t[p], t[p+1] = x, y
	
end

function ArkInventory.ItemSortKeyMoveUp( loc_id, s )

	local p = false
	local t = ArkInventory.OptionLocalGet( loc_id, { "sortorder" } )
	
	for k, v in ipairs( t ) do
		if s == v then
			p = k
			break
		end
	end

	if not p or p == 1 then
		return
	end
	
	local x, y = t[p-1], t[p]
	t[p], t[p-1] = x, y
	
end

function ArkInventory.ItemSortKeyCheck()

	for loc_id in pairs( ArkInventory.Global.Location ) do
	
		local t = ArkInventory.OptionLocalGet( loc_id, { "sortorder" } )
		
		assert( t ~= nil, "sortorder is not a table" ) --~~~~ check

		-- add mising keys
		for s in pairs( ArkInventory.Const.SortKeys ) do
			
			local ok = false
			
			for k, v in ipairs( t ) do
			
				if s == v then
					ok = true
					break
				end
			
			end
			
			if not ok then
				tinsert( t, s )
			end
			
		end
	
		
		-- remove old keys
		for k, v in ipairs( t ) do
			if not ArkInventory.Const.SortKeys[v] then
				tremove( t, k )
			end
		end
		
	end
	
end

function ArkInventory.NewItemReset( loc_id )

	-- reset new item text
	for bag_id, bag in pairs( ArkInventory.db.account.cache.who[ArkInventory.Global.Me.id].loc[loc_id].bag ) do	
		for slot_id, slot in pairs( bag.slot ) do
			slot.new = ArkInventory.Const.Slot.New.None --~~~~ check this still works
		end
	end

end



function ArkInventory.BagGetLocation( id )

	assert( id ~= nil, "invalid bag id: nil" )
	
	for loc_id, loc_data in pairs( ArkInventory.Global.Location ) do
		for _, bag_id in pairs( loc_data.BAGS ) do
			if id == bag_id then
				return loc_id
			end
		end
	end

end

function ArkInventory.BagType( id )

	if id == KEYRING_CONTAINER then
		return ArkInventory.Const.Slot.Type.Key
	elseif id == BANK_CONTAINER or id == 0 then
		return ArkInventory.Const.Slot.Type.Bag
	end

	local h = GetInventoryItemLink( "player", ContainerIDToInventoryID( id ) )
	
	if h then
	
		local t, s = select( 6, GetItemInfo( h ) )

		if t == ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER"] then
		
			if s == ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_BAG"] then
				return ArkInventory.Const.Slot.Type.Bag
			elseif s == ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_SOULSHARD"] then
				return ArkInventory.Const.Slot.Type.Soulshard
			elseif s == ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_HERB"] then
				return ArkInventory.Const.Slot.Type.Herb
			elseif s == ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_ENCHANTING"] then
				return ArkInventory.Const.Slot.Type.Enchanting
			elseif s == ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_ENGINEERING"] then
				return ArkInventory.Const.Slot.Type.Engineering
			elseif s == ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_GEM"] then
				return ArkInventory.Const.Slot.Type.Gem
			elseif s == ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_MINING"] then
				return ArkInventory.Const.Slot.Type.Mining
			end
			
		elseif t == ArkInventory.Localise["WOW_ITEM_TYPE_QUIVER"] then
		
			if s == ArkInventory.Localise["WOW_ITEM_TYPE_QUIVER_ARROW"] then
				return ArkInventory.Const.Slot.Type.Arrow
			elseif s == ArkInventory.Localise["WOW_ITEM_TYPE_QUIVER_BULLET"] then
				return ArkInventory.Const.Slot.Type.Bullet
			end
			
		end
	
		--ArkInventory.Debug( "debug unknown bag type: bag_id=" .. id .. ", type=" .. t .. " (" .. ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER"] .. ") , subtype=" .. s .. " (" .. ArkInventory.Localise["WOW_ITEM_TYPE_CONTAINER_BAG"] .. ")" )
		return ArkInventory.Const.Slot.Type.Unknown
	
	else

		-- empty bag slots
		return ArkInventory.Const.Slot.Type.Bag
	
	end
	
end

function ArkInventory.BagSetDirtyAll()

	for _, loc in pairs( ArkInventory.Global.Location ) do
		ArkInventory.BagSetDirty( loc.BAGS )
	end

end

function ArkInventory.BagSetDirty( bag_id_table )

	--ArkInventory.Debug( { GREEN_FONT_COLOR_CODE, "BagSetDirty() start" } )

	local loc_id
	
	for _, bag_id in pairs( bag_id_table ) do
	
		--ArkInventory.PrintPlus( { "flagging bag ", bag_id, " for rescan" } )
	
		loc_id = ArkInventory.BagGetLocation( bag_id )
	
		ArkInventory.Global.Location[loc_id].rescan[bag_id] = true
		
	end

	--ArkInventory.Debug( { GREEN_FONT_COLOR_CODE, "BagSetDirty() end" } )
	
end

function ArkInventory.BagScanAll()

	--ArkInventory.Debug( { GREEN_FONT_COLOR_CODE, "BagScanAll() start" } )
	
	for _, loc in pairs( ArkInventory.Global.Location ) do
		for _, bag_id in pairs( loc.BAGS ) do
			ArkInventory.BagScan( bag_id )
		end
	end
	
	--ArkInventory.Debug( { GREEN_FONT_COLOR_CODE, "BagScanAll() end" } )
	
end

function ArkInventory.BagScan( bag_id )

	--ArkInventory.Debug( { GREEN_FONT_COLOR_CODE, "BagScan( ", bag_id, " ) start" } )

	if bag_id == nil then
		return
	end

	local loc_id = ArkInventory.BagGetLocation( bag_id )
	assert( loc_id, "bag [" .. bag_id .. "] is not assigned to any location" )
	
	-- check rescan tag
	if not ArkInventory.Global.Location[loc_id].rescan[bag_id] then
		--ArkInventory.Debug( { "aborted scan of bag ", bag_id, ", no recorded change" } )
		return
	end

	if loc_id == ArkInventory.Const.Location.Bank and ArkInventory.Global.Mode.Bank == false then
		--ArkInventory.PrintPlus( { "aborted scan of bag ", bag_id, ", not at bank" } )
		return
	end

	
	local bag = { }
	bag["count"] = GetContainerNumSlots( bag_id )
	bag["empty"] = 0
	bag["type"] = ArkInventory.BagType( bag_id )
	bag["slot"] = { }
	
	if bag_id ~= BANK_CONTAINER and bag_id ~= BACKPACK_CONTAINER and bag_id ~= KEYRING_CONTAINER then
		bag["h"] = GetInventoryItemLink( "player", ContainerIDToInventoryID( bag_id ) )
	end

	if ArkInventory.Global.Mode.Bank and loc_id == ArkInventory.Const.Location.Bank and bag_id ~= BANK_CONTAINER then
		numSlots = GetNumBankSlots()
		if bag_id - NUM_BAG_SLOTS <= numSlots  then
			bag["purchase"] = nil
		else
			bag["purchase"] = true
		end
	end
	
	local i, old_bag, old_slot, item_id, item_suffix, item_enchant

	--ArkInventory.PrintPlus( { "bag ", bag_id, " has ", bag.count, " slots" } )

	old_bag = ArkInventory.db.account.cache.who[ArkInventory.Global.Me.id].loc[loc_id].bag[bag_id]

	if old_bag and bag.count < old_bag.count then
		--ArkInventory.PrintPlus( { "tainted, bag=", bag_id, ", removed/smaller bag" } )
		ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Recalculate )
	end

	for slot_id = 1, bag.count do
	
		i = { }
		
		i["bag_id"] = bag_id
		i["slot_id"] = slot_id
		i["h"] = GetContainerItemLink( bag_id, slot_id )
		
		if i.h then
			_, i["count"] = GetContainerItemInfo( bag_id, slot_id )
			_, _, i["q"] = GetItemInfo( i.h )

			-- check for soulbound
			ArkInventory.Global.ScanTooltip:SetItem( i )
			if ArkInventory.Global.ScanTooltip:Contains( "^" .. ITEM_SOULBOUND .. "$" ) then
				i["sb"] = true
			end

		else

			-- empty slot count
			bag.empty = bag.empty + 1

		end

		i["count"] = i["count"] or 0
		i["q"] = i["q"] or 0
		i["sb"] = i["sb"] or false
		
		i["id"] = ArkInventory.ItemGetID( i.h )
		
		i["cat"], i["catdef"] = ArkInventory.ItemCategoryGet( i, bag.type, bag_id, slot_id )
		
		if bag_id == 0 then
		--ArkInventory.PrintPlus( { "bag=[", bag_id, "], slot=[", slot_id, "], item=[", i.id, "], category=[", i.cat, "], default=[", i.catdef, "]" } )
		end
		
		ArkInventory.ItemSortKeyGenerate( loc_id, i )
		
		
		-- save the data
		bag.slot[slot_id] = i

		
		-- check for changes
		if not old_bag then
		
			--  bag added
			--ArkInventory.PrintPlus( { "tainted, bag=", bag_id, ", new bag" } )
			ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Recalculate )
			
		else
		
			old_slot = old_bag.slot[slot_id]
			
			if not old_slot then
				--  the old slot doesnt exist - bag increased in size?
				i["new"] = ArkInventory.Const.Slot.New.None
				--ArkInventory.Debug( { "tainted, bag=", bag_id, ", slot=", slot_id, ", new slot" } )
				ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Recalculate )
			elseif i.h and not old_slot.h then
				-- item added
				i["new"] = ArkInventory.Const.Slot.New.New
				--ArkInventory.Debug( { "tainted, bag=", bag_id, ", slot=", slot_id, ", item added" } )
				ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Refresh )
			elseif not i.h and old_slot.h then
				-- item removed
				i["new"] = ArkInventory.Const.Slot.New.None
				--ArkInventory.Debug( { "tainted, bag=", bag_id, ", slot=", slot_id, ", item removed" } )
				ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Refresh )
			elseif i.h and old_slot.h and i.h ~= old_slot.h then
				-- different item
				if i.id ~= old_slot.id then
					i["new"] = ArkInventory.Const.Slot.New.New
				end
				--ArkInventory.Debug( { "tainted, bag=", bag_id, ", slot=", slot_id, ", item changed" } )
				ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Refresh )
			elseif ( i.sb and not old_slot.sb ) or ( not i.sb and old_slot.sb ) then
				-- soulbound changed
				i["new"] = ArkInventory.Const.Slot.New.New
				--ArkInventory.Debug( { "tainted, bag=", bag_id, ", slot=", slot_id, ", soulbound changed" } )
				ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Refresh )
			elseif i.count ~= old_slot.count then
				-- item count changed, not tainted but needs to be refreshed
				if i.count > old_slot.count then
					--ArkInventory.PrintPlus( { "tainted, bag=", bag_id, ", slot=", slot_id, ", increased" } )
					i["new"] = ArkInventory.Const.Slot.New.Increased
				else
					--ArkInventory.PrintPlus( { "tainted, bag=", bag_id, ", slot=", slot_id, ", decreased" } )
					i["new"] = ArkInventory.Const.Slot.New.Decreased
				end
				
				ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Refresh )
			--elseif ( i.cat and not old_slot.cat ) or ( not i.cat and old_slot.cat ) or ( i.cat and old_slot.cat and i.cat ~= old_slot.cat ) then
				-- category changed
				--ArkInventory.Debug( { "tainted, bag=", bag_id, ", slot=", slot_id, ", category changed" } )
				--ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Recalculate )
			end
		
		end
		
		
	end

	ArkInventory.db.account.cache.who[ArkInventory.Global.Me.id].loc[loc_id].bag[bag_id] = bag
	
	-- reset rescan tag
	ArkInventory.Global.Location[loc_id].rescan[bag_id] = nil
	
	--ArkInventory.Debug( { GREEN_FONT_COLOR_CODE, "BagScan( ", bag_id, " ) end" } )
	
end




function ArkInventory.Category_Bar_Get( loc_id, category_id )
	
	if category_id == nil then
		category_id = ArkInventory.Const.Categories.Default
	end
	
	local bar = ArkInventory.OptionLocalGet( loc_id, { "category", category_id } )
		
	-- if it's the default category and the default is not on a bar then put it on bar 1
	if bar == nil and category_id == ArkInventory.Const.Categories.Default then
		bar = 1
	end
	
	return bar
	
end

function ArkInventory.Category_Location_Set( loc_id, category_id, barnum )

	assert( category_id ~= nil , "category is nil" )

	if category_id ~= ArkInventory.Const.Categories.Default or barnum ~= nil then
		ArkInventory.OptionLocalSet( loc_id, { "category", category_id }, barnum )
	end
	
end

function ArkInventory.Category_Location_Get( loc_id, category_id )
	-- maps category id's to the bars they are assigned to
	local cat = ArkInventory.Category_Bar_Get( loc_id, category_id )
	
	if not cat then
		-- if this category hasn't been assigned to a bar then return the bar that DEFAULT is using
		return ArkInventory.Category_Bar_Get( loc_id, ArkInventory.Const.Categories.Default ), true
	else
		return cat, false
	end
end

function ArkInventory.Category_Hidden_Check( loc_id, category_id )

	local bar = ArkInventory.Category_Bar_Get( loc_id, category_id )
	
	if bar ~= nil and bar < 0 then
		return true
	else
		return false
	end

end

function ArkInventory.Category_Hidden_Toggle( loc_id, category_id )
	ArkInventory.Category_Location_Set( loc_id, category_id, 0 - ArkInventory.Category_Location_Get( loc_id, category_id ) )
end

function ArkInventory.Category_Generate()

	categories = {
		["SYSTEM"] = ArkInventory.Const.Categories.System,
		["SKILL"] = ArkInventory.Const.Categories.Skill,
		["CLASS"] = ArkInventory.Const.Categories.Class,
		["EMPTY"] = ArkInventory.Const.Categories.Empty,
		["OTHER"] = ArkInventory.Const.Categories.Other,
		["RULE"] = ArkInventory.db.account.option.rule,
	}
	
	local name, order
	
	ArkInventory.Global.Category = { }

	for t, d in pairs( categories ) do
	
		for k, v in pairs( d ) do

			assert( not ArkInventory.Global.Category[k], "duplicate category id [" .. k .. "]" )
		
			if t == "RULE" then
				order = ( v.order or 99999 ) + ( k / 10000 )
				name = k .. ". " .. ( v.name or "<no name>" )
			else
				order = 0
				name = v
			end
			
			ArkInventory.Global.Category[k] = {
				["id"] = k,
				["name"] = name,
				["fullname"] = format( "%s > %s", ArkInventory.Localise["CATEGORY_" .. t], name ),
				["order"] = order,
				["type_code"] = t,
				["type"] = ArkInventory.Localise["CATEGORY_" .. t],
			}
				

			
		end
	end

end

function ArkInventory.Category_Bar_Insert( loc_id, barnum )

	for k, v in pairs( ArkInventory.OptionLocalGet( loc_id, { "category" } ) ) do
		if v >= barnum then
			ArkInventory.Category_Location_Set( loc_id, k, ArkInventory.Category_Location_Get( loc_id, k ) + 1 )
		end
	end

end

function ArkInventory.Category_Bar_Remove( loc_id, barnum )

	local def_loc = ArkInventory.Category_Location_Get( loc_id, ArkInventory.Const.Categories.Default ) -- bar the DEFAULT category is currently on
	
	for k, v in pairs( ArkInventory.OptionLocalGet( loc_id, { "category" } ) ) do
	
		if v > barnum then
			ArkInventory.Category_Location_Set( loc_id, k, ArkInventory.Category_Location_Get( loc_id, k ) - 1 )
		elseif v == barnum then
			
			if k == ArkInventory.Const.Categories.Default then
				-- if the DEFAULT category was on the bar then move it to bar 1
				ArkInventory.Category_Location_Set( loc_id, k, 1 )
			else
				-- erase the location, setting it back to the same as DEFAULT
				ArkInventory.Category_Location_Set( loc_id, k, nil )
			end
			
		end
		
	end

end

function ArkInventory.Category_Bar_Clear( loc_id, barnum )

	for k, v in pairs( ArkInventory.OptionLocalGet( loc_id, { "category" } ) ) do
		if v == barnum then
			if k ~= ArkInventory.Const.Categories.Default then
				-- erase the location, setting it back to the same as DEFAULT
				ArkInventory.Category_Location_Set( loc_id, k, nil )
			end
		end
	end

end

function ArkInventory.Category_Bar_HasEntries( loc_id, barnum, cat_type )

	for _, cat in ArkInventory.spairs( ArkInventory.Global.Category ) do

		local t = cat.type_code
		local cat_bar, def_bar = ArkInventory.Category_Location_Get( loc_id, cat.id )
		
		if abs( cat_bar ) == barnum and not def_bar then
			
			if t == "RULE" then
				if not ArkInventory.db.profile.option.rule[cat.id] then
					t = "DO_NOT_USE" -- don't display disabled rules
				end
			end
			
			if cat_type == t then
				return true
			end
		
		end
	
	end

end


function ArkInventory.ItemCategoryGetSystemID( cat_name )

	-- internal system category names only
	
	local cn = ArkInventory.Localise[cat_name]
	
	for _, v in pairs( ArkInventory.Global.Category ) do
		if v.id < 0 and cn == v.name then
			return v.id
		end
	end
	
	return ArkInventory.Const.Categories.Default -- default
	
end


function ArkInventory.ItemCategoryGetDefaultActual( i, bt, bag_id, slot_id )

	-- local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }

	local info_name, _, info_rarity, _, _, info_type, info_subtype, _, info_location = GetItemInfo( i.h )
	
	-- trash, it's always trash
	if info_rarity == 0 then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_TRASH" )
	end

	
	-- projectiles
	if info_location == "INVTYPE_AMMO" or info_type == ArkInventory.Localise["WOW_ITEM_TYPE_PROJECTILE"] then
	
		if info_subtype == ArkInventory.Localise["WOW_ITEM_TYPE_PROJECTILE_BULLET"] then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_PROJECTILE_BULLET" )
		elseif info_subtype == ArkInventory.Localise["WOW_ITEM_TYPE_PROJECTILE_ARROW"] then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_PROJECTILE_ARROW" )
		end

		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_PROJECTILE" )
		
	end
	
	-- bags / containers
	if info_location == "INVTYPE_BAG" or ArkInventory.PT_ItemInSets( i.h, "Bag" ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_CONTAINER" )
	end

	-- soulbound equipment (armour, weapons, trinkets, tabards, etc, etc)
	if i.sb and info_location ~= "" then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EQUIPMENT_SOULBOUND" )
	end

	-- soul shards
	if ArkInventory.PT_ItemInSets( i.h, "Container.ItemsInType.Soul Shard" ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SOULSHARD" )
	end

	-- mounts
	if ArkInventory.PT_ItemInSets( i.h, "Misc.Mount" ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_MOUNT" )
	end

	-- reputation hand-ins
	if ArkInventory.PT_ItemInSets( i.h, "Reputation.Turnin" ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_REPUTATION" )
	end

	-- quest items
	if info_type == ArkInventory.Localise["WOW_ITEM_TYPE_QUEST"] or ArkInventory.PT_ItemInSets( i.h, "QuestMats" ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_QUEST" )
	end

	-- keys
	if info_type == ArkInventory.Localise["WOW_ITEM_TYPE_KEY"] or ArkInventory.PT_ItemInSets( i.h, "Misc.Key" ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_KEY" )
	end
	
	-- food
	if ArkInventory.PT_ItemInSets( i.h, "Consumable.Food.Edible" ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_FOOD" )
	end

	-- drink
	if ArkInventory.PT_ItemInSets( i.h, "Consumable.Water" ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_DRINK" )
	end

	-- potions (health)
	if 
	ArkInventory.PT_ItemInSets( i.h, "Consumable.Potion.Recovery.Healing,Consumable.Warlock.Healthstone" ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_POTION_HEAL" )
	end
	
	-- potions (mana)
	if ArkInventory.PT_ItemInSets( i.h, "Consumable.Potion.Recovery.Mana,Consumable.Mage.Mana Stone" ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_POTION_MANA" )
	end
	
	-- potions (everything else)
	if ArkInventory.PT_ItemInSets( i.h, "Consumable.Potion" ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_POTION" )
	end

	-- skills - cycle through the users skills and allocate items to those profressions first
	for k in ArkInventory.spairs( ArkInventory.Global.Skills, function(a,b) return ArkInventory.Global.Skills[a] < ArkInventory.Global.Skills[b] end ) do
	
		if ArkInventory.PT_ItemInSets( i.h, ArkInventory.Localise["PT_SKILL_" .. k] ) then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SKILL_" .. k )
		end

	end

	-- skills - do the rest
	for w in string.gmatch( ArkInventory.Const.Skills, "[^,]+" ) do
		if ArkInventory.PT_ItemInSets( i.h, ArkInventory.Localise["PT_SKILL_" .. w] ) then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SKILL_" .. w )
		end
	end

	
	-- class items (this characters class first)
	if ArkInventory.PT_ItemInSets( i.h, ArkInventory.Localise["PT_CLASS_" .. ArkInventory.Global.Me.class] ) then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_CLASS_" .. ArkInventory.Global.Me.class )
	end

	-- class items
	for w in string.gmatch( ArkInventory.Const.Classes, "[^,]+" ) do
		if ArkInventory.PT_ItemInSets( i.h, ArkInventory.Localise["PT_CLASS_" .. w] ) then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_CLASS_" .. w )
		end
	end


	-- soulbound items that need to be categorised somewhere else other than soulbound
	if i.sb then
	
		-- pets (non combat)
		if ArkInventory.PT_ItemInSets( i.h, "Misc.Minipet" ) then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_PET_NONCOMBAT" )
		end

		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SOULBOUND" )
		
	end

	
	-- non soulbound weapons and armour
	if info_location and info_location ~= "" then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EQUIPMENT" )
	end


	-- recipes
	if info_type == ArkInventory.Localise["WOW_ITEM_TYPE_RECIPE"] then
		if 1 == 2 then
			-- ignore this for the moment
			for w in string.gmatch( ArkInventory.Const.Skills, "[^,]+" ) do
				if info_subtype == ArkInventory.Localise[w] then
					return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SKILL_" .. w )
				end
			end
		else
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_RECIPE" )
		end	
	end
	
	
	-- fallback when not in periodic table sets

	
	-- setup tooltip for scanning
	ArkInventory.Global.ScanTooltip:SetItem( i )
	
	-- skill requirement (but not armour or weapons) from tooltip
	local _, _, req = ArkInventory.Global.ScanTooltip:Find( ArkInventory.Localise["WOW_TOOLTIP_REQUIRES"], false, false, true )
	
	if req and not ( info_type == ArkInventory.Localise["WOW_ITEM_TYPE_ARMOR"] or info_type == ArkInventory.Localise["WOW_ITEM_TYPE_WEAPON"] ) then
	
		for w in string.gmatch( ArkInventory.Const.Skills, "[^,]+" ) do
		
			if strfind( req, ArkInventory.Localise["WOW_SKILL_" .. w] ) then
				return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SKILL_" .. w )
			end
		
		end

	end

	-- class via tooltip
	local _, _, req = ArkInventory.Global.ScanTooltip:Find( ArkInventory.Localise["WOW_TOOLTIP_CLASS"], false, false, true )
	
	if req then
		for w in string.gmatch( "DRUID,HUNTER,MAGE,PALADIN,PRIEST,ROGUE,SHAMAN,WARLOCK,WARRIOR", "[^,]+" ) do
			if strfind( req, ArkInventory.Localise["WOW_CLASS_" .. w] ) then
				return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_CLASS_" .. w )
			end
		end
	end
	
	if info_type == ArkInventory.Localise["WOW_ITEM_TYPE_CONSUMABLE"] then

		if ArkInventory.Global.ScanTooltip:Contains( ArkInventory.Localise["WOW_TOOLTIP_POTION_HEAL"] ) then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_POTION_HEAL" )
		end

		if ArkInventory.Global.ScanTooltip:Contains( ArkInventory.Localise["WOW_TOOLTIP_POTION_MANA"] ) then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_POTION_MANA" )
		end
		
		if ArkInventory.Global.ScanTooltip:Contains( ArkInventory.Localise["WOW_TOOLTIP_FOOD"] ) then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_FOOD" )
		end
		
		if ArkInventory.Global.ScanTooltip:Contains( ArkInventory.Localise["WOW_TOOLTIP_DRINK"] ) then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_DRINK" )
		end

		if strfind( info_name, ArkInventory.Localise["WOW_TOOLTIP_POTION"] ) or strfind( info_name, ArkInventory.Localise["WOW_TOOLTIP_ELIXIR"] ) then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_POTION" )
		end
		
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_CONSUMABLE" )
		
	end
	
	
	if info_type == ArkInventory.Localise["WOW_ITEM_TYPE_MISCELLANEOUS"] then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_MISCELLANEOUS" )
	end
	
	if info_type == ArkInventory.Localise["WOW_ITEM_TYPE_REAGENT"] then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_REAGENT" )
	end

	if info_type == ArkInventory.Localise["WOW_ITEM_TYPE_TRADE_GOODS"] then

		if info_subtype == ArkInventory.Localise["WOW_ITEM_TYPE_TRADE_GOODS_DEVICES"] then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_TRADE_GOODS_DEVICES" )
		elseif info_subtype == ArkInventory.Localise["WOW_ITEM_TYPE_TRADE_GOODS_EXPLOSIVES"] then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_TRADE_GOODS_EXPLOSIVES" )
		elseif info_subtype == ArkInventory.Localise["WOW_ITEM_TYPE_TRADE_GOODS_PARTS"] then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_TRADE_GOODS_PARTS" )
		end

		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_TRADE_GOODS" )
	
	end

	
	-- fallback for any item not categorised
	return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_DEFAULT" )
	
end

function ArkInventory.ItemCategoryGetDefaultEmpty( bt, bag_id )

	local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }

	local loc_id = ArkInventory.BagGetLocation( bag_id )
	local clump = ArkInventory.OptionLocalGet( loc_id, { "slot", "empty", "clump" } )
	
	if bt == ArkInventory.Const.Slot.Type.Bag then
		if clump then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY" )
		else
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY_BAG" )
		end
	end
	
	if bt == ArkInventory.Const.Slot.Type.Bullet then
		if clump then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_PROJECTILE_BULLET" )
		else
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY_PROJECTILE_BULLET" )
		end
	end
	
	if bt == ArkInventory.Const.Slot.Type.Arrow then
		if clump then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_PROJECTILE_ARROW" )
		else
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY_PROJECTILE_ARROW" )
		end
	end
	
	if bt == ArkInventory.Const.Slot.Type.Key then
		if clump then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_KEY" )
		else
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY_KEY" )
		end
	end
	
	if bt == ArkInventory.Const.Slot.Type.Soulshard then
		if clump then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SOULSHARD" )
		else
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY_SOULSHARD" )
		end
	end
	
	if bt == ArkInventory.Const.Slot.Type.Herb then
		if clump then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SKILL_HERBALISM" )
		else
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY_HERB" )
		end
	end
	
	if bt == ArkInventory.Const.Slot.Type.Enchanting then
		if clump then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SKILL_ENCHANTING" )
		else
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY_ENCHANTING" )
		end
	end
	
	if bt == ArkInventory.Const.Slot.Type.Engineering then
		if clump then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SKILL_ENGINEERING" )
		else
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY_ENGINEERING" )
		end
	end
	
	if bt == ArkInventory.Const.Slot.Type.Gem then
		if clump then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SKILL_JEWELCRAFTING" )
		else
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY_GEM" )
		end
	end
	
	if bt == ArkInventory.Const.Slot.Type.Mining then
		if clump then
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_SKILL_MINING" )
		else
			return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY_MINING" )
		end
	end
	
	if clump then
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY" )
	else
		return ArkInventory.ItemCategoryGetSystemID( "CATEGORY_EMPTY_UNKNOWN" )
	end

end

function ArkInventory.ItemCategoryGetDefault( i, bt, bag_id, slot_id )
	
	local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }
	
	if not i.h then
		return ArkInventory.ItemCategoryGetDefaultEmpty( bt, bag_id )
	end

	cid = ArkInventory.ItemGetCacheID( i )
	
	-- if the value has been cached then use it
	if not ArkInventory.Global.Cache.Default[cid] then
		ArkInventory.Global.Cache.Default[cid] = ArkInventory.ItemCategoryGetDefaultActual( i, bt, bag_id, slot_id )
	end
	
	return ArkInventory.Global.Cache.Default[cid]

end


function ArkInventory.ItemCategoryGetRule( i, bt, bag_id, slot_id )

	-- local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }

	-- ArkInventory.PrintPlus( "ItemCategoryGetRule() start" )
	
	-- check rules
	local r = ArkInventory.db.account.option.rule
	
	for rulenum in ArkInventory.spairs( r, function(a,b) return r[a].order < r[b].order end ) do
		
		local a, em = ArkInventory.RuleAppliesToItem( rulenum, i )

		if em == nil then
		
			if a == true then
				return rulenum
			end
		
		else
		
			ArkInventory:Print( RED_FONT_COLOR_CODE .. "Rule " .. rulenum .. " is now flagged as damaged and will no longer be used until repaired" )
			
			ArkInventory.db.account.option.rule[rulenum].damaged = true
			
			ArkInventory.PrintPlus( em )
			
		end
		
	end

	-- ArkInventory.PrintPlus( "ItemCategoryGetRule() end", debuginfo )

end

function ArkInventory.ItemCategoryGet( i, bt, bag_id, slot_id )
	-- returns category, [ default category]
	
	--local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }
	
	-- get default category
	local dc = ArkInventory.ItemCategoryGetDefault( i, bt, bag_id, slot_id )

	-- items cache id
	cid = ArkInventory.ItemGetCacheID( i )
	
	-- if the value has been cached then use it
	if ArkInventory.Global.Cache.Current[cid] == nil then
	
		local rs = ArkInventory.db.profile.option.category[cid] -- manually assigned item to a system category
		
		if rs == nil then
			rs = ArkInventory.ItemCategoryGetRule( i ) -- rule assigned item
		end

		-- cache the result
		ArkInventory.Global.Cache.Current[cid] = rs
		
	end

	if ArkInventory.Global.Cache.Current[cid] == nil then
		return dc, nil
	else
		return ArkInventory.Global.Cache.Current[cid], dc
	end
	
end


function ArkInventory.ItemCategorySet( i, category_id )
	
	ArkInventory.ItemCacheClear()

	-- set category_id to nil to reset back to default
	
	local cid = ArkInventory.ItemGetCacheID( i )
	ArkInventory.db.profile.option.category[cid] = category_id
	
end

function ArkInventory.ReverseName( n )

	if n and type( n ) == "string" then

		local s = { }

		for w in string.gmatch( n, "%S+" ) do
			tinsert( s, 1, w )
		end

		return table.concat( s, " " )
		
	end

end

function ArkInventory.ItemCacheClear()
	ArkInventory.Category_Generate()
	ArkInventory.BagSetDirtyAll()
	ArkInventory.Global.Cache.Current = { }
end

function ArkInventory.Frame_Main_DrawStatus( loc_id, level )
	if level < ArkInventory.Global.Location[loc_id].draw_state then
		ArkInventory.Global.Location[loc_id].draw_state = level
	end
end


function ArkInventory.Frame_Main_Generate_InitAll()
	for loc_id in pairs( ArkInventory.Global.Location ) do
		ArkInventory.Frame_Main_Generate_Init( loc_id )
	end
end

function ArkInventory.Frame_Main_Generate_RecalcAll()
	for loc_id in pairs( ArkInventory.Global.Location ) do
		ArkInventory.Frame_Main_Generate_Recalc( loc_id )
	end
end

function ArkInventory.Frame_Main_Generate_RefreshAll()
	for loc_id in pairs( ArkInventory.Global.Location ) do
		ArkInventory.Frame_Main_Generate_Refresh( loc_id )
	end
end



function ArkInventory.Frame_Main_Generate_Init( loc_id )
	ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Init )
	ArkInventory.Frame_Main_DrawLocation( loc_id )
end

function ArkInventory.Frame_Main_Generate_Recalc( loc_id )
	ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Recalculate )
	ArkInventory.Frame_Main_DrawLocation( loc_id )
end

function ArkInventory.Frame_Main_Generate_Refresh( loc_id )
	ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Refresh )
	ArkInventory.Frame_Main_DrawLocation( loc_id )
end



function ArkInventory.Frame_Main_Generate_All()
	for loc_id in pairs( ArkInventory.Global.Location ) do
		ArkInventory.Frame_Main_DrawLocation( loc_id )
	end
end

function ArkInventory.Frame_Main_DrawLocation( loc_id )
	local frame = ArkInventory.Frame_Main_Get( loc_id )
	ArkInventory.Frame_Main_Draw( frame )
end








function ArkInventory.PutItemInBank()

	if CursorHasItem() then
		
		for x = 1, GetContainerNumSlots( BANK_CONTAINER ) do
			h = GetContainerItemLink( BANK_CONTAINER, x )
			if not h then
				if not PickupContainerItem( BANK_CONTAINER, x ) then
					ClearCursor()
				end
				return
			end
		end
		
		UIErrorsFrame:AddMessage( ERR_BAG_FULL, 1.0, 0.1, 0.1, 1.0 )
		ClearCursor()
		
	end
	
end



function ArkInventory.Frame_Main_Get( loc_id )

	framename = ArkInventory.Const.Program.Frame .. loc_id
	frame = getglobal( framename )
	assert( frame, "xml element '" .. framename .. "' could not be found" )
	
	return frame

end
	
function ArkInventory.Frame_Main_Scale( frame )
	local loc_id = frame.ARK_Data.loc_id
	frame:SetScale( ArkInventory.OptionLocalGet( loc_id, { "window", "scale" } ) )
end
	
function ArkInventory.Frame_Main_Scale_All()
	for loc_id in pairs( ArkInventory.Global.Location ) do
		frame = ArkInventory.Frame_Main_Get( loc_id )
		ArkInventory.Frame_Main_Scale( frame )
	end
end

function ArkInventory.Frame_Main_Offline( frame )
	
	local loc_id = frame.ARK_Data.loc_id
	
	if ArkInventory.Global.Location[loc_id].player == ArkInventory.Global.Me.id then
		ArkInventory.Global.Location[loc_id].offline = false
		if loc_id == ArkInventory.Const.Location.Bank and ArkInventory.Global.Mode.Bank == false then
			ArkInventory.Global.Location[loc_id].offline = true
		end
	else
		ArkInventory.Global.Location[loc_id].offline = true
	end
	
end

function ArkInventory.Frame_Main_Anchor( loc_id, anchor )

	local frame = ArkInventory.Frame_Main_Get( loc_id )
	
	frame:ClearAllPoints()
	
	ArkInventory.OptionLocalSet( loc_id, { "window", "anchor" }, anchor )
	
	if anchor == ArkInventory.Const.Anchor.BottomRight then
		frame:SetPoint( "BOTTOMRIGHT" )
	end

	if anchor == ArkInventory.Const.Anchor.BottomLeft then
		frame:SetPoint( "BOTTOMLEFT" )
	end

	if anchor == ArkInventory.Const.Anchor.TopLeft then
		frame:SetPoint( "TOPLEFT" )
	end

	if anchor == ArkInventory.Const.Anchor.TopRight then
		frame:SetPoint( "TOPRIGHT" )
	end

end

function ArkInventory.Frame_Main_Paint( frame )
	
	local loc_id = frame.ARK_Data.loc_id
	
	for _, z in pairs( { frame:GetChildren() } ) do
		
		-- background colour
		obj = getglobal( z:GetName() .. "Background" )
		if obj then
			local colour = ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "background" } )
			obj:SetTexture( colour.r, colour.g, colour.b, colour.a )
		end
		
		-- border colour
		if ArkInventory.OptionLocalGet( loc_id, { "window", "border" } ) then
			local colour = ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "border" } )
			z:SetBackdropBorderColor( colour.r, colour.g, colour.b, 1 )
		else
			z:SetBackdropBorderColor( 0, 0, 0, 0 )
		end
		
	end
	
end

function ArkInventory.Frame_Main_Paint_All()

	for loc_id, loc_data in pairs( ArkInventory.Global.Location ) do
		frame = ArkInventory.Frame_Main_Get( loc_id )
		ArkInventory.Frame_Main_Paint( frame )
	end
	
end

function ArkInventory.Frame_Main_Update( frame )

	local loc_id = frame.ARK_Data.loc_id
	local current_player = ArkInventory.Global.Location[loc_id].player
	
	-- update the empty slot count
	local empty = { }
	for k, bag in pairs( ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag ) do
		if not empty[bag.type] then
			empty[bag.type] = { ["count"] = 0, ["empty"] = 0, ["type"] = bag.type }
		end
		empty[bag.type].count = empty[bag.type].count + bag.count
		empty[bag.type].empty = empty[bag.type].empty + bag.empty
	end

	local ee = ArkInventory.Table.Sum( empty, function( a ) return a.empty end )
	local ts = ArkInventory.db.account.cache.who[current_player].loc[loc_id].slot_count
	
	local y = ""
	if ee == 0 then
		y = RED_FONT_COLOR_CODE .. ArkInventory.Localise["STATUS_FULL"]
	else
		y = y .. ee .. "/" .. ts
	end

	if ts == 0 then
		y = RED_FONT_COLOR_CODE .. ArkInventory.Localise["STATUS_NO_DATA"]
	end

	
	if ts ~= 0 and ArkInventory.Table.Elements( empty ) > 1 then
		local z = 0
		local x
		y = y .. "  -  "
		for t, e in ArkInventory.spairs( empty, function(a,b) return empty[a].type < empty[b].type end ) do
			z = z + 1
			--x = e.empty .. "/" .. e.count .. " " .. ArkInventory.BagTypeText( t )
			x = e.empty .. " " .. ArkInventory.OptionLocalGet( loc_id, { "slot", "data", t, "name" } )
			if e.empty == 0 then
				x = RED_FONT_COLOR_CODE .. x .. FONT_COLOR_CODE_CLOSE
			end
			
			if z == 1 then
				y = y .. x
			else
				y = y .. ", " .. x
			end
			
		end
	end

	getglobal( frame:GetName() .. "StatusText" ):SetText( y )
	
	
	-- set the size of the window
	local h = 0
	h = h + getglobal( frame:GetName() .. "Title" ):GetHeight()
	h = h + getglobal( frame:GetName() .. "Container" ):GetHeight()
	h = h + getglobal( frame:GetName() .. "Changer" ):GetHeight()
	h = h + getglobal( frame:GetName() .. "Status" ):GetHeight()
	frame:SetHeight( h )
	
	frame:SetWidth( ArkInventory.db.account.cache.who[current_player].loc[loc_id].container.width )
	
end

function ArkInventory.Frame_Main_Draw( frame )

	assert( frame, "frame reference is nil" )
	
	-- exit if window isn't displayed
	if not frame:IsVisible() then
		return
	end
	
	--ArkInventory.PrintPlus( { "Frame_Main_Draw( ", frame, " )" } )
	
	local loc_id = frame.ARK_Data.loc_id
	local current_player = ArkInventory.Global.Location[loc_id].player

	-- is the window online or offline?
	ArkInventory.Frame_Main_Offline( frame )
	
	
	-- bag changer frame
	local obj = getglobal( frame:GetName() .. "Changer" )
	
	-- hide the changer frame if it can't be used
	--if ArkInventory.db.account.option.framehide.changer or ArkInventory.Global.Location[loc_id].offline or ( loc_id == ArkInventory.Const.Location.Bank and not ArkInventory.Global.Mode.Bank ) or loc_id == ArkInventory.Const.Location.Key then
	if ArkInventory.db.account.option.framehide.changer or loc_id == ArkInventory.Const.Location.Key then
		obj:SetHeight( 3 )
		obj:Hide()
	else
		obj:SetHeight( 58 )
		obj:Show()
	end
	
	-- if changer frame is open then dirty the bags and set to refresh - allows for when bags are changed as no events are triggered when that happens
	if obj:IsVisible() then
		ArkInventory.BagSetDirty( ArkInventory.Global.Location[loc_id].BAGS )
		ArkInventory.Frame_Changer_Player_Update()
		ArkInventory.Frame_Changer_Bank_Update()
		--ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Refresh )
	end
	
	-- instant sort or edit mode
	if ArkInventory.OptionLocalGet( loc_id, { "sort", "instant" } ) or ArkInventory.Global.Mode.Edit then
		ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Recalculate )
	end
	
	-- rescan all bags
	if not ArkInventory.Global.Location[loc_id].offline then
		ArkInventory.BagScanAll()
	end
	
	-- do we need to draw the window
	if ArkInventory.Global.Location[loc_id].draw_state == ArkInventory.Const.Window.Draw.None then
		return
	end

	local obj
	
	if ArkInventory.Global.Location[loc_id].draw_state <= ArkInventory.Const.Window.Draw.Init then

		ArkInventory.Frame_Main_Scale( frame )
		ArkInventory.Frame_Main_Paint( frame )

		-- setup main icon
		getglobal( frame:GetName() .. "TitleLocation0" ):SetNormalTexture( ArkInventory.Global.Location[loc_id].TEXTURE )
	
		-- setup small icons
		for x in pairs( ArkInventory.Global.Location ) do
			obj = getglobal( frame:GetName() .. "TitleLocation" .. x )
			obj:SetNormalTexture( ArkInventory.Global.Location[x].TEXTURE )
			obj:SetPushedTexture( ArkInventory.Global.Location[x].TEXTURE )
			obj:SetDisabledTexture( ArkInventory.Global.Location[x].TEXTURE )
			obj:SetHighlightTexture( ArkInventory.Global.Location[x].TEXTURE )
		end
		
		-- hide the header window if it's not needed
		obj = getglobal( frame:GetName() .. "Title" )
		if ArkInventory.db.account.option.framehide.header then
			obj:Hide()
			obj:SetHeight( 3 )
			
			obj = getglobal( frame:GetName() .. "ContainerMenu" )
			obj:SetNormalTexture( ArkInventory.Global.Location[loc_id].TEXTURE )
			obj:Show()
		else
			obj:SetHeight( 40 )
			obj:Show()
			getglobal( frame:GetName() .. "ContainerMenu" ):Hide()
		end


		-- hide the status window if it's not needed
		obj = getglobal( frame:GetName() .. "Status" )
		if ArkInventory.db.account.option.framehide.status then
			obj:Hide()
			obj:SetHeight( 3 )
		else
			obj:SetHeight( 40 )
			obj:Show()
		end
		
	end

	if ArkInventory.Global.Location[loc_id].draw_state <= ArkInventory.Const.Window.Draw.Refresh then
	
		-- set the current player
		obj = getglobal( frame:GetName() .. "TitleWho" )
		t = {
			ArkInventory.db.account.cache.who[current_player].name or ArkInventory.Localise["STATUS_NO_DATA"],
			ArkInventory.Global.Location[loc_id].NAME,
			ArkInventory.db.account.cache.who[current_player].realm or ArkInventory.Localise["STATUS_NO_DATA"],
		}
	
		if ArkInventory.Global.Location[loc_id].offline then
			obj:SetTextColor( 1, 0, 0 )
			tinsert( t, 3, ArkInventory.Localise["STATUS_OFFLINE"] )
		else
			obj:SetTextColor( 0, 1, 0 )
		end
	
		tinsert( t, ArkInventory.db.account.cache.who[current_player].faction or ArkInventory.Localise["STATUS_NO_DATA"] )
	
		obj:SetText( table.concat( t, " - " ) )

	end
	
	obj = getglobal( frame:GetName() .. "Container" )
	ArkInventory.Frame_Container_Draw( obj )
	
	
	if ArkInventory.Global.Location[loc_id].draw_state <= ArkInventory.Const.Window.Draw.Refresh then
		ArkInventory.Frame_Main_Update( frame )
	end
	
	
	ArkInventory.Global.Location[loc_id].draw_state = ArkInventory.Const.Window.Draw.None
	
end
	
function ArkInventory.Frame_Main_Show( loc_id, player )

	assert( loc_id, "invalid location: nil" )
	
	local frame = ArkInventory.Frame_Main_Get( loc_id )

	if not player then
		player = ArkInventory.Global.Me.id
	end

	if player ~= ArkInventory.Global.Location[loc_id].player then
		-- showing a different player than whats already being displayed so init
		ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Init )
	else
		-- same player, set to recalc
		ArkInventory.Frame_Main_DrawStatus( loc_id, ArkInventory.Const.Window.Draw.Recalculate )
	end
	
	ArkInventory.Global.Location[loc_id].player = player
	
	frame:Show()
	ArkInventory.Frame_Main_Draw( frame )

end

function ArkInventory.Frame_Main_OnShow( frame )

	local loc_id = frame.ARK_Data.loc_id

	if loc_id == ArkInventory.Const.Location.Key then
		PlaySound( "KeyRingOpen" )
	elseif loc_id == ArkInventory.Const.Location.Bank then
		PlaySound( "igMainMenuOpen" )
	elseif loc_id == ArkInventory.Const.Location.Bag then
		PlaySound( "igBackPackOpen" )
	end
	
end

	
		
function ArkInventory.Frame_Main_Hide( w )

	for loc_id in pairs( ArkInventory.Global.Location ) do
		if not w or w == loc_id then
			frame = ArkInventory.Frame_Main_Get( loc_id )
			frame:Hide()
		end
	end
	
end

function ArkInventory.Frame_Main_OnHide( frame )

	local loc_id = frame.ARK_Data.loc_id

	if loc_id == ArkInventory.Const.Location.Key then
	
		PlaySound( "KeyRingClose" )
		
	elseif loc_id == ArkInventory.Const.Location.Bank then
	
		PlaySound( "igMainMenuClose" )
		
		if ArkInventory.db.account.option.framehide.blizzard and ArkInventory.Global.Mode.Bank then
			-- close blizzards bank frame if we're hiding blizzard frames, we're at the bank, and the bank window was closed
			CloseBankFrame()
		end
		
	elseif loc_id == ArkInventory.Const.Location.Bag then
	
		PlaySound( "igBackPackClose" )
		
	end

	if ArkInventory.Global.Mode.Edit then
		-- if the edit mode is active then disable edit mode and taint so it's rebuilt when next opened
		ArkInventory.Global.Mode.Edit = false
		ArkInventory.Frame_Main_Generate_RecalcAll()
	end	
end

function ArkInventory.Frame_Main_OnLoad( frame )

	assert( frame, "frame is nil" )

	framename = frame:GetName()
	local loc_id = strmatch( framename, "^.-(%d+)" )
	
	assert( loc_id, string.format( "xml element '%s' is not an %s frame", framename, ArkInventory.Const.Program.Name ) )
	
	frame.ARK_Data = {
		["loc_id"] = tonumber( loc_id ),
	}
	
	frame:RegisterForDrag( "LeftButton" )
	tinsert( UISpecialFrames, framename )

end


function ArkInventory.Frame_Container_CalculateBars( frame )

	-- loads the inventory into their respective bars

	--ArkInventory.PrintPlus( { GREEN_FONT_COLOR_CODE, "Frame_Container_CalculateBars( ", frame:GetName(), " ) start" } )

	local loc_id = frame.ARK_Data.loc_id
	local current_player = ArkInventory.Global.Location[loc_id].player

	ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar = { }
	ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count = 1

	local barnum
		
	for bag_id, bag in pairs( ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag ) do
	
		for slot_id, slot in pairs( bag.slot ) do
		
			barnum = ArkInventory.Category_Location_Get( loc_id, slot.cat )
			
			--ArkInventory.PrintPlus( { "loc_id=[", loc_id, "], category=[", slot.cat, "], barnum[=", barnum, "]" } )
	
			if barnum > 0 or ArkInventory.Global.Mode.Edit or ArkInventory.OptionLocalGet( loc_id, { "slot", "ignorehidden" } ) then
			-- hidden categories reside on negative bar numbers so they don't get displayed
			-- but show them if in edit mode or the user wants us to ignore the hidden flag
	
				barnum = abs( barnum )
	
				-- create the bar
				if not ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[barnum] then
					ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[barnum] = { ["id"] = barnum, ["item"] = { }, ["count"] = 0, ["width"] = 0, ["height"] = 0, ["ghost"] = false, ["frame"] = 0 }
				end
		
				-- add the item to the bar
				tinsert( ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[barnum].item, { ["bag"] = bag_id, ["slot"] = slot_id } )
			
				-- increment the bars item count
				ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count + 1
			
				-- keep track of the last bar used
				if barnum > ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count then
					ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count = barnum
				end

				--ArkInventory.PrintPlus( { "bag[", bag_id, "], slot[", slot_id, "], cat[", slot.cat, "], bar[", barnum, "], id=[", ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[barnum].id, "]" } )
				
			end
			
		end
		
	end

	
	-- get highest used bar
	local cats = ArkInventory.OptionLocalGet( loc_id, { "category" } )
	for _, barnum in pairs( cats ) do
		if barnum > ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count then
			ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count = barnum
		end
	end
	
	-- round up to a full number of bars per row
	ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count = ceil( ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count / ArkInventory.OptionLocalGet( loc_id, { "bar", "per" } ) ) * ArkInventory.OptionLocalGet( loc_id, { "bar", "per" } )

	-- update the maximum number of bar frames used so far
	if ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count > ArkInventory.Global.Location[loc_id].bar_max then
		ArkInventory.Global.Location[loc_id].bar_max = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count
	end

	-- if we're in edit mode then create all missing bars and add a ghost item to every bar
	-- ghost items allow for the bar menu icon
	if ArkInventory.Global.Mode.Edit or ArkInventory.OptionLocalGet( loc_id, { "bar", "showempty" } ) then
	
		--ArkInventory.PrintPlus( { "edit mode - adding ghost bars" } )
		for barnum = 1, ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count do
				
			if not ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[barnum] then
			
				-- create a ghost bar
				ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[barnum] = { ["id"] = barnum, ["item"] = { }, ["count"] = 1, ["width"] = 0, ["height"] = 0, ["ghost"] = true, ["frame"] = 0 }
				
			else
	
				-- add a ghost item to the bar by incrementing the bars item count
				ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count + 1
				
			end
			
		end
		
	end

	--ArkInventory.PrintPlus( { GREEN_FONT_COLOR_CODE, "Frame_Container_CalculateBars( ", frame:GetName(), " ) end" } )
	
end

function ArkInventory.Frame_Container_Calculate( frame )

	-- calculate what the bars look like in the conatiner

	--ArkInventory.PrintPlus( { GREEN_FONT_COLOR_CODE, "Frame_Container_Calculate( ", frame:GetName(), " ) start" } )

	local loc_id = frame.ARK_Data.loc_id
	local current_player = ArkInventory.Global.Location[loc_id].player

	ArkInventory.db.account.cache.who[current_player].loc[loc_id].container = { ["row"] = { } }
	
	
	local bpr = ArkInventory.OptionLocalGet( loc_id, { "bar", "per" } )
	local rownum = 0
	local bf = 1 -- bar frame, allocated to each bar as it's calculated (uses less frames this way)
	
	--ArkInventory.PrintPlus( { "container has ", ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count, " bars" } )
	--ArkInventory.PrintPlus( { "container set for ", bpr, " bars per row" } )
	
	
	if ArkInventory.Global.Mode.Edit == false and ArkInventory.OptionLocalGet( loc_id, { "bar", "compact" } ) then
	
		--ArkInventory.PrintPlus( { "compact bars enabled" } )
	
		local bc = 0  -- number of bars currently in this row
		local vr = { }  -- virtual row - holds a list of bars for this row

		for j = 1, ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count do
		
			--ArkInventory.PrintPlus( { "bar [", j, "]" } )
		
			if ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[j] then
				if ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[j].count > 0 then
					--ArkInventory.PrintPlus( { "assignment: bar [", j, "] to frame [", bf, "]" } )
					ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[j]["frame"] = bf
					bf = bf + 1
					bc = bc + 1
					--tinsert( vr, ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[j] )
					tinsert( vr, j )
				else
					--ArkInventory.PrintPlus( { "bar [", j, "] has no items" } )
				end
			else
				--ArkInventory.PrintPlus( { "bar [", j, "] has no items (does not exist)" } )
			end
		
			if bc > 0 and ( bc == bpr or j == ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count ) then
		
				rownum = rownum + 1
				if not ArkInventory.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] then
					ArkInventory.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] = { }
				end
				
				--ArkInventory.PrintPlus( { "row [", rownum, "] allocated [", bc, "] bars" } )
			
				ArkInventory.db.account.cache.who[current_player].loc[loc_id].container.row[rownum].bar = vr
				
				--ArkInventory.PrintPlus( { "row [", rownum, "] created" } )
				
				bc = 0
				vr = { }

			end
		
		end
	
	else
	
		for j = 1, ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count, bpr do
		
			local bc = 0  -- number of bars currently in this row
			local vr = { }  -- virtual row - holds a list of bars for this row

			for b = 1, bpr do
				if ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1] then
					if ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1].count > 0 then
						--ArkInventory.PrintPlus( { "assignment: bar [", j+b-1, "] to frame [", bf, "]" } )
						ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1]["frame"] = bf
						bf = bf + 1
						bc = bc + 1
						--tinsert( vr, ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1] )
						tinsert( vr, j+b-1 )
					else
						--ArkInventory.PrintPlus( { "bar [", j+b-1, "] has no items" } )
					end
				else
					--ArkInventory.PrintPlus( { "bar [", j+b-1, "] has no items (does not exist)" } )
				end
			end
		
			if bc > 0 then
		
				rownum = rownum + 1
				if not ArkInventory.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] then
					ArkInventory.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] = { }
				end
			
				--ArkInventory.PrintPlus( { "row [", rownum, "] allocated [", bc, "] bars" } )
				
				ArkInventory.db.account.cache.who[current_player].loc[loc_id].container.row[rownum].bar = vr
				
			end

		end
		
	end

	
	-- fit the bars into the row

	local rmw = ArkInventory.OptionLocalGet( loc_id, { "window", "width" } )  -- row max width
	local rcw = 0 -- row current width
	local rch = 1 -- row current height
	local rmh = 0 -- row max height
		
	bar = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar
		
	for rownum, row in ipairs( ArkInventory.db.account.cache.who[current_player].loc[loc_id].container.row ) do
		
		for k, barnum in ipairs( row.bar ) do

			bar[barnum].width = floor( bar[barnum].count / rmw )
			if bar[barnum].width < 1 then
				bar[barnum].width = 1
			end
			
			bar[barnum].height = ceil( bar[barnum].count / bar[barnum].width )
				
			if bar[barnum].height > rmh then
				rmh = bar[barnum].height
			end
			
			--ArkInventory.PrintPlus( { "row=[", rownum, "], index=[", k, "], bar=[", barnum, "], width=[", bar[barnum].width, "], height=[", bar[barnum].height, "]" } )
			
		end
		
		
		
		if rmh > 1 then

			repeat
			
				rcw = 0
				rmh = 0
				rmb = 0
				
				-- find bar with highest height
				for _, barnum in ipairs( row.bar ) do
					if bar[barnum].height > rmh then
						rmh = bar[barnum].height
						rmb = barnum
					end
				end

				
				-- increase that bars width by one
				bar[rmb].width = bar[rmb].width + 1
				
				-- and recalcualte it's new height
				bar[rmb].height = ceil( bar[rmb].count / bar[rmb].width )
				
				-- and see if that all fits
				rcw = 0
				rmh = 0
				for _, barnum in ipairs( row.bar ) do
					
					rcw = rcw + bar[barnum].width
					
					if bar[barnum].height > rmh then
						rmh = bar[barnum].height
					end
					
				end
				
				-- exit if the width fits or the max height is 1
			until rcw >= rmw or rmh == 1
			
		end
		
		--ArkInventory.PrintPlus( { "maximum height for row [", rownum, "] was [", rmh, "]" } )
		
		for k, barnum in ipairs( row.bar ) do
		
			--ArkInventory.PrintPlus( { "setting max height for row [", rownum, "] bar [", barnum, "] to [", rmh, "]" } )
		
			-- set height of all bars in the row to the maximum height used (looks better)
			bar[barnum].height = rmh
			
			if bar[barnum].ghost or ArkInventory.Global.Mode.Edit or ArkInventory.OptionLocalGet( loc_id, { "bar", "showempty" } ) then
				-- remove the ghost item from the count (it was only needed to calculate properly)
				bar[barnum].count = bar[barnum].count - 1
			end
		end
		
	end
	

	--ArkInventory.PrintPlus( { GREEN_FONT_COLOR_CODE, "Frame_Container_Calculate( ", frame:GetName(), " ) end" } )

end

function ArkInventory.Frame_Container_Draw( frame )

	local loc_id = frame.ARK_Data.loc_id
	local current_player = ArkInventory.Global.Location[loc_id].player
	
	if ArkInventory.Global.Location[loc_id].draw_state <= ArkInventory.Const.Window.Draw.Recalculate then

		-- break the inventory up into it's respective bars
		ArkInventory.Frame_Container_CalculateBars( frame )
	
	
		-- calculate what the container should look like
		ArkInventory.Frame_Container_Calculate( frame )

		local name

		-- create (if required) the bar frames, and hide any that are no longer required
		local placeframename = frame:GetName() .. "Bar"
		local placeframe = getglobal( placeframename )
		assert( placeframe, "xml element '" .. placeframename .. "' could not be found" )
		
		for j = 1, ArkInventory.Global.Location[loc_id].bar_max do
			local barframename = placeframename .. j
			local barframe = getglobal( barframename )
			if not barframe then
				barframe = CreateFrame( "Frame", barframename, placeframe, "ARKINV_TemplateFrameBar" )
			end
			
			ArkInventory.Frame_Bar_Paint( barframe )
			barframe:Hide()
		end

		
		-- calculate numer of active slots (required to keep track of the total number of slots a character has)
		ArkInventory.db.account.cache.who[current_player].loc[loc_id].slot_count = ArkInventory.Table.Sum( ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag, function( a ) return a.count end )

		
		-- create (if required) the bags and their item buttons, and hide any that are not currently needed
		local placeframename = frame:GetName() .. "Bag"
		local placeframe = getglobal( placeframename )
		assert( placeframe, "xml element '" .. placeframename .. "' could not be found" )

		--~~~~ need to fix this for when the cache is reset
		for _, bag_id in pairs( ArkInventory.Global.Location[loc_id].BAGS ) do
		
			local bagframename = placeframename .. bag_id
			local bagframe = getglobal( bagframename )
			if not bagframe then
				bagframe = CreateFrame( "Frame", bagframename, placeframename, "ARKINV_TemplateFrameBag" )
			end
			
			-- remember the maximum number of slots used for each bag
			local b = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag[bag_id]
			
			if not ArkInventory.Global.Location[loc_id].slot_max[bag_id] then
				ArkInventory.Global.Location[loc_id].slot_max[bag_id] = 0
			end
			
			if b then
				if b.count > ArkInventory.Global.Location[loc_id].slot_max[bag_id] then
					ArkInventory.Global.Location[loc_id].slot_max[bag_id] = b.count
				end
			end

			-- create the item frames for the bag
			for j = 1, ArkInventory.Global.Location[loc_id].slot_max[bag_id] do

				local itemframename = ArkInventory.ContainerItemNameGet( loc_id, bag_id, j )
				local itemframe = getglobal( itemframename )
				if not itemframe then
					itemframe = CreateFrame( "Button", itemframename, bagframe, "ARKINV_TemplateButtonItem" )
				end	

				if j == 1 then
					ArkInventory.Global.BAG_SLOT_SIZE = itemframe:GetWidth()
				end
				
				ArkInventory.Frame_Item_Update_Clickable( itemframe )
				itemframe:Hide()
				
			end
			
		end
		
	end



	-- build the bar frames
	
	local name = frame:GetName()
		
	local pad_slot = ArkInventory.OptionLocalGet( loc_id, { "slot", "pad" } )
	local pad_bar_int = ArkInventory.OptionLocalGet( loc_id, { "bar", "pad", "internal" } )
	local pad_bar_ext = ArkInventory.OptionLocalGet( loc_id, { "bar", "pad", "external" } )
	local pad_window = ArkInventory.OptionLocalGet( loc_id, { "window", "pad" } )
	local anchor = ArkInventory.OptionLocalGet( loc_id, { "bar", "anchor" } )
	local direction = ArkInventory.OptionLocalGet( loc_id, { "bar", "direction" } )

	for rownum, row in ipairs( ArkInventory.db.account.cache.who[current_player].loc[loc_id].container.row ) do

		row["width"] = pad_window * 2
		
		for bar_index, barnum in ipairs( row.bar ) do

			bar = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[barnum]
			
			barframename = name .. "Bar" .. bar.frame
			obj = getglobal( barframename )
			assert( obj, "xml element '" .. barframename .. "' could not be found" )

			-- assign the bar number used to the bar frame
			obj.ARK_Data.bar = barnum
			
			if ArkInventory.Global.Location[loc_id].draw_state <= ArkInventory.Const.Window.Draw.Recalculate then

				obj_width = bar.width * ArkInventory.Global.BAG_SLOT_SIZE + ( bar.width - 1 ) * pad_slot + pad_bar_int * 2
				obj:SetWidth( obj_width )
				row.width = row.width + obj_width
				
				if bar_index > 1 then
					row.width = row.width + pad_bar_ext
				end

				row["height"] = bar.height * ArkInventory.Global.BAG_SLOT_SIZE + ( bar.height - 1 ) * pad_slot + pad_bar_int * 2				
				obj:SetHeight( row.height )
				
				obj:ClearAllPoints()
				
				--ArkInventory.Debug( "row=" .. rownum .. ", bar=" .. bar_index .. ", obj=" .. obj:GetName() .. ", frame=" .. bar.frame )
				-- anchor first bar to frame
				if bar.frame == 1 then
				
					if anchor == ArkInventory.Const.Anchor.BottomRight then
						obj:SetPoint( "BOTTOMRIGHT", frame, "BOTTOMRIGHT", 0 - pad_window, pad_window )
					elseif anchor == ArkInventory.Const.Anchor.BottomLeft then
						obj:SetPoint( "BOTTOMLEFT", frame, "BOTTOMLEFT", pad_window, pad_window )
					elseif anchor == ArkInventory.Const.Anchor.TopLeft then
						obj:SetPoint( "TOPLEFT", frame, "TOPLEFT", pad_window, 0 - pad_window )
					elseif anchor == ArkInventory.Const.Anchor.TopRight then
						obj:SetPoint( "TOPRIGHT", frame, "TOPRIGHT", 0 - pad_window, 0 - pad_window )
					end
					
				else
				
					if bar_index == 1 then
						-- next row, place under previous row
						--ArkInventory.Debug( "anchor=" .. name .. "Bar" .. ArkInventory.db.account.cache.who[current_player].loc[loc_id].container.row[rownum-1].bar[1].frame )
						
						local prev = ArkInventory.db.account.cache.who[current_player].loc[loc_id].container.row[rownum-1].bar[1]
						local pbar = name .. "Bar" .. ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[prev].frame
						
						if anchor == ArkInventory.Const.Anchor.BottomRight then
						
							if direction == ArkInventory.Const.Direction.Horizontal then
								obj:SetPoint( "BOTTOMRIGHT", pbar, "TOPRIGHT", 0, pad_bar_ext )
							elseif direction == ArkInventory.Const.Direction.Vertical then
								obj:SetPoint( "BOTTOMRIGHT", pbar, "BOTTOMLEFT", 0 - pad_bar_ext, 0 )
							end
							
						elseif anchor == ArkInventory.Const.Anchor.BottomLeft then
						
							if direction == ArkInventory.Const.Direction.Horizontal then
								obj:SetPoint( "BOTTOMLEFT", pbar, "TOPLEFT", 0, pad_bar_ext )
							elseif direction == ArkInventory.Const.Direction.Vertical then
								obj:SetPoint( "BOTTOMLEFT", pbar, "BOTTOMRIGHT", pad_bar_ext, 0 )
							end
							
						elseif anchor == ArkInventory.Const.Anchor.TopLeft then
						
							if direction == ArkInventory.Const.Direction.Horizontal then
								obj:SetPoint( "TOPLEFT", pbar, "BOTTOMLEFT", 0, 0 - pad_bar_ext )
							elseif direction == ArkInventory.Const.Direction.Vertical then
								obj:SetPoint( "TOPLEFT", pbar, "TOPRIGHT", pad_bar_ext, 0 )
							end
							
						elseif anchor == ArkInventory.Const.Anchor.TopRight then
						
							if direction == ArkInventory.Const.Direction.Horizontal then
								obj:SetPoint( "TOPRIGHT", pbar, "BOTTOMRIGHT", 0, 0 - pad_bar_ext )
							elseif direction == ArkInventory.Const.Direction.Vertical then
								obj:SetPoint( "TOPRIGHT", pbar, "TOPLEFT", 0 - pad_bar_ext, 0 )
							end
							
						end

					else
						-- next slot, place bar next to last one
						
						local pbar = name .. "Bar" .. ( bar.frame - 1 )
						
						if anchor == ArkInventory.Const.Anchor.BottomRight then
						
							if direction == ArkInventory.Const.Direction.Horizontal then
								obj:SetPoint( "BOTTOMRIGHT", pbar, "BOTTOMLEFT", 0 - pad_bar_ext, 0 )
							elseif direction == ArkInventory.Const.Direction.Vertical then
								obj:SetPoint( "BOTTOMRIGHT", pbar, "TOPRIGHT", 0, pad_bar_ext )
							end
							
						elseif anchor == ArkInventory.Const.Anchor.BottomLeft then
						
							if direction == ArkInventory.Const.Direction.Horizontal then
								obj:SetPoint( "BOTTOMLEFT", pbar, "BOTTOMRIGHT", pad_bar_ext, 0 )
							elseif direction == ArkInventory.Const.Direction.Vertical then
								obj:SetPoint( "BOTTOMLEFT", pbar, "TOPLEFT", 0, pad_bar_ext )
							end
							
						elseif anchor == ArkInventory.Const.Anchor.TopLeft then
						
							if direction == ArkInventory.Const.Direction.Horizontal then
								obj:SetPoint( "TOPLEFT", pbar, "TOPRIGHT", pad_bar_ext, 0 )
							elseif direction == ArkInventory.Const.Direction.Vertical then
								obj:SetPoint( "TOPLEFT", pbar, "BOTTOMLEFT", 0, 0 - pad_bar_ext )
							end
							
						elseif anchor == ArkInventory.Const.Anchor.TopRight then
						
							if direction == ArkInventory.Const.Direction.Horizontal then
								obj:SetPoint( "TOPRIGHT", pbar, "TOPLEFT", 0 - pad_bar_ext, 0 )
							elseif direction == ArkInventory.Const.Direction.Vertical then
								obj:SetPoint( "TOPRIGHT", pbar, "BOTTOMRIGHT", 0, 0 - pad_bar_ext )
							end
							
						end
						
					end
				
				end
				
				obj:Show()

			end
				
			if ArkInventory.Global.Location[loc_id].draw_state <= ArkInventory.Const.Window.Draw.Refresh then
				ArkInventory.Frame_Bar_DrawItems( obj )
			end
			
		end

	end

	
	if ArkInventory.Global.Location[loc_id].draw_state <= ArkInventory.Const.Window.Draw.Recalculate then

		-- set container height and width
		
		local c = ArkInventory.db.account.cache.who[current_player].loc[loc_id].container
		
		c.width = ArkInventory.Const.Window.Min.Width
		c.height = pad_window * 2

		for row_index, row in ipairs( c.row ) do
		
			if row.width > c.width then
				c.width = row.width
			end
			
			c.height = c.height + row.height
			
			if row_index > 1 then
				c.height = c.height + pad_bar_ext
			end
		
		end
		
		if c.height < ArkInventory.Const.Window.Min.Height then
			c.height = ArkInventory.Const.Window.Min.Height
		end
		
		frame:SetWidth( c.width )
		frame:SetHeight( c.height )

	end

	
end

function ArkInventory.Frame_Container_OnLoad( frame )

	assert( frame, "frame is nil" )

	framename = frame:GetName()
	local loc_id = strmatch( framename, "^.-(%d+)Container" )

	assert( loc_id, string.format( "xml element '%s' is not an %s frame", framename, ArkInventory.Const.Program.Name ) )
	
	frame.ARK_Data = {
		["loc_id"] = tonumber( loc_id ),
	}

end


function ArkInventory.Frame_Bar_Paint_All()

	--ArkInventory.PrintPlus( { "Frame_Bar_Paint_All()" } )

	for loc_id, loc_data in pairs( ArkInventory.Global.Location ) do

		c = getglobal( ArkInventory.Const.Program.Frame .. loc_id .. "Container" )
		
		if c and c:IsVisible() then
		
			for barnum = 1, loc_data.bar_max do

				obj = getglobal( c:GetName() .. "Bar" .. barnum )
				
				if obj then
					ArkInventory.Frame_Bar_Paint( obj )
				end
				
			end
			
		end
		
	end

end

function ArkInventory.Frame_Bar_Paint( frame )
	
	assert( frame, "frame is nil" )
	
	local loc_id = frame.ARK_Data.loc_id
	
	-- border colour
	if ArkInventory.OptionLocalGet( loc_id, { "bar", "border" } ) then
		colour = ArkInventory.OptionLocalGet( loc_id, { "bar", "colour", "border" } )
		frame:SetBackdropBorderColor( colour.r, colour.g, colour.b, 1 )
	else
		frame:SetBackdropBorderColor( 0, 0, 0, 0 )
	end
	
	-- background colour
	if ArkInventory.Global.Mode.Edit then
	
		frame:SetBackdropBorderColor( 1, 0, 0, 1 )
		getglobal( frame:GetName() .. "Background" ):SetTexture( 1, 0, 0, 0.1 )
		
		obj = getglobal( frame:GetName() .. "Edit" )
		obj:ClearAllPoints()
		pad_bar = ArkInventory.OptionLocalGet( loc_id, { "bar", "pad", "internal" } )
		obj:SetPoint( "TOPLEFT", frame, "TOPLEFT", pad_bar, 0 - pad_bar )
		obj:SetWidth( ArkInventory.Global.BAG_SLOT_SIZE )
		obj:SetHeight( ArkInventory.Global.BAG_SLOT_SIZE )
		obj:Show()
	
	else
	
		colour = ArkInventory.OptionLocalGet( loc_id, { "bar", "colour", "background" } )
		getglobal( frame:GetName() .. "Background" ):SetTexture( colour.r, colour.g, colour.b, colour.a )
		getglobal( frame:GetName() .. "Edit" ):Hide()
	
	end
	
end

function ArkInventory.Frame_Bar_DrawItems( frame )

	local loc_id = frame.ARK_Data.loc_id
	
	if ArkInventory.Global.Location[loc_id].draw_state > ArkInventory.Const.Window.Draw.Refresh then
		return
	end
	
	local barnum = frame.ARK_Data.barnum
	local current_player = ArkInventory.Global.Location[loc_id].player
	
	local bar = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar[frame.ARK_Data.bar]
	assert( bar, "bar data has not been set" )
	
	if bar.count == 0 or bar.ghost then
		return
	end
	
	if ArkInventory.Global.Location[loc_id].draw_state <= ArkInventory.Const.Window.Draw.Resort then
		
		-- sort the items in the bar
		for j = 1, bar.count do
	
			local bag_id = bar.item[j].bag
			local slot_id = bar.item[j].slot

			bar.item[j].sort = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag[bag_id].slot[slot_id].sort or "!"
			
		end
		
		sort( bar.item, function( a, b ) return a.sort > b.sort end )
		
	end

	local pad_slot = ArkInventory.OptionLocalGet( loc_id, { "slot", "pad" } )
	local pad_bar = ArkInventory.OptionLocalGet( loc_id, { "bar", "pad", "internal" } )
	local col = bar.width
	local obj

	-- cycle through the items in the bar
	for j = 1, bar.count do

		local i = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag[bar.item[j].bag].slot[bar.item[j].slot]
		name = ArkInventory.ContainerItemNameGet( loc_id, bar.item[j].bag, bar.item[j].slot )
		obj = getglobal( name )
		assert( obj, "xml element '" .. name .. "' does not exist" )

		if ArkInventory.Global.Location[loc_id].draw_state <= ArkInventory.Const.Window.Draw.Recalculate then
		
			-- anchor first item to bar frame - WARNING - item anchor point can only be bottom right - nothing else
			if ( j == 1 ) then
				obj:SetPoint( "BOTTOMRIGHT", frame, "BOTTOMRIGHT", 0 - pad_bar, pad_bar )
			else
				if ( mod( ( j - 1 ), col ) == 0 ) then
					-- next row, anchor to first item in previous row
					obj:SetPoint( "BOTTOMRIGHT", ArkInventory.ContainerItemNameGet( loc_id, bar.item[j-col].bag, bar.item[j-col].slot ), "TOPRIGHT", 0, pad_slot )
				else
					-- anchor to last one
					obj:SetPoint( "BOTTOMRIGHT", ArkInventory.ContainerItemNameGet( loc_id, bar.item[j-1].bag, bar.item[j-1].slot ), "BOTTOMLEFT", 0 - pad_slot, 0 )
				end
			end
			
		end
	
		obj:Show()

		if ArkInventory.Global.Location[loc_id].draw_state <= ArkInventory.Const.Window.Draw.Refresh then
			ArkInventory.Frame_Item_Update_QualityBorder( obj )
			ArkInventory.Frame_Item_Update_Fade( obj )
			ArkInventory.Frame_Item_Update_Count( obj )
			ArkInventory.Frame_Item_Update_Texture( obj )
			ArkInventory.Frame_Item_Update_Cooldown( obj )
		end

	end

end

function ArkInventory.Frame_Bar_OnLoad( frame )

	assert( frame, "frame is nil" )

	framename = frame:GetName()
	local loc_id, barnum = strmatch( framename, "^.-(%d+)ContainerBar(%d+)" )

	assert( loc_id, string.format( "xml element '%s' is not an %s frame", framename, ArkInventory.Const.Program.Name ) )
	assert( barnum, string.format( "xml element '%s' is not an %s frame", framename, ArkInventory.Const.Program.Name ) )
	
	frame.ARK_Data = {
		["loc_id"] = tonumber( loc_id ),
		["barnum"] = tonumber( barnum ),
	}
	
	frame:SetID( barnum )
	
end


function ArkInventory.Frame_Bag_OnLoad( frame )

	assert( frame, "frame is nil" )

	framename = frame:GetName()
	local loc_id, bag_id = strmatch( framename, "^.-(%d+)ContainerBag(%-?%d+)" )
	
	assert( loc_id, string.format( "xml element '%s' is not an %s frame", framename, ArkInventory.Const.Program.Name ) )
	assert( bag_id, string.format( "xml element '%s' is not an %s frame", framename, ArkInventory.Const.Program.Name ) )
	
	frame.ARK_Data = {
		["loc_id"] = tonumber( loc_id ),
		["bag_id"] = tonumber( bag_id ),
	}
	
	frame:SetID( bag_id )
	
end


function ArkInventory.Frame_Item_GetDB( frame )

	local loc_id = frame.ARK_Data.loc_id
	local current_player = ArkInventory.Global.Location[loc_id].player
	local bag_id = frame.ARK_Data.bag_id
	local slot_id = frame.ARK_Data.slot_id

	i = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag[bag_id].slot[slot_id]
	assert( i, "a matching itemtable entry for '" .. frame:GetName() .. "' does not exist" )
	
	return i
	
end
	
function ArkInventory.Frame_Item_Update_Texture( frame )
	
	assert( frame, "frame is nil" )
	
	if not frame:IsVisible() then
		return
	end

	local i = ArkInventory.Frame_Item_GetDB( frame )

	if i.h then

		if not ArkInventory.Global.Location[frame.ARK_Data.loc_id].offline then
			frame.readable = select( 5, GetContainerItemInfo( i.bag_id, i.slot_id ) )
		else
			frame.readable = nil
		end

		frame.hasItem = 1
		SetItemButtonTexture( frame, ArkInventory.ItemGetTexture( i.h ) )
		SetItemButtonTextureVertexColor( frame, 1, 1, 1 )
		
	else
		
		frame.readable = nil
		frame.hasItem = nil
		ArkInventory.Frame_Item_Update_Empty( frame )
		
	end

	-- new indicator
	ArkInventory.Frame_Item_Update_NewIndicator( frame )
	
end

function ArkInventory.Frame_Item_Update_Count( frame )
	local i = ArkInventory.Frame_Item_GetDB( frame )
	SetItemButtonCount( frame, i.count )
end

function ArkInventory.Frame_Item_Update_Fade( frame )
	if ArkInventory.Global.Location[frame.ARK_Data.loc_id].offline and ArkInventory.db.account.option.offline.fade then
		frame:SetAlpha( ArkInventory.Const.Fade )
	else
		frame:SetAlpha( 1 )
	end
end

function ArkInventory.Frame_Item_Update_QualityBorder( frame )

	assert( frame, "frame is nil" )

	if not frame:IsVisible() then
		return
	end

	local framename = frame:GetName()
	
	local loc_id = frame.ARK_Data.loc_id
	local current_player = ArkInventory.Global.Location[loc_id].player
	local bag_id = frame.ARK_Data.bag_id
	local i = ArkInventory.Frame_Item_GetDB( frame )
	
	obj_name = "ArkQualityBorder"
	obj = getglobal( framename .. obj_name )
	assert( obj, string.format( "xml element '%s' is missing the sub element %s", framename, obj_name ) )
	
	if i.h then
	
		if ArkInventory.OptionLocalGet( loc_id, { "slot", "border" } ) then
			r, g, b = GetItemQualityColor( i.q or 0 )	
			obj:SetBackdropBorderColor( r, g, b, 1 )
		else
			r, g, b = GetItemQualityColor( 0 )
			obj:SetBackdropBorderColor( r, g, b, 1 )
		end
	
	else
	
		if ArkInventory.OptionLocalGet( loc_id, { "slot", "empty", "border" } ) then
			-- slot colour
			local bt = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag[bag_id].type
			local colour = ArkInventory.OptionLocalGet( loc_id, { "slot", "data", bt, "colour" } )
			obj:SetBackdropBorderColor( colour.r, colour.g, colour.b, 1 )
		else
			-- trash colour
			r, g, b = GetItemQualityColor( 0 )
			obj:SetBackdropBorderColor( r, g, b, 1 )
		end
	
	end
	
end

function ArkInventory.Frame_Item_Update_NewIndicator( frame )
	
	assert( frame, "frame is nil" )
	
	if not frame:IsVisible() then
		return
	end

	local framename = frame:GetName()
	
	local i = ArkInventory.Frame_Item_GetDB( frame )
	
	obj_name = "ArkNewText"
	obj = getglobal( framename .. obj_name )
	assert( obj, string.format( "xml element '%s' is missing the sub element %s", framename, obj_name ) )
	
	if i.h and ArkInventory.db.account.option.newitem.show then
		colour = ArkInventory.db.account.option.newitem.colour
		obj:SetTextColor( colour.r, colour.g, colour.b )
		if i.new == ArkInventory.Const.Slot.New.None then
			obj:Hide()
		elseif i.new == ArkInventory.Const.Slot.New.New then
			obj:SetText( ArkInventory.Localise["NEW_ITEM_NEW"] )
			obj:Show()
		elseif i.new == ArkInventory.Const.Slot.New.Increased then
			obj:SetText( ArkInventory.Localise["NEW_ITEM_INCREASE"] )
			obj:Show()
		elseif i.new == ArkInventory.Const.Slot.New.Decreased then
			obj:SetText( ArkInventory.Localise["NEW_ITEM_DECREASE"] )
			obj:Show()
		end
	else
		obj:Hide()
	end
	
end

function ArkInventory.Frame_Item_Update_Empty( frame )

	assert( frame, "frame is nil" )
	
	if not frame:IsVisible() then
		return
	end
	
	local loc_id = frame.ARK_Data.loc_id
	local current_player = ArkInventory.Global.Location[loc_id].player
	local bag_id = frame.ARK_Data.bag_id
	local i = ArkInventory.Frame_Item_GetDB( frame )
	
	if not i.h then
	
		-- slot background
		if ArkInventory.OptionLocalGet( loc_id, { "slot", "empty", "icon" } ) then
			-- icon
			SetItemButtonTexture( frame, ArkInventory.Const.Texture.Empty.Slot )
			SetItemButtonTextureVertexColor( frame, 1, 1, 1 )
		else
			-- solid colour
			local bt = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag[bag_id].type
			local colour = ArkInventory.OptionLocalGet( loc_id, { "slot", "data", bt, "colour" } )

			SetItemButtonTexture( frame, [[Interface\Buttons\WHITE8X8]] )
			SetItemButtonTextureVertexColor( frame, colour.r * 0.25, colour.g * 0.25, colour.b * 0.25 )
		end
		
		-- slot border
		ArkInventory.Frame_Item_Update_QualityBorder( frame )
		
	end
	
end
	
function ArkInventory.Frame_Item_OnClick( frame, arg1 )
	
		local usedmycode = false
		
		if ArkInventory.Global.Location[frame.ARK_Data.loc_id].offline or ArkInventory.Global.Mode.Edit then

			if not ( IsShiftKeyDown() or IsControlKeyDown() ) then
		
				usedmycode = true
				-- do nothing for disabled buttons
				
			end
				
		end
	
		if usedmycode == false then
			ContainerFrameItemButton_OnClick( arg1 )
		end
	
	end

function ArkInventory.Frame_Item_OnEnter( frame )

	local loc_id = frame.ARK_Data.loc_id
	local i = ArkInventory.Frame_Item_GetDB( frame )
	
	local usedmycode = false
	
	if ArkInventory.Global.Location[loc_id].offline or i.bag_id == BANK_CONTAINER or i.bag_id == KEYRING_CONTAINER then

		usedmycode = true -- offline, bank or keyring
		
		if i.h then
	
			ArkInventory.TooltipSetPosition( frame )

			if ArkInventory.Global.Location[loc_id].offline then
				
				GameTooltip:SetHyperlink( i.h )

				if IsShiftKeyDown() then
					GameTooltip_ShowCompareItem()
				elseif IsControlKeyDown() then
					ShowInspectCursor()
				else
					ResetCursor()
				end
				
			elseif i.bag_id == BANK_CONTAINER then
				
				GameTooltip:SetInventoryItem( "player", BankButtonIDToInvSlotID( i.slot_id ) )
				
				if IsShiftKeyDown() then
					GameTooltip_ShowCompareItem()
				elseif IsControlKeyDown() then
					ShowInspectCursor()
				elseif frame.readable then
					ShowInspectCursor()
				else
					ResetCursor()
				end

			elseif i.bag_id == KEYRING_CONTAINER then
				GameTooltip:SetInventoryItem( "player", KeyRingButtonIDToInvSlotID( i.slot_id ) )
				CursorUpdate()
			else
				assert( false, "uncoded value to build tooltip " )
			end
			
			GameTooltip:Show()
			
		end

	end
	
	if usedmycode == false then
		ContainerFrameItemButton_OnEnter( frame )
	end

end

function ArkInventory.Frame_Item_OnDrag( frame )
	
	local usedmycode = false
	
	if ArkInventory.Global.Location[frame.ARK_Data.loc_id].offline or ArkInventory.Global.Mode.Edit then
	
		usedmycode = true
		-- do not drag for disabled buttons
		
	end

	if usedmycode == false then
		ContainerFrameItemButton_OnClick( "LeftButton" )
	end

end

function ArkInventory.Frame_Item_OnMouseUp( frame, arg1 )

	local i = ArkInventory.Frame_Item_GetDB( frame )
		
	if ArkInventory.Global.Location[frame.ARK_Data.loc_id].offline or ArkInventory.Global.Mode.Edit then
		
		if IsModifierKeyDown() then
			
			if i.h then
				
				if arg1 == "LeftButton" then
				
					if IsControlKeyDown() then
						DressUpItemLink( i.h )
					elseif IsShiftKeyDown() then
						ChatEdit_InsertLink( i.h )
					end
					
				end
				
			end
				
		else
	
			if ArkInventory.Global.Mode.Edit then
				ArkInventory.MenuItemOpen( frame )
			end
	
		end
			
	end
		
end

function ArkInventory.Frame_Item_OnEvent( frame )

	if not frame:IsVisible() then
		return
	end

	if event == "ITEM_LOCK_CHANGED" then
		if frame:IsVisible() then
			ArkInventory.Frame_Item_Update_Lock( frame )
		end
	elseif event == "BAG_UPDATE_COOLDOWN" then
		if frame:IsVisible() then
			ArkInventory.Frame_Item_Update_Cooldown( frame, arg1 )
		end
	else
		--ArkInventory.Debug( "event = " .. event )
	end

	ArkInventory.Frame_Item_OnUpdate( frame )
	
end
	
function ArkInventory.Frame_Item_OnUpdate( frame )
	
	if not frame:IsVisible() then
		return
	end

	if GameTooltip:IsOwned( frame ) then
		ArkInventory.Frame_Item_OnEnter( frame )
	end
	
end

function ArkInventory.Frame_Item_Update_Cooldown( frame, arg1 )

	-- triggered when a cooldown is first started, and used to hide/show the cooldown frame when offline
	
	if not frame:IsVisible() then
		return
	end

	local loc_id = frame.ARK_Data.loc_id
	local i = ArkInventory.Frame_Item_GetDB( frame )
	local framename = frame:GetName()

	if arg1 == nil or arg1 == i.bag_id then
	
		obj_name = "Cooldown"
		obj = getglobal( framename .. obj_name )
		assert( obj, string.format( "xml element '%s' is missing the sub element %s", framename, obj_name ) )
	
		if ArkInventory.Global.Location[loc_id].offline then
			obj:Hide()
		else
			ContainerFrame_UpdateCooldown( i.bag_id, frame )
		end
		
	end
	
end

function ArkInventory.Frame_Item_Update_Lock( frame )

	local loc_id = frame.ARK_Data.loc_id
	
	if frame:IsVisible() and not ArkInventory.Global.Location[loc_id].offline then
	
		local i = ArkInventory.Frame_Item_GetDB( frame )
		
		if i.h then
			local _, _, locked, _, readable = GetContainerItemInfo( i.bag_id, i.slot_id )
			frame.readable = readable
			SetItemButtonDesaturated( frame, locked, 0.5, 0.5, 0.5 )
		end
		
	else
	
		frame.readable = false
		
	end
	
end

function ArkInventory.Frame_Item_Update_Clickable( frame )

	local loc_id = frame.ARK_Data.loc_id
	
	if ArkInventory.Global.Mode.Edit or ArkInventory.Global.Location[loc_id].offline then
		-- disable clicks/drag when in edit mode or offline
		frame:RegisterForClicks()
		frame:RegisterForDrag()
	else
		frame:RegisterForClicks( "LeftButtonUp", "RightButtonUp" )
		frame:RegisterForDrag( "LeftButton" )
	end
end
	
function ArkInventory.Frame_Item_OnLoad( frame )

	framename = frame:GetName()
	local loc_id, bag_id, slot_id = strmatch( framename, "^.-(%d+)ContainerBag(%-?%d+)Slot(%d+)" )
	
	assert( loc_id, string.format( "xml element '%s' is not an %s frame", framename, ArkInventory.Const.Program.Name ) )
	assert( bag_id, string.format( "xml element '%s' is not an %s frame", framename, ArkInventory.Const.Program.Name ) )
	assert( slot_id, string.format( "xml element '%s' is not an %s frame", framename, ArkInventory.Const.Program.Name ) )
	
	frame.ARK_Data = {
		["loc_id"] = tonumber( loc_id ),
		["bag_id"] = tonumber( bag_id ),
		["slot_id"] = tonumber( slot_id ),
	}
	
	frame:SetID( slot_id )
	
	ContainerFrameItemButton_OnLoad()
	
	--frame:RegisterEvent( "BAG_UPDATE_COOLDOWN" )
	frame:RegisterEvent( "ITEM_LOCK_CHANGED" )

end






function ArkInventory.Frame_Changer_Player_Update()

	local loc_id = ArkInventory.Const.Location.Bag

	for x = 1, NUM_BAG_SLOTS do
		frame = getglobal( ArkInventory.Const.Program.Frame .. loc_id .. "ChangerWindowBag" .. x )
		if frame then
			ArkInventory.Frame_Changer_Generic_Extra_Update( frame )
		end
	end

end

function ArkInventory.Frame_Changer_Player_Main_OnLoad( frame )

	framename = frame:GetName()
		
	local loc_id = ArkInventory.Const.Location.Bag
	local bag_id = BACKPACK_CONTAINER
	
	frame.ARK_Data = {
		["loc_id"] = tonumber( loc_id ),
		["bag_id"] = tonumber( bag_id ),
	}

	frame:RegisterForClicks( "LeftButtonUp", "RightButtonUp" )
	SetItemButtonTexture( frame, ArkInventory.Global.Location[loc_id].TEXTURE )
	
end

function ArkInventory.Frame_Changer_Player_Main_Update( frame )
	ArkInventory.Frame_Item_Update_Fade( frame )
end

function ArkInventory.Frame_Changer_Player_Main_OnClick( frame )

	loc_id = frame.ARK_Data.loc_id
	
	if ArkInventory.Global.Location[loc_id].offline then
		return
	end

	PutItemInBackpack()
end

function ArkInventory.Frame_Changer_Player_Main_OnEnter( frame )
	ArkInventory.TooltipSetText( frame, BACKPACK_TOOLTIP )
	ArkInventory.BagHighlight( frame, true )
end




function ArkInventory.Frame_Changer_Bank_Update()

	local loc_id = ArkInventory.Const.Location.Bank

	parent = getglobal( ArkInventory.Const.Program.Frame .. loc_id .. "ChangerWindow" )
	
	if not parent:IsVisible() then
		return
	end
	
	for x = 1, NUM_BANKBAGSLOTS do
		frame = getglobal( ArkInventory.Const.Program.Frame .. loc_id .. "ChangerWindowBag" .. x )
		if frame then
			ArkInventory.Frame_Changer_Generic_Extra_Update( frame )
		end
	end

	parent = getglobal( ArkInventory.Const.Program.Frame .. loc_id .. "ChangerWindow" )
	purchaseFrame = getglobal( parent:GetName() .. "PurchaseInfo" )
	
	if ArkInventory.Global.Location[loc_id].offline then
		purchaseFrame:Hide()
		return
	end

	-- update blizzards frame as well because the static dialog box uses the data in it
	UpdateBagSlotStatus()

	-- now mimic that frame
	moneyFrame = purchaseFrame:GetName() .. "DetailMoneyFrame"
	purchaseButton = getglobal( purchaseFrame:GetName() .. "PurchaseButton" )
	
	numSlots, full = GetNumBankSlots()

	-- pass in # of current slots, returns cost of next slot
	cost = GetBankSlotCost( numSlots )
	
	purchaseFrame.nextSlotCost = cost
	if GetMoney() >= cost then
		SetMoneyFrameColor( moneyFrame, 1.0, 1.0, 1.0 )
		purchaseButton:Enable()
	else
		SetMoneyFrameColor( moneyFrame, 1.0, 0.1, 0.1 )
		purchaseButton:Disable()
	end
	MoneyFrame_Update( moneyFrame, cost )

	if full then
		purchaseFrame:Hide()
	else
		purchaseFrame:Show()
	end
	
end

function ArkInventory.Frame_Changer_Bank_Main_OnLoad( frame )

	framename = frame:GetName()
		
	local loc_id = ArkInventory.Const.Location.Bank
	local bag_id = BANK_CONTAINER
	
	frame.ARK_Data = {
		["loc_id"] = tonumber( loc_id ),
		["bag_id"] = tonumber( bag_id ),
	}

	frame:RegisterForClicks( "LeftButtonUp", "RightButtonUp" )
	SetItemButtonTexture( frame, ArkInventory.Global.Location[loc_id].TEXTURE )
	
end

function ArkInventory.Frame_Changer_Bank_Main_Update( frame )
	ArkInventory.Frame_Item_Update_Fade( frame )
end

function ArkInventory.Frame_Changer_Bank_Main_OnClick( frame )

	loc_id = frame.ARK_Data.loc_id
	
	if ArkInventory.Global.Location[loc_id].offline then
		return
	end

	ArkInventory.PutItemInBank()

end

function ArkInventory.Frame_Changer_Bank_Main_OnEnter( frame )
	ArkInventory.TooltipSetText( frame, ArkInventory.Localise["LOCATION_BANK"] )
	ArkInventory.BagHighlight( frame, true )
end








function ArkInventory.Frame_Changer_Generic_Extra_OnLoad( frame )

	framename = frame:GetName()

	loc_id, bag_id = strmatch( framename, "^" .. ArkInventory.Const.Program.Frame .. "(%d+).-(%d+)$" )
	
	loc_id = tonumber( loc_id )
	bag_id = tonumber( bag_id )
	
	if loc_id == ArkInventory.Const.Location.Bag then
	
		inv_id = ContainerIDToInventoryID( bag_id )
		
	elseif loc_id == ArkInventory.Const.Location.Bank then
	
		bag_id = bag_id + NUM_BAG_SLOTS
		inv_id = BankButtonIDToInvSlotID( bag_id, 1 )
		
	end
	
	frame.ARK_Data = {
		["loc_id"] = loc_id,
		["bag_id"] = bag_id,
		["inv_id"] = inv_id,
	}
	
	frame:RegisterForClicks( "LeftButtonUp", "RightButtonUp" )
	frame:RegisterForDrag( "LeftButton" )
	SetItemButtonTexture( frame, ArkInventory.Const.Texture.Empty.Bag )

end

function ArkInventory.Frame_Changer_Generic_Extra_OnClick( frame )
	
	loc_id = frame.ARK_Data.loc_id
	
	if ArkInventory.Global.Location[loc_id].offline then
		return
	end
	
	if not PutItemInBag( frame.ARK_Data.inv_id ) then
		ArkInventory.Frame_Changer_Generic_Extra_OnDragStart( frame )
	end
end

function ArkInventory.Frame_Changer_Generic_Extra_OnDragStart( frame )

	loc_id = frame.ARK_Data.loc_id
	
	if ArkInventory.Global.Location[loc_id].offline then
		return
	end
	
	PickupBagFromSlot( frame.ARK_Data.inv_id )
	PlaySound( "BAGMENUBUTTONPRESS" )
	
end

function ArkInventory.Frame_Changer_Generic_Extra_OnReceiveDrag( frame )

	loc_id = frame.ARK_Data.loc_id
	
	if ArkInventory.Global.Location[loc_id].offline then
		return
	end
	
	ArkInventory.Frame_Changer_Generic_Extra_OnClick( frame )
	
end

function ArkInventory.Frame_Changer_Generic_Extra_OnEnter( frame )

	loc_id = frame.ARK_Data.loc_id
	current_player = ArkInventory.Global.Location[loc_id].player
	bag_id = frame.ARK_Data.bag_id
	inv_id = frame.ARK_Data.inv_id
	
	ArkInventory.TooltipSetPosition( frame )
	
	if ArkInventory.Global.Location[loc_id].offline then
	
		b = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag[bag_id]
	
		if not b or b.count == 0 then
			-- empty slot, do nothing for the tooltip
		else
		
			if b.h then
				GameTooltip:SetHyperlink( b.h )
			else
				GameTooltip:SetText( ArkInventory.Localise["STATUS_NO_DATA"], 1.0, 1.0, 1.0 )
			end
			
		end
		
	else
	
		GameTooltip:SetInventoryItem( "player", inv_id )

	end
	
	CursorUpdate()
	
	ArkInventory.BagHighlight( frame, true )
	
end

function ArkInventory.Frame_Changer_Generic_Extra_Update( frame )

	if not frame:IsVisible() then
		return
	end

	local loc_id = frame.ARK_Data.loc_id
	local current_player = ArkInventory.Global.Location[loc_id].player
	local bag_id = frame.ARK_Data.bag_id
	local inv_id = frame.ARK_Data.inv_id
	
	local b = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag[bag_id]
	
	--ArkInventory.PrintPlus( { "who[", current_player, "].loc[", loc_id, "].bag[", bag_id, "]" } )
	
	if ArkInventory.Global.Location[loc_id].offline then
	
		if not b or b.count == 0 then
		
			SetItemButtonTexture( frame, ArkInventory.Const.Texture.Empty.Bag )
			
		else
		
			if b.h then
				SetItemButtonTexture( frame, ArkInventory.ItemGetTexture( b.h ) )
			else
				SetItemButtonTexture( frame, ArkInventory.Const.Texture.Missing )
			end
			
		end
		
	else
	
		SetItemButtonTexture( frame, GetInventoryItemTexture( "player", inv_id ) or ArkInventory.Const.Texture.Empty.Bag )
		
	end

	if b and b.purchase then
		SetItemButtonTextureVertexColor( frame, 1.0, 0.1, 0.1 )
	else
		SetItemButtonTextureVertexColor( frame, 1.0, 1.0, 1.0 )
	end

	ArkInventory.Frame_Item_Update_Fade( frame )
	
end

function ArkInventory.Frame_Changer_Generic_OnLeave( frame )
	GameTooltip:Hide()
	ResetCursor()
	ArkInventory.BagHighlight( frame, false )
end



function ArkInventory.BagHighlight( frame, show )
	
	local loc_id = frame.ARK_Data.loc_id
	local bag_id = frame.ARK_Data.bag_id
	
	if loc_id and bag_id ~= nil then
	
		local current_player = ArkInventory.Global.Location[loc_id].player
		
		local b = ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag[bag_id]
		if not b then
			return
		end
			
		local name = ArkInventory.Const.Program.Frame .. loc_id .. "ContainerBag" .. bag_id
		local frame = getglobal( name )
		if not frame then
			return
		end

		local colour = ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "baghighlight" } )

		for slot_id in pairs( b.slot ) do
			obj = getglobal( name .. "Slot" .. slot_id .. "ArkHighlight" )
			if obj then
				if show then
					getglobal( obj:GetName() .. "Background" ):SetTexture( colour.r, colour.g, colour.b, 0.3 )
					obj:Show()
				else
					obj:Hide()
				end
			end
			
		end
	
	end
	
end






function ArkInventory.UiItem_Empty()

	for loc_id, loc_data in pairs( ArkInventory.Global.Location ) do
	
		c = getglobal( ArkInventory.Const.Program.Frame .. loc_id .. "Container" )
		if c and c:IsVisible() then
	
			current_player = ArkInventory.Global.Location[loc_id].player
			for _, bag_id in pairs( loc_data.BAGS ) do
			
				for slot_id in pairs( ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag[bag_id].slot ) do
					s = getglobal( c:GetName() .. "Bag" .. bag_id .. "Slot" .. slot_id )
					ArkInventory.Frame_Item_Update_Empty( s )
				end
				
			end
			
		end
		
	end
	
end


function ArkInventory.UiGlobal_NewItemIndicator()

	for loc_id, loc_data in pairs( ArkInventory.Global.Location ) do
	
		c = getglobal( ArkInventory.Const.Program.Frame .. loc_id .. "Container" )
		if c and c:IsVisible() then
	
			current_player = ArkInventory.Global.Location[loc_id].player
			for _, bag_id in pairs( loc_data.BAGS ) do
			
				for slot_id in pairs( ArkInventory.db.account.cache.who[current_player].loc[loc_id].bag[bag_id].slot ) do
					s = getglobal( c:GetName() .. "Bag" .. bag_id .. "Slot" .. slot_id )
					if s and s:IsVisible() then
						ArkInventory.Frame_Item_Update_NewIndicator( s )
					end
				end
				
			end
			
		end
		
	end
	
end




function ArkInventory.MenuMainOpen( frame )

	if not frame then
		frame = this
	end

	assert( frame, "frame is nil" )
	assert( frame.ARK_Data, "not an " .. ArkInventory.Const.Program.Name .. " frame" )

	if ArkInventory.Lib.DewDrop:IsOpen( this ) then
	
		ArkInventory.Lib.DewDrop:Close()
	
	else

		local loc_id = frame.ARK_Data.loc_id
		local current_player = ArkInventory.Global.Location[loc_id].player
	
		local base_options = { type = "group", args = {} }
		ArkInventory.Lib.DewDrop:InjectAceOptionsTable( ArkInventory, base_options )
	
		local x, p, rp
		x = this:GetLeft() + ( this:GetRight() - this:GetLeft() ) / 2
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			p = "TOPRIGHT"
			rp = "TOPLEFT"
		else
			p = "TOPLEFT"
			rp = "TOPRIGHT"
		end
	
		ArkInventory.Lib.DewDrop:Open( this,
			"point", p,
			"relativePoint", rp,
			"children", function( level, value )
			
				if level == 1 then
			
					
					ArkInventory.Lib.DewDrop:AddLine( "text", string.format( "%1$s v%2$.2f", ArkInventory.Const.Program.Name, ArkInventory.Const.Program.Version ),
						"isTitle", true,
						"textHeight", 14
					)
					
					if ArkInventory.Const.Program.Beta ~= nil then
						ArkInventory.Lib.DewDrop:AddLine( "text", string.format( "%s(beta %s)", RED_FONT_COLOR_CODE, ArkInventory.Const.Program.Beta ),
							"nonClickable", true
						)
					end

					ArkInventory.Lib.DewDrop:AddLine()
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_SWITCH_CHARACTER"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_SWITCH_CHARACTER"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_SWITCH_CHARACTER_TEXT"],
						"hasArrow", true,
						"value", "SWITCH_CHARACTER"
					)
					
					ArkInventory.Lib.DewDrop:AddLine()
					ArkInventory.Lib.DewDrop:AddLine(	"text", ArkInventory.Localise["MOD_MENU_MAIN_GLOBAL_SETTINGS"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_GLOBAL_SETTINGS"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_GLOBAL_SETTINGS_TEXT"],
						"checked", ArkInventory.db.profile.option.useglobal,
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
							ArkInventory.db.profile.option.useglobal = not ArkInventory.db.profile.option.useglobal
							ArkInventory.Frame_Main_Generate_RecalcAll()
						end
					)

					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW"],
						"hasArrow", true,
						"value", "WINDOW"
					)
	
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_BARS"],
						"hasArrow", true,
						"value", "BARS"
					)
					
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS"],
						"hasArrow", true,
						"value", "ITEMS"
					)
					
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_SORTING"],
						"hasArrow", true,
						"value", "SORTING"
					)
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY"],
						"hasArrow", true,
						"value", "EMPTY"
					)
					
					
					ArkInventory.Lib.DewDrop:AddLine()
				
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_OFFLINE"],
						"hasArrow", true,
						"value", "OFFLINE"
					)

					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_HIDDEN"],
						"hasArrow", true,
						"value", "HIDDEN"
					)
					
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO"],
						"hasArrow", true,
						"value", "AUTO"
					)
					
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_NEWITEM"],
						"hasArrow", true,
						"value", "NEWITEM"
					)
					
					
					ArkInventory.Lib.DewDrop:AddLine()
					
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_REFRESH"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_REFRESH"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_REFRESH_TEXT"],
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
							ArkInventory.Frame_Main_Generate_RecalcAll()
						end
					)
					
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_RELOAD"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_RELOAD"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_RELOAD_TEXT"],
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
							ArkInventory.ItemCacheClear()
							ArkInventory.Frame_Main_Generate_RecalcAll()
						end
					)
					
					ArkInventory.Lib.DewDrop:AddLine(	"text", ArkInventory.Localise["MOD_MENU_MAIN_EDITMODE"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_EDITMODE"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_EDITMODE_TEXT"],
						"checked", ArkInventory.Global.Mode.Edit,
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
							ArkInventory.ToggleEditMode()
						end
					)

					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_BAGCHANGE"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_BAGCHANGE"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BAGCHANGE_TEXT"],
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
							ArkInventory.ToggleChanger()
						end
					)

					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_COMPRESS"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_COMPRESS"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_COMPRESS_TEXT"],
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
							Restack.Start( loc_id )
						end
					)

					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_RULES"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_RULES"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_RULES_TEXT"],
						"func", function()
							ARKINV_Rules:Show()
							ArkInventory.Lib.DewDrop:Close()
						end
					)

					ArkInventory.Lib.DewDrop:AddLine()
					-- leaves space on the end for the base options
					
				end


				if level == 2 and value then
				
					if value == "SWITCH_CHARACTER" then

						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_SWITCH_CHARACTER"] ),
							"isTitle", true,
							"textHeight", 12
						)
						ArkInventory.Lib.DewDrop:AddLine()
						
						if ArkInventory.Table.Elements( ArkInventory.db.account.cache.who ) == 1 then

							ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_SWITCH_CHARACTER_CHOOSE_NONE"],
								"disabled", true
							)
		
						else
							
							local c = ArkInventory.db.account.cache.who --~~~~ check
							
							for k, v in ArkInventory.spairs( c, function(a,b) return ( c[a].fullname or ArkInventory.Localise["STATUS_NO_DATA"] ) < ( c[b].fullname or ArkInventory.Localise["STATUS_NO_DATA"] ) end ) do
						
								local n = v.fullname or v.id or v.name or ArkInventory.Localise["STATUS_NO_DATA"]
								if v.id == ArkInventory.Global.Me.id then
									n = GREEN_FONT_COLOR_CODE .. n .. FONT_COLOR_CODE_CLOSE
								end

								if k ~= current_player then
									ArkInventory.Lib.DewDrop:AddLine(	"text", n,
										"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_SWITCH_CHARACTER"],
										"tooltipText", string.format( ArkInventory.Localise["MOD_MENU_MAIN_SWITCH_CHARACTER_CHOOSE_TEXT"], n ),
										"hasArrow", k ~= ArkInventory.Global.Me.id,
										"func", function()
											ArkInventory.Lib.DewDrop:Close()
											--ArkInventory.PrintPlus( { "change location [", loc_id, "] to [", k, "]" } )
											ArkInventory.Frame_Main_Show( loc_id, k )
										end,
										"value", ( "SWITCH_CHARACTER_" .. k )
									)
								end
								
							end
						
						end

					end

					
					if value == "WINDOW" then
					
						local n = string.upper( ArkInventory.Localise["MOD_MENU_MAIN_WINDOW"] )
						if not ArkInventory.db.profile.option.useglobal then
							n = n .. " [" .. GREEN_FONT_COLOR_CODE .. string.upper( ArkInventory.Global.Location[loc_id].NAME ) .. FONT_COLOR_CODE_CLOSE .. "]"
						end
						ArkInventory.Lib.DewDrop:AddLine( "text", n,
							"isTitle", true,
							"textHeight", 12
						)

						ArkInventory.Lib.DewDrop:AddLine()



						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_ANCHOR"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_ANCHOR_TEXT"],
							"hasArrow", true,
							"value", "WINDOW_ANCHOR"
						)
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_SCALE"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_SCALE"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_SCALE_TEXT"],
							"hasArrow", true,
							"hasSlider", true,
							"sliderIsPercent", true,
							"sliderValue", ArkInventory.OptionLocalGet( loc_id, { "window", "scale" } ),
							"sliderMin", 0.4,
							"sliderMax", 2,
							"sliderStep", 0.05,
							"sliderFunc", function( v )
								if v ~= ArkInventory.OptionLocalGet( loc_id, { "window", "scale" } ) then
									ArkInventory.OptionLocalSet( loc_id, { "window", "scale" }, v )
									ArkInventory.Frame_Main_Scale_All()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_PADDING"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_PADDING"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_PADDING_TEXT"],
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", ArkInventory.OptionLocalGet( loc_id, { "window", "pad" } ),
							"sliderMin", 4,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= ArkInventory.OptionLocalGet( loc_id, { "window", "pad" } ) then
									ArkInventory.OptionLocalSet( loc_id, { "window", "pad" }, v )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_WIDTH"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_WIDTH"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_WIDTH_TEXT"],
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", ArkInventory.OptionLocalGet( loc_id, { "window", "width" } ),
							"sliderMin", 8,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= ArkInventory.OptionLocalGet( loc_id, { "window", "width" } ) then
									ArkInventory.OptionLocalSet( loc_id, { "window", "width" }, v )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BACKGROUND_COLOR"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BACKGROUND_COLOR"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BACKGROUND_COLOR_TEXT"],
							"hasColorSwatch", true,
							"hasOpacity", true,
							"r", ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "background", "r" } ),
							"g", ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "background", "g" } ),
							"b", ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "background", "b" } ),
							"opacity", ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "background", "a" } ),
							"colorFunc", function( r, g, b, a )
								ArkInventory.OptionLocalSet( loc_id, { "window", "colour", "background", "r" }, r )
								ArkInventory.OptionLocalSet( loc_id, { "window", "colour", "background", "g" }, g )
								ArkInventory.OptionLocalSet( loc_id, { "window", "colour", "background", "b" }, b )
								ArkInventory.OptionLocalSet( loc_id, { "window", "colour", "background", "a" }, a )
								ArkInventory.Frame_Main_Paint_All()
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BORDER"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BORDER"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BORDER_TEXT"],
							"checked", ArkInventory.OptionLocalGet( loc_id, { "window", "border" } ),
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "window", "border" }, not ArkInventory.OptionLocalGet( loc_id, { "window", "border" } ) )
								ArkInventory.Frame_Main_Paint_All()
							end
						)
						if ArkInventory.OptionLocalGet( loc_id, { "window", "border" } ) then
							ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BORDER_COLOR"],
								"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BORDER_COLOR"],
								"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BORDER_COLOR_TEXT"],
								"hasColorSwatch", true,
								"r", ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "border", "r" } ),
								"g", ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "border", "g" } ),
								"b", ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "border", "b" } ),
								"colorFunc", function( r, g, b )
									ArkInventory.OptionLocalSet( loc_id, { "window", "colour", "border", "r" }, r )
									ArkInventory.OptionLocalSet( loc_id, { "window", "colour", "border", "g" }, g )
									ArkInventory.OptionLocalSet( loc_id, { "window", "colour", "border", "b" }, b )
									ArkInventory.Frame_Main_Paint_All()
								end
							)
						end
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BAGHIGHLIGHT_COLOR"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BAGHIGHLIGHT_COLOR"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_BAGHIGHLIGHT_COLOR_TEXT"],
							"hasColorSwatch", true,
							"hasOpacity", false,
							"r", ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "baghighlight", "r" } ),
							"g", ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "baghighlight", "g" } ),
							"b", ArkInventory.OptionLocalGet( loc_id, { "window", "colour", "baghighlight", "b" } ),
							"colorFunc", function( r, g, b )
								ArkInventory.OptionLocalSet( loc_id, { "window", "colour", "baghighlight", "r" }, r )
								ArkInventory.OptionLocalSet( loc_id, { "window", "colour", "baghighlight", "g" }, g )
								ArkInventory.OptionLocalSet( loc_id, { "window", "colour", "baghighlight", "b" }, b )
							end
						)
					
					end
					
					
					if value == "BARS" then
						
						local n = string.upper( ArkInventory.Localise["MOD_MENU_MAIN_BARS"] )
						if not ArkInventory.db.profile.option.useglobal then
							n = n .. " [" .. GREEN_FONT_COLOR_CODE .. string.upper( ArkInventory.Global.Location[loc_id].NAME ) .. FONT_COLOR_CODE_CLOSE .. "]"
						end
						ArkInventory.Lib.DewDrop:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						ArkInventory.Lib.DewDrop:AddLine()
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_BARS_ANCHOR"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_BARS_ANCHOR"],
							"hasArrow", true,
							"value", "BAR_ANCHOR"
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_BARS_DIRECTION"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_BARS_DIRECTION"],
							"hasArrow", true,
							"value", "BAR_DIRECTION"
						)
						ArkInventory.Lib.DewDrop:AddLine(	"text", ArkInventory.Localise["MOD_MENU_MAIN_BARS_PER_ROW"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_BARS_PER_ROW"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_PER_ROW_TEXT"],
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", ArkInventory.OptionLocalGet( loc_id, { "bar", "per" } ),
							"sliderMin", 1,
							"sliderMax", 16,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= ArkInventory.OptionLocalGet( loc_id, { "bar", "per" } ) then
									ArkInventory.OptionLocalSet( loc_id, { "bar", "per" }, v )
									ArkInventory.Frame_Main_Generate_RefreshAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_BARS_PADDING"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_BARS_PADDING"],
							"hasArrow", true,
							"value", "BAR_PADDING"
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_BARS_COMPACT"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_BARS_COMPACT"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_COMPACT_TEXT"],
							"checked", ArkInventory.OptionLocalGet( loc_id, { "bar", "compact" } ),
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "bar", "compact" }, not ArkInventory.OptionLocalGet( loc_id, { "bar", "compact" } ) )
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_BARS_SHOW_EMPTY"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_BARS_SHOW_EMPTY"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_SHOW_EMPTY_TEXT"],
							"checked", ArkInventory.OptionLocalGet( loc_id, { "bar", "showempty" } ),
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "bar", "showempty" }, not ArkInventory.OptionLocalGet( loc_id, { "bar", "showempty" } ) )
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						)

						ArkInventory.Lib.DewDrop:AddLine()

--						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_BARS_HIDE"],
--							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_BARS_HIDE"],
--							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_HIDE_TEXT"],
--							"checked", ArkInventory.OptionLocalGet( loc_id, { "bar", "hide" } ),
--							"func", function()
--								ArkInventory.OptionLocalSet( loc_id, { "bar", "hide" }, not ArkInventory.OptionLocalGet( loc_id, { "bar", "hide" } ) )
--								ArkInventory.Frame_Bar_Paint_All()
--							end
--						)
						
--						if not ArkInventory.OptionLocalGet( loc_id, { "bar", "hide" } ) then
						
							ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_BARS_BACKGROUND"],
								"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_BARS_BACKGROUND"],
								"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_BACKGROUND_TEXT"],
								"hasColorSwatch", true,
								"hasOpacity", true,
								"r", ArkInventory.OptionLocalGet( loc_id, { "bar", "colour", "background", "r" } ),
								"g", ArkInventory.OptionLocalGet( loc_id, { "bar", "colour", "background", "g" } ),
								"b", ArkInventory.OptionLocalGet( loc_id, { "bar", "colour", "background", "b" } ),
								"opacity", ArkInventory.OptionLocalGet( loc_id, { "bar", "colour", "background", "a" } ),
								"colorFunc", function( r, g, b, a )
									ArkInventory.OptionLocalSet( loc_id, { "bar", "colour", "background", "r" }, r )
									ArkInventory.OptionLocalSet( loc_id, { "bar", "colour", "background", "g" }, g )
									ArkInventory.OptionLocalSet( loc_id, { "bar", "colour", "background", "b" }, b )
									ArkInventory.OptionLocalSet( loc_id, { "bar", "colour", "background", "a" }, a )
									ArkInventory.Frame_Bar_Paint_All()
								end
							)
							
							ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_BARS_BORDER"],
								"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_BARS_BORDER"],
								"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_BORDER_TEXT"],
								"checked", ArkInventory.OptionLocalGet( loc_id, { "bar", "border" } ),
								"func", function()
									ArkInventory.OptionLocalSet( loc_id, { "bar", "border" }, not ArkInventory.OptionLocalGet( loc_id, { "bar", "border" } ) )
									ArkInventory.Frame_Bar_Paint_All()
								end
							)
							if ArkInventory.OptionLocalGet( loc_id, { "bar", "border" } ) then
								ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_BARS_BORDER_COLOUR"],
									"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_BARS_BORDER_COLOUR"],
									"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_BORDER_COLOUR_TEXT"],
									"hasColorSwatch", true,
									"r", ArkInventory.OptionLocalGet( loc_id, { "bar", "colour", "border", "r" } ),
									"g", ArkInventory.OptionLocalGet( loc_id, { "bar", "colour", "border", "g" } ),
									"b", ArkInventory.OptionLocalGet( loc_id, { "bar", "colour", "border", "b" } ),
									"colorFunc", function( r, g, b )
										ArkInventory.OptionLocalSet( loc_id, { "bar", "colour", "border", "r" }, r )
										ArkInventory.OptionLocalSet( loc_id, { "bar", "colour", "border", "g" }, g )
										ArkInventory.OptionLocalSet( loc_id, { "bar", "colour", "border", "b" }, b )
										ArkInventory.Frame_Bar_Paint_All()
									end
								)
							end
							
						end
						
--					end
					
					
					if value == "ITEMS" then
					
						local n = string.upper( ArkInventory.Localise["MOD_MENU_MAIN_ITEMS"] )
						if not ArkInventory.db.profile.option.useglobal then
							n = n .. " [" .. GREEN_FONT_COLOR_CODE .. string.upper( ArkInventory.Global.Location[loc_id].NAME ) .. FONT_COLOR_CODE_CLOSE .. "]"
						end
						ArkInventory.Lib.DewDrop:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						ArkInventory.Lib.DewDrop:AddLine()
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_PADDING"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_PADDING"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_PADDING_TEXT"],
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", ArkInventory.OptionLocalGet( loc_id, { "slot", "pad" } ),
							"sliderMin", 1,
							"sliderMax", 16,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if ArkInventory.OptionLocalGet( loc_id, { "slot", "pad" } ) ~= v then
									ArkInventory.OptionLocalSet( loc_id, { "slot", "pad" }, v )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_BORDER"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_BORDER"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_BORDER_TEXT"],
							"checked", ArkInventory.OptionLocalGet( loc_id, { "slot", "border" } ),
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "slot", "border" }, not ArkInventory.OptionLocalGet( loc_id, { "slot", "border" } ) )
								ArkInventory.Frame_Main_Generate_RefreshAll()
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_HIDDEN"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_HIDDEN"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_HIDDEN_TEXT"],
							"checked", ArkInventory.OptionLocalGet( loc_id, { "slot", "ignorehidden" } ),
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "slot", "ignorehidden" }, not ArkInventory.OptionLocalGet( loc_id, { "slot", "ignorehidden" } ) )
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						)
		
					end
					
					
					if value == "SORTING" then

						local n = string.upper( ArkInventory.Localise["MOD_MENU_MAIN_SORTING"] )
						if not ArkInventory.db.profile.option.useglobal then
							n = n .. " [" .. GREEN_FONT_COLOR_CODE .. string.upper( ArkInventory.Global.Location[loc_id].NAME ) .. FONT_COLOR_CODE_CLOSE .. "]"
						end
						ArkInventory.Lib.DewDrop:AddLine( "text", n,
							"isTitle", true,
							"textHeight", 12
						)
						ArkInventory.Lib.DewDrop:AddLine()

						ArkInventory.Lib.DewDrop:AddLine(	"text", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INSTANT"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INSTANT"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INSTANT_TEXT"],
							"checked", ArkInventory.OptionLocalGet( loc_id, { "sort", "instant" } ),
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "sort", "instant" }, not ArkInventory.OptionLocalGet( loc_id, { "sort", "instant" } ) )
								ArkInventory.ItemSortKeyRegenerate( loc_id )
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						)
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_BAGSLOT"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_BAGSLOT"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_BAGSLOT_TEXT"],
							"isRadio", true,
							"checked", ArkInventory.OptionLocalGet( loc_id, { "sort", "bagslot" } ),
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "sort", "bagslot" }, not ArkInventory.OptionLocalGet( loc_id, { "sort", "bagslot" } ) )
								ArkInventory.ItemSortKeyRegenerate( loc_id )
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_USER"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_USER"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_USER_TEXT"],
							"isRadio", true,
							"checked", not ArkInventory.OptionLocalGet( loc_id, { "sort", "bagslot" } ),
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "sort", "bagslot" }, not ArkInventory.OptionLocalGet( loc_id, { "sort", "bagslot" } ) )
								ArkInventory.ItemSortKeyRegenerate( loc_id )
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						)

						ArkInventory.Lib.DewDrop:AddLine()
						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_SORTING_ORDER"] ), "isTitle", true, "textHeight", 12 )
						
						for k, v in ipairs( ArkInventory.OptionLocalGet( loc_id, { "sortorder" } ) ) do
						
							if ArkInventory.Const.SortKeys[v] then
								local checked = ArkInventory.OptionLocalGet( loc_id, { "sort", v } )
								local disabled = ArkInventory.OptionLocalGet( loc_id, { "sort", "bagslot" } )
								local n = ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INCLUDE_" .. string.upper( v )]
								local tt_text = ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INCLUDE_" .. string.upper( v ) .. "_TEXT"]
								
								if not disabled then
									if checked then
										n = GREEN_FONT_COLOR_CODE .. n .. FONT_COLOR_CODE_CLOSE
									else
										n = RED_FONT_COLOR_CODE .. n .. FONT_COLOR_CODE_CLOSE
										tt_text = tt_text .. "\n\n" .. RED_FONT_COLOR_CODE .. ArkInventory.Localise["MOD_MENU_MAIN_SORTING_NOT_INCLUDED"]
									end
								end
								
								ArkInventory.Lib.DewDrop:AddLine( "text", n,
									"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INCLUDE_" .. string.upper( v )],
									"tooltipText", tt_text,
									"checked", checked,
									"disabled", disabled,
									"hasArrow", not disabled,
									"value", "SORT_ORDER_" .. v,
									"func", function()
										ArkInventory.OptionLocalSet( loc_id, { "sort", v }, not checked )
										ArkInventory.ItemSortKeyRegenerate( loc_id )
										ArkInventory.Frame_Main_Generate_RecalcAll() --~~~~ should just resort, not recalc
									end
								)
							end
						
						end
						
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INCLUDE_REVERSE"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INCLUDE_REVERSE"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INCLUDE_REVERSE_TEXT"],
							"checked", ArkInventory.OptionLocalGet( loc_id, { "sort", "reversed" } ),
							"disabled", ArkInventory.OptionLocalGet( loc_id, { "sort", "bagslot" } ) or not ArkInventory.OptionLocalGet( loc_id, { "sort", "name" } ),
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "sort", "reversed" }, not ArkInventory.OptionLocalGet( loc_id, { "sort", "reversed" } ) )
								ArkInventory.ItemSortKeyRegenerate( loc_id )
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						)

					end
					
					
					if value == "EMPTY" then

						local n = string.upper( ArkInventory.Localise["MOD_MENU_MAIN_EMPTY"] )
						if not ArkInventory.db.profile.option.useglobal then
							n = n .. " [" .. GREEN_FONT_COLOR_CODE .. string.upper( ArkInventory.Global.Location[loc_id].NAME ) .. FONT_COLOR_CODE_CLOSE .. "]"
						end
						ArkInventory.Lib.DewDrop:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						ArkInventory.Lib.DewDrop:AddLine()
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_ICON"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_ICON"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_ICON_TEXT"],
							"checked", ArkInventory.OptionLocalGet( loc_id, { "slot", "empty", "icon" } ) == true,
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "slot", "empty", "icon" }, not ArkInventory.OptionLocalGet( loc_id, { "slot", "empty", "icon" } ) )
								--ArkInventory.Frame_Main_Generate_RecalcAll()
								ArkInventory.UiItem_Empty()
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_BORDER"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_BORDER"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_BORDER_TEXT"],
							"checked", ArkInventory.OptionLocalGet( loc_id, { "slot", "empty", "border" } ) == true,
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "slot", "empty", "border" }, not ArkInventory.OptionLocalGet( loc_id, { "slot", "empty", "border" } ) )
								ArkInventory.UiItem_Empty()
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_COLOUR"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_COLOUR"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_COLOUR_TEXT"],
							"hasArrow", true,
							"value", "EMPTY_COLOUR"
						)
						
						ArkInventory.Lib.DewDrop:AddLine()
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_CLUMP"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_CLUMP"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_CLUMP_TEXT"],
							"checked", ArkInventory.OptionLocalGet( loc_id, { "slot", "empty", "clump" } ),
							"func", function()
								ArkInventory.OptionLocalSet( loc_id, { "slot", "empty", "clump" }, not ArkInventory.OptionLocalGet( loc_id, { "slot", "empty", "clump" } ) )
								ArkInventory.ItemCacheClear()
								--ArkInventory.ItemCategoryReloadEmpty()
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						)
					
					end
					
					
					if value == "OFFLINE" then

						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_OFFLINE"] ), "isTitle", true, "textHeight", 12 )
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_OFFLINE_BAG"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_OFFLINE_BAG"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_OFFLINE_BAG_TEXT"],
							"checked", ArkInventory.db.account.option.offline.alt,
							"func", function()
								ArkInventory.db.account.option.offline.alt = not ArkInventory.db.account.option.offline.alt
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_OFFLINE_BANK"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_OFFLINE_BANK"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_OFFLINE_BANK_TEXT"],
							"checked", ArkInventory.db.account.option.offline.bank,
							"func", function()
								ArkInventory.db.account.option.offline.bank = not ArkInventory.db.account.option.offline.bank
							end
						)
						ArkInventory.Lib.DewDrop:AddLine()
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_FADE"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_FADE"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_ITEMS_FADE_TEXT"],
							"checked", ArkInventory.db.account.option.offline.fade,
							"func", function()
								ArkInventory.db.account.option.offline.fade = not ArkInventory.db.account.option.offline.fade
								ArkInventory.Frame_Main_Generate_RefreshAll()
							end
						)
					
					end
					
					
					if value == "HIDDEN" then

						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_HIDDEN"] ), "isTitle", true, "textHeight", 12 )
						
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_HIDDEN_TITLE"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_HIDDEN_TITLE"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_HIDDEN_TITLE_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.framehide.header,
							"func", function()
								ArkInventory.db.account.option.framehide.header = not ArkInventory.db.account.option.framehide.header
								ArkInventory.Frame_Main_Generate_InitAll()
							end
						)
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_HIDDEN_STATUS"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_HIDDEN_STATUS"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_HIDDEN_STATUS_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.framehide.status,
							"func", function()
								ArkInventory.db.account.option.framehide.status = not ArkInventory.db.account.option.framehide.status
								ArkInventory.Frame_Main_Generate_InitAll()
							end
						)
						
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_HIDDEN_BLIZZARD"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_HIDDEN_BLIZZARD"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_HIDDEN_BLIZZARD_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.framehide.blizzard,
							"func", function()
								ArkInventory.db.account.option.framehide.blizzard = not ArkInventory.db.account.option.framehide.blizzard
								ArkInventory.HookBlizzardAPI()
							end
						)

						
					end
					
					
					if value == "AUTO" then
					
						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_AUTO"] ), "isTitle", true, "textHeight", 12 )
						ArkInventory.Lib.DewDrop:AddLine()
					
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_OPEN"],
							"hasArrow", true,
							"value", "AUTO_OPEN"
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_CLOSE"],
							"hasArrow", true,
							"value", "AUTO_CLOSE"
						)

					end
					
					
					if value == "NEWITEM" then
					
						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_NEWITEM"] ), "isTitle", true, "textHeight", 12 )
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_NEWITEM_SHOW"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_NEWITEM_SHOW"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_NEWITEM_SHOW_TEXT"],
							"checked", ArkInventory.db.account.option.newitem.show,
							"func", function()
								ArkInventory.db.account.option.newitem.show = not ArkInventory.db.account.option.newitem.show
								ArkInventory.UiGlobal_NewItemIndicator()
							end
						)
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_NEWITEM_COLOUR"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_NEWITEM_COLOUR"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_NEWITEM_COLOUR_TEXT"],
							"hasColorSwatch", true,
							"r", ArkInventory.db.account.option.newitem.colour.r,
							"g", ArkInventory.db.account.option.newitem.colour.g,
							"b", ArkInventory.db.account.option.newitem.colour.b,
							"colorFunc", function( r, g, b )
								ArkInventory.db.account.option.newitem.colour.r = r
								ArkInventory.db.account.option.newitem.colour.g = g
								ArkInventory.db.account.option.newitem.colour.b = b
								ArkInventory.UiGlobal_NewItemIndicator()
							end
						)
						
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_NEWITEM_RESET"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_NEWITEM_RESET"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_NEWITEM_RESET_TEXT"],
							"func", function()
								ArkInventory.Lib.DewDrop:Close()
								ArkInventory.NewItemReset( loc_id )
								ArkInventory.UiGlobal_NewItemIndicator()
							end
						)
						
					end
					
				end


				if level == 3 and value then
				
					if strsub( value, 1, 17 ) == "SWITCH_CHARACTER_" then
					
						local k = strmatch( value, "^SWITCH_CHARACTER_(.+)" )
						local fn = ArkInventory.db.account.cache.who[k].fullname or k
						
						ArkInventory.Lib.DewDrop:AddLine( "text", fn,
							"isTitle", true,
							"textHeight", 12
						)
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine(	"text", RED_FONT_COLOR_CODE .. ArkInventory.Localise["MOD_MENU_MAIN_SWITCH_CHARACTER_ERASE"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_SWITCH_CHARACTER_ERASE"],
							"tooltipText", RED_FONT_COLOR_CODE .. format( ArkInventory.Localise["MOD_MENU_MAIN_SWITCH_CHARACTER_ERASE_TEXT"], fn ),
							"func", function()
								ArkInventory.Lib.DewDrop:Close()
								ArkInventory.Frame_Main_Hide()
								ArkInventory.db.account.cache.who[k] = nil
								ArkInventory.Frame_Main_Generate_Recalc( loc_id )
							end
						)	

					end

					
					if value == "WINDOW_ANCHOR" then
					
						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_WINDOW_ANCHOR"] ),
							"isTitle", true,
							"textHeight", 12
						)
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", "BOTTOMRIGHT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the bottom right",
							"disabled", true,
							"isRadio", true,
							"checked", ArkInventory.OptionLocalGet( loc_id, { "window", "anchor" } ) == ArkInventory.Const.Anchor.BottomRight,
							"func", function()
								if ArkInventory.OptionLocalGet( loc_id, { "window", "anchor" } ) ~= ArkInventory.Const.Anchor.BottomRight then
									ArkInventory.Frame_Main_Anchor( loc_id, ArkInventory.Const.Anchor.BottomRight )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", "BOTTOMLEFT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the bottom left",
							"disabled", true,
							"isRadio", true,
							"checked", ArkInventory.OptionLocalGet( loc_id, { "window", "anchor" } ) == ArkInventory.Const.Anchor.BottomLeft,
							"func", function()
								if ArkInventory.OptionLocalGet( loc_id, { "window", "anchor" } ) ~= ArkInventory.Const.Anchor.BottomLeft then
									ArkInventory.Frame_Main_Anchor( loc_id, ArkInventory.Const.Anchor.BottomLeft )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", "TOPLEFT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the top left",
							"isRadio", true,
							"checked", ArkInventory.OptionLocalGet( loc_id, { "window", "anchor" } ) == ArkInventory.Const.Anchor.TopLeft,
							"func", function()
								if ArkInventory.OptionLocalGet( loc_id, { "window", "anchor" } ) ~= ArkInventory.Const.Anchor.TopLeft then
									ArkInventory.Frame_Main_Anchor( loc_id, ArkInventory.Const.Anchor.TopLeft )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", "TOPRIGHT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the top right",
							"disabled", true,
							"isRadio", true,
							"checked", ArkInventory.OptionLocalGet( loc_id, { "window", "anchor" } ) == ArkInventory.Const.Anchor.TopRight,
							"func", function()
								if ArkInventory.OptionLocalGet( loc_id, { "window", "anchor" } ) ~= ArkInventory.Const.Anchor.TopRight then
									ArkInventory.Frame_Main_Anchor( loc_id, ArkInventory.Const.Anchor.TopRight )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
					end
					
					
					if value == "BAR_PADDING" then
					
						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_BARS_PADDING"] ), "isTitle", true, "textHeight", 12 )
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", "Internal",
							"tooltipTitle", "Internal Padding",
							"tooltipText", "the amount of space to add between the bars and the items",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", ArkInventory.OptionLocalGet( loc_id, { "bar", "pad", "internal" } ),
							"sliderMin", 4,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= ArkInventory.OptionLocalGet( loc_id, { "bar", "pad", "internal" } ) then
									ArkInventory.OptionLocalSet( loc_id, { "bar", "pad", "internal" }, v )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", "External",
							"tooltipTitle", "External Padding",
							"tooltipText", "the amount of space to add between bars",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", ArkInventory.OptionLocalGet( loc_id, { "bar", "pad", "external" } ),
							"sliderMin", 0,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= ArkInventory.OptionLocalGet( loc_id, { "bar", "pad", "external" } ) then
									ArkInventory.OptionLocalSet( loc_id, { "bar", "pad", "external" }, v )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
					end
				
					if value == "BAR_ANCHOR" then
					
						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_BARS_ANCHOR"] ), "isTitle", true, "textHeight", 12 )
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_GENERIC_BOTTOMRIGHT"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_GENERIC_BOTTOMRIGHT"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_ANCHOR_BOTTOMRIGHT_TEXT"],
							"isRadio", true,
							"checked", ArkInventory.OptionLocalGet( loc_id, { "bar", "anchor" } ) == ArkInventory.Const.Anchor.BottomRight,
							"func", function()
								if ArkInventory.OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= ArkInventory.Const.Anchor.BottomRight then
									ArkInventory.OptionLocalSet( loc_id, { "bar", "anchor" }, ArkInventory.Const.Anchor.BottomRight )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_GENERIC_BOTTOMLEFT"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_GENERIC_BOTTOMLEFT"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_ANCHOR_BOTTOMLEFT_TEXT"],
							"isRadio", true,
							"checked", ArkInventory.OptionLocalGet( loc_id, { "bar", "anchor" } ) == ArkInventory.Const.Anchor.BottomLeft,
							"func", function()
								if ArkInventory.OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= ArkInventory.Const.Anchor.BottomLeft then
									ArkInventory.OptionLocalSet( loc_id, { "bar", "anchor" }, ArkInventory.Const.Anchor.BottomLeft )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_GENERIC_TOPLEFT"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_GENERIC_TOPLEFT"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_ANCHOR_TOPLEFT_TEXT"],
							"isRadio", true,
							"checked", ArkInventory.OptionLocalGet( loc_id, { "bar", "anchor" } ) == ArkInventory.Const.Anchor.TopLeft,
							"func", function()
								if ArkInventory.OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= ArkInventory.Const.Anchor.TopLeft then
									ArkInventory.OptionLocalSet( loc_id, { "bar", "anchor" }, ArkInventory.Const.Anchor.TopLeft )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_GENERIC_TOPRIGHT"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_GENERIC_TOPRIGHT"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_ANCHOR_TOPRIGHT_TEXT"],
							"isRadio", true,
							"checked", ArkInventory.OptionLocalGet( loc_id, { "bar", "anchor" } ) == ArkInventory.Const.Anchor.TopRight,
							"func", function()
								if ArkInventory.OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= ArkInventory.Const.Anchor.TopRight then
									ArkInventory.OptionLocalSet( loc_id, { "bar", "anchor" }, ArkInventory.Const.Anchor.TopRight )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
					end
				
					if value == "BAR_DIRECTION" then
					
						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_BARS_DIRECTION"] ), "isTitle", true, "textHeight", 12 )
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_GENERIC_HORIZONTAL"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_GENERIC_HORIZONTAL"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_DIRECTION_HORIZONTAL_TEXT"],
							"isRadio", true,
							"checked", ArkInventory.OptionLocalGet( loc_id, { "bar", "direction" } ) == ArkInventory.Const.Direction.Horizontal,
							"func", function()
								if ArkInventory.OptionLocalGet( loc_id, { "bar", "direction" } ) ~= ArkInventory.Const.Direction.Horizontal then
									ArkInventory.OptionLocalSet( loc_id, { "bar", "direction" }, ArkInventory.Const.Direction.Horizontal )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_GENERIC_VERTICAL"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_GENERIC_VERTICAL"],
							"tooltipText", ArkInventory.Localise["MOD_MENU_MAIN_BARS_DIRECTION_VERTICAL_TEXT"],
							"disabled", true,
							"isRadio", true,
							"checked", ArkInventory.OptionLocalGet( loc_id, { "bar", "direction" } ) == ArkInventory.Const.Direction.Vertical,
							"func", function()
								if ArkInventory.OptionLocalGet( loc_id, { "bar", "direction" } ) ~= ArkInventory.Const.Direction.Vertical then
									ArkInventory.OptionLocalSet( loc_id, { "bar", "direction" }, ArkInventory.Const.Direction.Vertical )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							end
						)
					end

					
					if value == "EMPTY_COLOUR" then
					
						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_EMPTY_COLOUR"] ), "isTitle", true, "textHeight", 12 )
						ArkInventory.Lib.DewDrop:AddLine()
						
						for k, v in ArkInventory.spairs( ArkInventory.OptionLocalGet( loc_id, { "slot", "data" } ), function(a,b) return ArkInventory.OptionLocalGet( loc_id, { "slot", "data", a, "long" } ) < ArkInventory.OptionLocalGet( loc_id, { "slot", "data", b, "long" } ) end ) do
							ArkInventory.Lib.DewDrop:AddLine( "text", v.long,
								"hasColorSwatch", true,
								"r", ArkInventory.OptionLocalGet( loc_id, { "slot", "data", k, "colour", "r" } ),
								"g", ArkInventory.OptionLocalGet( loc_id, { "slot", "data", k, "colour", "g" } ),
								"b", ArkInventory.OptionLocalGet( loc_id, { "slot", "data", k, "colour", "b" } ),
								"colorFunc", function( r, g, b )
									ArkInventory.OptionLocalSet( loc_id, { "slot", "data", k, "colour", "r" }, r )
									ArkInventory.OptionLocalSet( loc_id, { "slot", "data", k, "colour", "g" }, g )
									ArkInventory.OptionLocalSet( loc_id, { "slot", "data", k, "colour", "b" }, b )
									ArkInventory.UiItem_Empty()
								end
							)
						end

					end

					
					if value == "AUTO_OPEN" then

						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_OPEN"] ), "isTitle", true, "textHeight", 12 )
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["LOCATION_BANK"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_OPEN"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_BANK_OPEN_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.auto.open.bank,
							"func", function()
								ArkInventory.db.account.option.auto.open.bank = not ArkInventory.db.account.option.auto.open.bank
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_MAILBOX"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_OPEN"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_MAILBOX_OPEN_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.auto.open.mail,
							"func", function()
								ArkInventory.db.account.option.auto.open.mail = not ArkInventory.db.account.option.auto.open.mail
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_MERCHANT"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_OPEN"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_MAILBOX_OPEN_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.auto.open.merchant,
							"func", function()
								ArkInventory.db.account.option.auto.open.merchant = not ArkInventory.db.account.option.auto.open.merchant
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_TRADE"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_OPEN"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_TRADE_OPEN_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.auto.open.trade,
							"func", function()
								ArkInventory.db.account.option.auto.open.trade = not ArkInventory.db.account.option.auto.open.trade
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_AUCTION"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_OPEN"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_AUCTION_OPEN_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.auto.open.auction,
							"func", function()
								ArkInventory.db.account.option.auto.open.auction = not ArkInventory.db.account.option.auto.open.auction
							end
						)
					
					end
					
					if value == "AUTO_CLOSE" then
					
						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_CLOSE"] ), "isTitle", true, "textHeight", 12 )
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["LOCATION_BANK"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_BANK_CLOSE_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.auto.close.bank,
							"func", function()
								ArkInventory.db.account.option.auto.close.bank = not ArkInventory.db.account.option.auto.close.bank
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_MAILBOX"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_MAILBOX_CLOSE_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.auto.close.mail,
							"func", function()
								ArkInventory.db.account.option.auto.close.mail = not ArkInventory.db.account.option.auto.close.mail
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_MERCHANT"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_MERCHANT_CLOSE_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.auto.close.merchant,
							"func", function()
								ArkInventory.db.account.option.auto.close.merchant = not ArkInventory.db.account.option.auto.close.merchant
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_TRADE"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_TRADE_CLOSE_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.auto.close.trade,
							"func", function()
								ArkInventory.db.account.option.auto.close.trade = not ArkInventory.db.account.option.auto.close.trade
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_AUCTION"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_AUCTION_CLOSE_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.auto.close.auction,
							"func", function()
								ArkInventory.db.account.option.auto.close.auction = not ArkInventory.db.account.option.auto.close.auction
							end
						)
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_COMBAT"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_AUTO_COMBAT_CLOSE_TEXT"], ArkInventory.Const.Program.Name ),
							"checked", ArkInventory.db.account.option.auto.close.combat,
							"func", function()
								ArkInventory.db.account.option.auto.close.combat = not ArkInventory.db.account.option.auto.close.combat
							end
						)
						
					end

					
					if strsub( value, 1, 11 ) == "SORT_ORDER_" then

						local k = strmatch( value, "^SORT_ORDER_(.+)" )
					
						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INCLUDE_" .. string.upper( k )] ), "isTitle", true, "textHeight", 12 )
						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine(	"text", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_MOVE_UP"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_MOVE_UP"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_SORTING_MOVE_UP_TEXT"], LIGHTYELLOW_FONT_COLOR_CODE .. ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INCLUDE_" .. string.upper( k )] .. FONT_COLOR_CODE_CLOSE ),
							"func", function()
								ArkInventory.ItemSortKeyMoveUp( loc_id, k )
								ArkInventory.ItemSortKeyRegenerate( loc_id )
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						)	

						ArkInventory.Lib.DewDrop:AddLine(	"text", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_MOVE_DOWN"],
							"tooltipTitle", ArkInventory.Localise["MOD_MENU_MAIN_SORTING_MOVE_DOWN"],
							"tooltipText", format( ArkInventory.Localise["MOD_MENU_MAIN_SORTING_MOVE_DOWN_TEXT"], LIGHTYELLOW_FONT_COLOR_CODE .. ArkInventory.Localise["MOD_MENU_MAIN_SORTING_INCLUDE_" .. string.upper( k )] .. FONT_COLOR_CODE_CLOSE ),
							"func", function()
								ArkInventory.ItemSortKeyMoveDown( loc_id, k )
								ArkInventory.ItemSortKeyRegenerate( loc_id )
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						)	
						
					end
					
				end
				
				
				
				-- try to add the base options (will fail where it's not supposed to exist so this is safe to use this way albeit crude)
				ArkInventory.Lib.DewDrop:FeedAceOptionsTable( base_options )
				
				if level == 1 then
				
					ArkInventory.Lib.DewDrop:AddLine()
					
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_GENERIC_CLOSE_MENU"],
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
						end
					)

				end

			end
			
		)

	end
	
	
	
end

function ArkInventory.MenuBarOpen( frame )

	if not frame then
		frame = this
	end

	assert( frame, "frame is nil" )
	assert( frame.ARK_Data, string.format( "xml element '%s' is not an %s frame", framename, ArkInventory.Const.Program.Name ) )
	
	if ArkInventory.Lib.DewDrop:IsOpen( this ) then

		ArkInventory.Lib.DewDrop:Close()
		
	else

		local loc_id = frame.ARK_Data.loc_id
		local barnum = frame.ARK_Data.barnum
		local current_player = ArkInventory.Global.Location[loc_id].player
		
		local x, p, rp
		x = this:GetLeft() + ( this:GetRight() - this:GetLeft() ) / 2
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			p = "TOPRIGHT"
			rp = "TOPLEFT"
		else
			p = "TOPLEFT"
			rp = "TOPRIGHT"
		end
	
		local category = {
			["type"] = {
				[1] = "SYSTEM",
				[2] = "SKILL",
				[3] = "CLASS",
				[4] = "EMPTY",
				[5] = "RULE",
			},
		}
		
		ArkInventory.Lib.DewDrop:Open( this,
			"point", p,
			"relativePoint", rp,
			"children", function( level, value )
			
				if level == 1 then
				
					ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( format( ArkInventory.Localise["MOD_MENU_BAR_INFORMATION_TITLE"], barnum ) ), "isTitle", true, "textHeight", 12 )
					
					ArkInventory.Lib.DewDrop:AddLine()
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_BAR_CATEGORY_CURRENT"] .. ":", "isTitle", true )

					
					local has_entries = false
					for _, v in ipairs( category.type ) do
						if ArkInventory.Category_Bar_HasEntries( loc_id, barnum, v ) then
							has_entries = true
							ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["CATEGORY_" .. v],
								"hasArrow", true,
								"value", "CATEGORY_CURRENT_" .. v
							)
						end
					end
					if not has_entries then
						ArkInventory.Lib.DewDrop:AddLine( "text", "none assigned",
							"disabled", true
						)
					end

					ArkInventory.Lib.DewDrop:AddLine()
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_BAR_CATEGORY_ASSIGN"] .. ":",
						"isTitle", true
					)
					for _, v in ipairs( category.type ) do
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["CATEGORY_" .. v],
							"hasArrow", true,
							"value", "CATEGORY_ASSIGN_" .. v
						)
					end
					
					ArkInventory.Lib.DewDrop:AddLine()
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_BAR_CLEAR"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_BAR_CLEAR"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_BAR_CLEAR_TEXT"],
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
							ArkInventory.Category_Bar_Clear( loc_id, barnum )
							ArkInventory.Frame_Main_Generate_RecalcAll()
						end
					)
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_BAR_INSERT"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_BAR_INSERT"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_BAR_INSERT_TEXT"],
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
							ArkInventory.Category_Bar_Insert( loc_id, barnum )
							ArkInventory.Frame_Main_Generate_RecalcAll()
						end
					)
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_BAR_REMOVE"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_BAR_REMOVE"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_BAR_REMOVE_TEXT"],
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
							ArkInventory.Category_Bar_Remove( loc_id, barnum )
							ArkInventory.Frame_Main_Generate_RecalcAll()
						end
					)
					
					ArkInventory.Lib.DewDrop:AddLine()
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_GENERIC_CLOSE_MENU"],
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
						end
					)
					
				end
				
				
				if level == 2 and value then

					if strsub( value, 1, 17 ) == "CATEGORY_CURRENT_" then

						local cat_type = strmatch( value, "^CATEGORY_CURRENT_(.+)" )
				
						if cat_type ~= nil then
					
							ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["CATEGORY_" .. cat_type],
								"isTitle", true,
								"textHeight", 12
							)

							ArkInventory.Lib.DewDrop:AddLine()
							local has_entries = false
							for _, cat in ArkInventory.spairs( ArkInventory.Global.Category, function(a,b) return ArkInventory.Global.Category[a].fullname < ArkInventory.Global.Category[b].fullname end ) do

								local t = cat.type_code
								local cat_bar, def_bar = ArkInventory.Category_Location_Get( loc_id, cat.id )
								
								if abs( cat_bar ) == barnum and not def_bar then
							
									if t == "RULE" then
										if not ArkInventory.db.profile.option.rule[cat.id] then
											t = "DO_NOT_USE" -- don't display disabled rules
										end
									end
						
									if cat_type == t then
		
										local tag_colour = GREEN_FONT_COLOR_CODE
										if cat_bar < 0 then
											tag_colour = RED_FONT_COLOR_CODE
										end
		
										has_entries = true
										ArkInventory.Lib.DewDrop:AddLine( "text", tag_colour .. cat.name,
											"tooltipTitle", cat.fullname,
											"hasArrow", true,
											"value", "CATEGORY_CURRENT_OPTION_" .. cat.id
										)
										
									end
						
								end
	
							end
							
							if not has_entries then
								ArkInventory.Lib.DewDrop:AddLine( "text", "none assigned",
									"disabled", true
								)
							end
							
						end

					end

					
					if strsub( value, 1, 16 ) == "CATEGORY_ASSIGN_" then
					
						local cat_type = strmatch( value, "^CATEGORY_ASSIGN_(.+)" )
				
						if cat_type ~= nil then
					
							ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["CATEGORY_" .. cat_type],
								"isTitle", true,
								"textHeight", 12
							)

							ArkInventory.Lib.DewDrop:AddLine()
							for _, cat in ArkInventory.spairs( ArkInventory.Global.Category, function(a,b) return ArkInventory.Global.Category[a].fullname < ArkInventory.Global.Category[b].fullname end ) do

								local t = cat.type_code
								local cat_bar, def_bar = ArkInventory.Category_Location_Get( loc_id, cat.id )
							
								if abs( cat_bar ) == barnum and not def_bar then
									t = "DO_NOT_USE" -- change the category so it doesn't display
								end

								if t == "RULE" then
									if not ArkInventory.db.profile.option.rule[cat.id] then
										t = "DO_NOT_USE" -- don't display disabled rules
									end
								end
								
								if cat_type == t then
	
									local n = cat.name
	
									if not def_bar then
										-- category is assigned to a bar - show the user where
										n = LIGHTYELLOW_FONT_COLOR_CODE .. cat.name .. GREEN_FONT_COLOR_CODE .. "  [" .. ArkInventory.Category_Location_Get( loc_id, cat.id ) .. "]" .. FONT_COLOR_CODE_CLOSE
									end
	
									ArkInventory.Lib.DewDrop:AddLine( "text", n,
										"tooltipTitle", ArkInventory.Localise["MOD_MENU_BAR_CATEGORY"],
										"tooltipText", format( ArkInventory.Localise["MOD_MENU_BAR_CATEGORY_TEXT"], cat.fullname ),
										"func", function()
											ArkInventory.Category_Location_Set( loc_id, cat.id, barnum )
											ArkInventory.Frame_Main_Generate_RecalcAll()
										end
									)
								end
	
							end
							
						end
						
					end

					
				end

				
				if level == 3 and value then
				
					if strsub( value, 1, 24 ) == "CATEGORY_CURRENT_OPTION_" then
					
						local cat_id = tonumber( strmatch( value, "^CATEGORY_CURRENT_OPTION_(.+)" ) )
				
						if cat_id ~= nil then
					
							local cat = ArkInventory.Global.Category[cat_id]
						
							ArkInventory.Lib.DewDrop:AddLine( "text", cat.fullname,
								"isTitle", true,
								"textHeight", 12
							)

							ArkInventory.Lib.DewDrop:AddLine()
							cv = ArkInventory.Category_Location_Get( loc_id, cat_id )
							ArkInventory.Lib.DewDrop:AddLine(	"text", format( ArkInventory.Localise["MOD_MENU_ITEM_MOVE"], LIGHTYELLOW_FONT_COLOR_CODE .. cat.fullname .. FONT_COLOR_CODE_CLOSE ),
								"hasArrow", true,
								"hasSlider", true,
								"sliderValue", cv,
								"sliderMin", 1,
								"sliderMax", ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count + 1,
								"sliderStep", 1,
								"sliderFunc", function( nv )
									if cv ~= nv then
										ArkInventory.Category_Location_Set( loc_id, cat_id, nv )
										ArkInventory.Frame_Main_Generate_RecalcAll()
									end
								end
							)

							ArkInventory.Lib.DewDrop:AddLine()
							ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_BAR_CATEGORY_REMOVE"],
								"tooltipTitle", ArkInventory.Localise["MOD_MENU_BAR_CATEGORY_REMOVE"],
								"tooltipText", format( ArkInventory.Localise["MOD_MENU_BAR_CATEGORY_REMOVE_TEXT"], cat.fullname, barnum ),
								"func", function()
									ArkInventory.Category_Location_Set( loc_id, cat_id, nil )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							)

							ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_BAR_CATEGORY_HIDDEN"],
								"tooltipTitle", ArkInventory.Localise["MOD_MENU_BAR_CATEGORY_HIDDEN"],
								"tooltipText", ArkInventory.Localise["MOD_MENU_BAR_CATEGORY_HIDDEN_TEXT"],
								"checked", ArkInventory.Category_Hidden_Check( loc_id, cat_id ),
								"func", function()
									ArkInventory.Category_Hidden_Toggle( loc_id, cat_id )
									ArkInventory.Frame_Main_Generate_RecalcAll()
								end
							)
					
						end
						
					end

				
				end
				
			end
		)

	end
	
end

function ArkInventory.MenuItemOpen( frame )

	if not frame then
		frame = this
	end

	if ArkInventory.Global.Mode.Edit == false then
		return
	end

	if ArkInventory.Lib.DewDrop:IsOpen( this ) then
	
		ArkInventory.Lib.DewDrop:Close()
		
	else

		local loc_id = frame.ARK_Data.loc_id
		local bag_id = frame.ARK_Data.bag_id
		local slot_id = frame.ARK_Data.slot_id
		local current_player = ArkInventory.Global.Location[loc_id].player
		local i = ArkInventory.Frame_Item_GetDB( frame )
		
	
		local x, p, rp
		x = this:GetLeft() + ( this:GetRight() - this:GetLeft() ) / 2
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			p = "TOPRIGHT"
			rp = "TOPLEFT"
		else
			p = "TOPLEFT"
			rp = "TOPRIGHT"
		end
	
		local ic = select( 4, GetItemQualityColor( i.q ) )
		local barnum = abs( ArkInventory.Category_Location_Get( loc_id, i.cat ) )
		
		local category = {
			["type"] = {
				[1] = "SYSTEM",
				[2] = "SKILL",
				[3] = "CLASS",
				[4] = "EMPTY",
			},
			["data"] = {
			},
		}

		if i.cat ~= nil then
			tinsert( category.data, ArkInventory.Global.Category[i.cat] )
		else
			tinsert( category.data, ArkInventory.Global.Category[ArkInventory.Const.Categories.Default] )
		end
		
		if i.catdef ~= nil then
			tinsert( category.data, ArkInventory.Global.Category[i.catdef] )
		end

		
		ArkInventory.Lib.DewDrop:Open( this,
			"point", p,
			"relativePoint", rp,
			"children", function( level, value )
			
				if level == 1 then

					ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_ITEM_INFORMATION_TITLE"] ) .. ":",
						"isTitle", true,
						"textHeight", 12
					)
					ArkInventory.Lib.DewDrop:AddLine()
					
					ArkInventory.Lib.DewDrop:AddLine( "text",  ArkInventory.Localise["MOD_MENU_ITEM_ITEM"] .. ": " .. ic .. ( ArkInventory.ItemGetName( i.h ) or "" ) )
					
					ArkInventory.Lib.DewDrop:AddLine()
					if category.data[2] then
					
						-- item has a default category, that means it's been specifically assigned elsewhere
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_ITEM_CURRENT_ASSIGNMENT"] .. ": " .. GREEN_FONT_COLOR_CODE .. category.data[1].fullname .. FONT_COLOR_CODE_CLOSE,
							"notClickable", true
						)

						ArkInventory.Lib.DewDrop:AddLine()
						
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_ITEM_DEFAULT_ASSIGNMENT"] .. ": " .. LIGHTYELLOW_FONT_COLOR_CODE .. category.data[2].fullname .. FONT_COLOR_CODE_CLOSE,
							"tooltipTitle", "Reset to default",
							"tooltipText", "click to reset the system category for this item back to it's default value (does not reset rules)",
							"func", function()
								ArkInventory.Lib.DewDrop:Close()
								ArkInventory.ItemCategorySet( i, nil )
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						)

					else
					
						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_ITEM_DEFAULT_ASSIGNMENT"] .. ": " .. LIGHTYELLOW_FONT_COLOR_CODE .. category.data[1].fullname .. FONT_COLOR_CODE_CLOSE,
							"notClickable", true
						)
					
					end
	
					ArkInventory.Lib.DewDrop:AddLine()
					ArkInventory.Lib.DewDrop:AddLine( "text", "Assignable Categories:", "isTitle", true )
					for _, v in ipairs( category.type ) do
						ArkInventory.Lib.DewDrop:AddLine( "text", v,
							"hasArrow", true,
							"tooltipTitle", "Assign Category",
							"tooltipText", "assign this item to a specific category",
							"value", "CATEGORY_ASSIGN_" .. v
						)
					end
					
					ArkInventory.Lib.DewDrop:AddLine()
					ArkInventory.Lib.DewDrop:AddLine(	"text", format( ArkInventory.Localise["MOD_MENU_ITEM_MOVE"], LIGHTYELLOW_FONT_COLOR_CODE .. category.data[1].fullname .. FONT_COLOR_CODE_CLOSE ),
						"hasArrow", true,
						"hasSlider", true,
						"sliderValue", ArkInventory.Category_Location_Get( loc_id, i.cat ),
						"sliderMin", 1,
						"sliderMax", ArkInventory.db.account.cache.who[current_player].loc[loc_id].bar_count + 1,
						"sliderStep", 1,
						"sliderFunc", function( v )
							if ArkInventory.Category_Location_Get( loc_id, i.cat ) ~= v then
								ArkInventory.Category_Location_Set( loc_id, i.cat, v )
								ArkInventory.Frame_Main_Generate_RecalcAll()
							end
						end
					)

					ArkInventory.Lib.DewDrop:AddLine()
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_ITEM_DEBUG"],
						"hasArrow", true,
						"value", "DEBUG_INFO"
					)
					
					ArkInventory.Lib.DewDrop:AddLine()
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_ITEM_RULE_NEW"],
						"hasArrow", true,
						"hasEditBox", true,
						"editBoxText", "",
						"editBoxFunc", function( v )
							ArkInventory.Lib.DewDrop:Close()
							d = { ["enabled"] = true, ["order"] = 0, ["name"] = v, ["formula"] = "false" }
							rule_id = ArkInventory.db.account.option.nextrule
							ArkInventory.RuleEntryAdd( rule_id, d )
						end
					)
					
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_ITEM_RULE_ADD"],
						"hasArrow", true,
						"value", "ITEM_RULE_ADD"
					)

					ArkInventory.Lib.DewDrop:AddLine()
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_GENERIC_CLOSE_MENU"],
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
						end
					)
					
				end

				
				if level == 2 and value then

					if value == "ITEM_RULE_ADD" then
					
						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_ITEM_RULE_ADD"] ), "isTitle", true, "textHeight", 12 )
						
						ArkInventory.Lib.DewDrop:AddLine()
						
						local n
						for _, v in ArkInventory.spairs( ArkInventory.Global.Category, function(a,b) return ArkInventory.Global.Category[a].order < ArkInventory.Global.Category[b].order end ) do
							if v.type_code == "RULE" and ArkInventory.db.profile.option.rule[v.id] and ArkInventory.db.account.option.rule[v.id].compiled and not ArkInventory.db.account.option.rule[v.id].damaged then
								
								if ArkInventory.RuleAppliesToItem( v.id, i ) then
									n = GREEN_FONT_COLOR_CODE .. v.name .. FONT_COLOR_CODE_CLOSE
								else
									n = v.name
								end
								
								ArkInventory.Lib.DewDrop:AddLine( "text", n,
									"func", function()
										ArkInventory.Lib.DewDrop:Close()
										ArkInventory.AddItemToRule( i.h, v.id )
									end
								)
							end
						
						end
						
					end
				
					if value == "DEBUG_INFO" then

						ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_ITEM_DEBUG"] ), "isTitle", true, "textHeight", 12 )
						
						ArkInventory.Lib.DewDrop:AddLine()
					
						ArkInventory.Lib.DewDrop:AddLine( "text", "Bag: " .. GREEN_FONT_COLOR_CODE .. bag_id )
						ArkInventory.Lib.DewDrop:AddLine( "text", "Slot: " .. GREEN_FONT_COLOR_CODE .. slot_id )
						local bagtype = ArkInventory.Const.Slot.Data[ArkInventory.BagType( bag_id )].type
						if bagtype then
							ArkInventory.Lib.DewDrop:AddLine( "text", "Type: " .. GREEN_FONT_COLOR_CODE .. bagtype )
						end
						ArkInventory.Lib.DewDrop:AddLine()
						ArkInventory.Lib.DewDrop:AddLine( "text", "AI ID: " .. GREEN_FONT_COLOR_CODE .. i.id )
						ArkInventory.Lib.DewDrop:AddLine( "text", "AI Category: " .. GREEN_FONT_COLOR_CODE .. category.data[1].id )
			
						if i.h then
							
							local inam, _, irar, ilvl, imin, ityp, isub, icount, iloc, itxt = GetItemInfo( i.h )
							iloc = getglobal( iloc )
							if not iloc then
								iloc = ""
							end
							
							ArkInventory.Lib.DewDrop:AddLine()
							ArkInventory.Lib.DewDrop:AddLine( "text", "Name: " .. GREEN_FONT_COLOR_CODE .. inam )
							local ilnk = strmatch( i.h, "(%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+)" )
							ArkInventory.Lib.DewDrop:AddLine( "text", "Quality: " .. GREEN_FONT_COLOR_CODE .. irar .. " - " .. string.lower( getglobal( "ITEM_QUALITY" .. irar .. "_DESC" ) ) )
							ArkInventory.Lib.DewDrop:AddLine( "text", "Item Level (Stat): " .. GREEN_FONT_COLOR_CODE .. ilvl )
							ArkInventory.Lib.DewDrop:AddLine( "text", "Item Level (Use): " .. GREEN_FONT_COLOR_CODE .. imin )
							ArkInventory.Lib.DewDrop:AddLine( "text", "Type: " .. GREEN_FONT_COLOR_CODE .. ityp )
							ArkInventory.Lib.DewDrop:AddLine( "text", "Sub Type: " .. GREEN_FONT_COLOR_CODE .. isub )
							ArkInventory.Lib.DewDrop:AddLine( "text", "Location: " .. GREEN_FONT_COLOR_CODE .. iloc )

							ArkInventory.Lib.DewDrop:AddLine()
							ArkInventory.Lib.DewDrop:AddLine( "text", "ID: " .. GREEN_FONT_COLOR_CODE .. ilnk )
							ArkInventory.Lib.DewDrop:AddLine( "text", "Stack Size: " .. GREEN_FONT_COLOR_CODE .. icount )
							ArkInventory.Lib.DewDrop:AddLine( "text", "Texture: " .. GREEN_FONT_COLOR_CODE .. itxt )
							
							ArkInventory.Lib.DewDrop:AddLine()
							ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_ITEM_DEBUG_PT"],
								"hasArrow", true,
								"tooltipTitle", ArkInventory.Localise["MOD_MENU_ITEM_DEBUG_PT"],
								"tooltipText", ArkInventory.Localise["MOD_MENU_ITEM_DEBUG_PT_TEXT"],
								"value", "DEBUG_INFO_PT"
							)
							
						end

					end
					
					if strsub( value, 1, 16 ) == "CATEGORY_ASSIGN_" then
					
						local k = strmatch( value, "CATEGORY_ASSIGN_(.+)" )
					
						ArkInventory.Lib.DewDrop:AddLine( "text", k, "isTitle", true, "textHeight", 12 )
						ArkInventory.Lib.DewDrop:AddLine()
					
						for _, v in ArkInventory.spairs( ArkInventory.Global.Category, function(a,b) return ArkInventory.Global.Category[a].fullname < ArkInventory.Global.Category[b].fullname end ) do
					
							local t = v.type_code
							if v.id == i.cat then
								t = "DO_NOT_USE"
							end
							
							--ArkInventory.Debug( "id=" .. cat.id .. ", type=[" .. cat.type .. "], value=[" .. value .. "]" )
							if k == t then
								--~~~~
								ArkInventory.Lib.DewDrop:AddLine( "text", v.name,
									"tooltipTitle", "Assign to Category",
									"tooltipText", "assign this item to " .. v.fullname, --~~~~ check this
									"func", function()
										ArkInventory.Lib.DewDrop:Close()
										ArkInventory.ItemCategorySet( i, v.id )
										ArkInventory.Frame_Main_Generate_RecalcAll()
									end
								)
							
							end
							
						end
						
					end

					
					
				end

				
				if level == 3 and value then
				
					if value == "DEBUG_INFO_PT" then

						ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_ITEM_DEBUG_PT_TITLE"] .. ":", "isTitle", true, "textHeight", 12 )
					
						ArkInventory.Lib.DewDrop:AddLine()
					
						local pt_set = ArkInventory.Lib.PeriodicTable:ItemSearch( i.h )
						
						if not pt_set then
						
							ArkInventory.Lib.DewDrop:AddLine( "text", LIGHTYELLOW_FONT_COLOR_CODE .. ArkInventory.Localise["MOD_MENU_ITEM_DEBUG_PT_NONE"] )
						
						else
						
							for k, v in pairs( pt_set ) do
								ArkInventory.Lib.DewDrop:AddLine( "text", v,
									"hasArrow", true,
									"hasEditBox", true,
									"editBoxText", v
								)
							end
							
						end

					end
				
				end
				
			end
		)
		
	end
	
end

function ArkInventory.MenuRuleOpen( frame )

	if not frame then
		frame = this
	end

	if ArkInventory.Lib.DewDrop:IsOpen( this ) then

		ArkInventory.Lib.DewDrop:Close()
		
	else

		local x, p, rp
		x = this:GetLeft() + ( this:GetRight() - this:GetLeft() ) / 2
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			p = "TOPRIGHT"
			rp = "TOPLEFT"
		else
			p = "TOPLEFT"
			rp = "TOPRIGHT"
		end
	
		ArkInventory.Lib.DewDrop:Open( this,
			"point", p,
			"relativePoint", rp,
			"children", function( level, value )
			
				if level == 1 then
				
					ArkInventory.Lib.DewDrop:AddLine( "text", string.upper( ArkInventory.Localise["MOD_MENU_MAIN_RULES"] ), "isTitle", true, "textHeight", 12 )
					
					ArkInventory.Lib.DewDrop:AddLine()

					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_RULE_SHOWDISABLED"],
						"tooltipTitle", ArkInventory.Localise["MOD_MENU_RULE_SHOWDISABLED"],
						"tooltipText", ArkInventory.Localise["MOD_MENU_RULE_SHOWDISABLED_TEXT"],
						"checked", ArkInventory.db.account.option.showdisabled,
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
							ArkInventory.db.account.option.showdisabled = not ArkInventory.db.account.option.showdisabled,
							ArkInventory.Frame_Rules_Table_Reset( "ARKINV_RulesFrameView" )
							ArkInventory.Frame_Rules_Table_Refresh( "ARKINV_RulesFrame" )
						end
					)
					
					ArkInventory.Lib.DewDrop:AddLine()
					
					ArkInventory.Lib.DewDrop:AddLine( "text", ArkInventory.Localise["MOD_MENU_GENERIC_CLOSE_MENU"],
						"func", function()
							ArkInventory.Lib.DewDrop:Close()
						end
					)
					
				end
				
				
				if level == 2 and value then
				
				end

			end
		)

	end
	
end


function ArkInventory.OfflineCacheCleanup()

	--ArkInventory.PrintPlus( { "OfflineCacheCleanup() start" } )

	for player, player_data in pairs( ArkInventory.db.account.cache.who ) do

		for loc_id, loc_data in pairs( player_data.loc ) do
			
			--ArkInventory.PrintPlus( { "checking cache: [", player, "] / [", ArkInventory.Global.Location[loc_id].NAME, "]" } )
			
			if loc_id == ArkInventory.Const.Location.Bank and not ArkInventory.db.account.option.offline.bank then
				-- erase bank if not needed
				--ArkInventory.PrintPlus( { "erasing cached ", ArkInventory.Global.Location[loc_id].NAME, " data for [", player, "]" } )
				ArkInventory.db.account.cache.who[player].loc[loc_id] = nil
			end
	
		end

		if player ~= ArkInventory.Global.Me.id and not ArkInventory.db.account.option.offline.alt then
			--ArkInventory.PrintPlus( { "erasing cached ", ArkInventory.Global.Location[loc_id].NAME, " data for [", player, "]" } )
			ArkInventory.db.account.cache.who[player] = nil
		end

	end

	--ArkInventory.PrintPlus( { "OfflineCacheCleanup() end" } )
	
end


function ArkInventory.SkillGet()

	local good = false
	
	-- ArkInventory.Debug( "GetNumSkillLines() = " .. GetNumSkillLines() )
	
	for j = 1, GetNumSkillLines() do
	
		local name, header = GetSkillLineInfo( j )

		if header ~= nil then

			if name == ArkInventory.Localise["WOW_SKILL_HEADER_PRIMARY"] or name == ArkInventory.Localise["WOW_SKILL_HEADER_SECONDARY"] then
				-- ArkInventory.Debug( "header = " .. name )
				good = true
			else
				good = false
			end
			
		else
		
			if good then
				-- ArkInventory.Debug( "name = " .. name )
				local skill = strmatch( ArkInventory.Localise:GetReverseTranslation( name ), "WOW_SKILL_(.+)" )
				ArkInventory.Global.Skills[skill] = j
			end
			
		end
		
	end
	
end

function ArkInventory.SkillPrint()
	for k, v in pairs( ArkInventory.Global.Skills ) do
		ArkInventory:Print( "skill: " .. k .. " = " .. v )
	end
end

function ArkInventory.HookBlizzardAPI()

	if ArkInventory.db.account.option.framehide.blizzard then
	
		ArkInventory:Hook( "OpenBackpack", "HookBackpackOpen", true )
		ArkInventory:Hook( "ToggleBackpack", "HookBackpackToggle", true )
		ArkInventory:Hook( "OpenAllBags", "HookBackpackOpen", true )
		ArkInventory:Hook( "OpenBag", "HookBackpackToggle", true )
		ArkInventory:Hook( "ToggleBag", "HookBackpackToggle", true )

		ArkInventory:Hook( "ToggleKeyRing", "HookKeyringToggle", true )
	
		BankFrame:UnregisterEvent( "BANKFRAME_OPENED" )
		BankFrame:UnregisterEvent( "BANKFRAME_CLOSED" )
		
		--ArkInventory.HookReport()
		
	else

		BankFrame:RegisterEvent( "BANKFRAME_OPENED" )
		BankFrame:RegisterEvent( "BANKFRAME_CLOSED" )
	
		ArkInventory:UnhookAll()

		--ArkInventory.HookReport()
	
	end
	
end

function ArkInventory.HookBackpackOpen()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "HookBackpackOpen()" } )
	ArkInventory.Frame_Main_Show( ArkInventory.Const.Location.Bag )
end

function ArkInventory.HookBackpackToggle()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "HookBackpackToggle()" } )
	ArkInventory.Frame_Container_Toggle( ArkInventory.Const.Location.Bag )
end

function ArkInventory.HookBagOpen( bag_id )
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "HookBagOpen( ", bag_id, " )" } )
	if bag_id then
		ArkInventory.Frame_Main_Show( ArkInventory.BagGetLocation( bag_id ) )
	end
end

function ArkInventory.HookKeyringToggle()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "HookKeyringToggle()" } )
	ArkInventory.Frame_Container_Toggle( ArkInventory.Const.Location.Key )
end

function ArkInventory.HookBagToggle( bag_id )
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "HookBagToggle( ", bag_id, " )" } )
	if bag_id then
		local loc_id = ArkInventory.BagGetLocation( bag_id )
		ArkInventory.Frame_Container_Toggle( loc_id )
	end
end

function ArkInventory.HookDoNothing()
	--ArkInventory.Debug( { RED_FONT_COLOR_CODE, "HookDoNothing()" } )
	-- do nothing
end


function ArkInventory.ContainerItemNameGet( loc_id, bag_id, slot_id )
	return ArkInventory.Const.Program.Frame .. loc_id .. "Container" .. "Bag" .. bag_id .. "Slot" .. slot_id
end


function ArkInventory.OptionLocalGet( loc_id, opt )

	assert( loc_id, "invalid location" )
	assert( opt, "invalid option table" )

	if ArkInventory.db.profile.option.useglobal then
		loc_id = ArkInventory.Const.Location.Bag
	end
	
	--s = "option.local." .. loc_id
	local p = { ArkInventory.db.profile.option["local"][loc_id] }
	local c = 1
	
	for k = 1, #opt do
		c = k + 1
		v = opt[k]
		p[c] = p[k][v]
		--s = s .. "." .. v
	end
	
	--ArkInventory.PrintPlus( { "get ", s, " = [", p[c], "]" } )
	return p[c]

end

function ArkInventory.OptionLocalSet( loc_id, opt, n )

	assert( loc_id, "invalid location" )
	assert( opt, "invalid option table" )

	if ArkInventory.db.profile.option.useglobal then
		loc_id = ArkInventory.Const.Location.Bag
	end
	
	--s = "option.local." .. loc_id
	local p = { ArkInventory.db.profile.option["local"][loc_id] }
	local c = 1
	
	for k = 1, #opt - 1 do
		c = k + 1
		v = opt[k]
		p[c] = p[k][v]
		--s = s .. "." .. v
	end
	
	v = opt[c]
	--ArkInventory.PrintPlus( { "set ", s, "[", v, "], old=[", p[c][v], "], new=[", n, "]" } )
	p[c][v] = n

end


function ArkInventory.ToggleChanger()
	ArkInventory.db.account.option.framehide.changer = not ArkInventory.db.account.option.framehide.changer
	ArkInventory.Frame_Main_Generate_RefreshAll()
end

function ArkInventory.ToggleEditMode()
	ArkInventory.Global.Mode.Edit = not ArkInventory.Global.Mode.Edit
	ArkInventory.Frame_Bar_Paint_All()
	ArkInventory.Frame_Main_Generate_RecalcAll()
end


function ArkInventory.TooltipSetPosition( frame )

	local x, a
	x = frame:GetLeft() + ( frame:GetRight() - frame:GetLeft() ) / 2
	if ( x >= ( GetScreenWidth() / 2 ) ) then
		a = "ANCHOR_LEFT"
	else
		a = "ANCHOR_RIGHT"
	end

	GameTooltip:SetOwner( frame, a )
	
end

function ArkInventory.TooltipSetText( frame, txt, r, g, b )

	ArkInventory.TooltipSetPosition( frame )
	GameTooltip:SetText( txt, r or 1, g or 1, b or 1 )
	GameTooltip:Show()
	
end

function ArkInventory.TooltipHide()
	GameTooltip:Hide()
end

function ArkInventory.AddItemToRule( h, rulenum )
	local d = ArkInventory.db.account.option.rule[rulenum]
	d.formula = d.formula .. " or id( " .. ArkInventory.ItemGetID( h ) .. " )"
	d["enabled"] = ArkInventory.db.profile.option.rule[rulenum]
	ArkInventory.RuleEntryEdit( rulenum, d )
end



function ArkInventory.CategoryRenumber_145_200( cat_old, cat_new )

	if ArkInventory.db.profile.option["global"] and ArkInventory.db.profile.option.global["category"] and ArkInventory.db.profile.option.global.category["item"] then
		for item_id, cat_id in pairs( ArkInventory.db.profile.option.global.category.item ) do
			if cat_id == cat_old then
				ArkInventory.db.profile.option.global.category.item[item_id] = cat_new
			end
		end
	end

	for loc_id in pairs( ArkInventory.Global.Location ) do
		if ArkInventory.db.profile.option["local"][loc_id]["category"] then
			for cat_id, barnum in pairs( ArkInventory.db.profile.option["local"][loc_id]["category"] ) do
				if cat_id == cat_old then
					ArkInventory.db.profile.option["local"][loc_id]["category"][cat_new] = barnum
					ArkInventory.db.profile.option["local"][loc_id]["category"][cat_id] = nil
				end
			end
		end
	end

end

function ArkInventory.ConvertOldOptions()

	local upgrade_version = 0

	if not ArkInventory.db.profile.option["version"] then
		ArkInventory.db.profile.option["version"] = upgrade_version
	end

	
	upgrade_version = 1
	if ArkInventory.db.profile.option.version < upgrade_version then

		ArkInventory:Print( format( "Upgrading profile %1$s to %2$.2f", ArkInventory:GetProfile(), upgrade_version ) )
		
		-- don't store data in char db any more
		ArkInventory:ResetDB( "char" )
	
		-- moved the background colour option
		if ArkInventory.db.profile.option["window"] and ArkInventory.db.profile.option.window["background"] then
			ArkInventory.db.profile.option.window.colour.background = ArkInventory.db.profile.option.window.background
			ArkInventory.db.profile.option.window.background = nil
		end
	
		-- moved the close on combat option
		if ArkInventory.db.profile.option["window"] and ArkInventory.db.profile.option.window["combat"] then
			ArkInventory.db.profile.option.window["auto"]["close"]["combat"] = ArkInventory.db.profile.option.window.combat
			ArkInventory.db.profile.option.window.combat = nil
		end

		-- moved the slot sort options
		if ArkInventory.db.profile.option["slot"] and ArkInventory.db.profile.option.slot["sort"] then
			ArkInventory.db.profile.option["sort"]["type"] = ArkInventory.db.profile.option.slot.sort
			ArkInventory.db.profile.option.slot.sort = nil
		end
	
		if ArkInventory.db.profile.option["category"] and ArkInventory.db.profile.option.category["item"] then
			-- new id format
			local new_cat = { }
			local new_key = nil
			for k, v in pairs( ArkInventory.db.profile.option.category.item ) do
		
				new_key = k
	
				if strmatch( k, "^%-?%d+$" ) then -- original format, just the number
				
					-- adding suffix and soulbound
					new_key = k .. ".0.0.0"
				
				elseif strmatch( k, "^%-?%d+.%-?%d+.%-?%d+$" ) then -- second format id.suffix.soulbound
			
					-- moving soulbound and adding enchant
					local v1, v2, v3 = strmatch( k, "^(%-?%d+).(%-?%d+).(%-?%d+)" )
					new_key = v1 .. "." .. v3 .. "." .. v2 .. ".0"
				
				end
		
				-- id . soulbound . suffix . enchant
				new_cat[new_key] = v
			end
			ArkInventory.db.profile.option["category"]["item"] = new_cat
		end


		-- individual window widths
		if ArkInventory.db.profile.option["window"] and ArkInventory.db.profile.option.window["col"] and type( ArkInventory.db.profile.option.window.col ) == "number" then
			ArkInventory.db.profile.option.window.col = {
				[ArkInventory.Const.Location.Bag] = ArkInventory.db.profile.option.window.col,
			}
		end

		-- move the default category to it's new id (so it can be hidden)
		if ArkInventory.db.profile.option["category"] and ArkInventory.db.profile.option.category["location"] and ArkInventory.db.profile.option.category.location[0] then
			ArkInventory.db.profile.option.category.location[ArkInventory.Const.Categories.Default] = ArkInventory.db.profile.option.category.location[0]
			ArkInventory.db.profile.option.category.location[0] = nil
		end
		
		ArkInventory.db.profile.option.version = upgrade_version
		ArkInventory.db.account.option.version = upgrade_version
	
	end
	
	
	upgrade_version = 1.3
	if ArkInventory.db.profile.option.version < upgrade_version then
	
		ArkInventory:Print( format( "Upgrading profile %1$s to %2$.2f", ArkInventory:GetProfile(), upgrade_version ) )
	
		if not ArkInventory.db.profile.option["global"] then
			ArkInventory.db.profile.option["global"] = { }
		end

		if ArkInventory.db.profile.option["window"] then
	
			if ArkInventory.db.profile.option.window["scale"] then
				ArkInventory.db.profile.option["local"][ArkInventory.Const.Location.Bag]["window"]["scale"] = ArkInventory.db.profile.option.window.scale
				ArkInventory.db.profile.option.window.scale = nil
			end
			
			if ArkInventory.db.profile.option.window["col"] then
	
				if ArkInventory.db.profile.option.window.col[ArkInventory.Const.Location.Bag] then
					ArkInventory.db.profile.option["local"][ArkInventory.Const.Location.Bag]["window"]["width"] = ArkInventory.db.profile.option.window.col[ArkInventory.Const.Location.Bag]
					ArkInventory.db.profile.option.window.col[ArkInventory.Const.Location.Bag] = nil
				end
	
				if ArkInventory.db.profile.option.window.col[ArkInventory.Const.Location.Bank] then
					ArkInventory.db.profile.option["local"][ArkInventory.Const.Location.Bank]["window"]["width"] = ArkInventory.db.profile.option.window.col[ArkInventory.Const.Location.Bank]
					ArkInventory.db.profile.option.window.col[ArkInventory.Const.Location.Bank] = nil
				end
	
				if ArkInventory.db.profile.option.window.col[ArkInventory.Const.Location.Key] then
					ArkInventory.db.profile.option["local"][ArkInventory.Const.Location.Key]["window"]["width"] = ArkInventory.db.profile.option.window.col[ArkInventory.Const.Location.Key]
					ArkInventory.db.profile.option.window.col[ArkInventory.Const.Location.Key] = nil
				end
	
				ArkInventory.db.profile.option.window.col = nil
			
			end

			if ArkInventory.db.profile.option.window["border"] then
				ArkInventory.db.profile.option["local"][ArkInventory.Const.Location.Bag]["window"]["border"] = ArkInventory.db.profile.option.window.border
				ArkInventory.db.profile.option.window.border = nil
			end

			if ArkInventory.db.profile.option.window["colour"] then
				ArkInventory.db.profile.option["local"][ArkInventory.Const.Location.Bag]["window"]["colour"] = ArkInventory.db.profile.option.window.colour
				ArkInventory.db.profile.option.window.colour = nil
			end

			if ArkInventory.db.profile.option.window["ignorehidden"] then
				ArkInventory.db.profile.option["local"][ArkInventory.Const.Location.Bag]["slot"]["ignorehidden"] = ArkInventory.db.profile.option.window.ignorehidden
				ArkInventory.db.profile.option.window.ignorehidden = nil
			end
			
			if ArkInventory.db.profile.option.window["auto"] then
				ArkInventory.db.profile.option.global["auto"] = ArkInventory.db.profile.option.window.auto
				ArkInventory.db.profile.option.window.auto = nil
			end
	
			if ArkInventory.db.profile.option.window["framehide"] then
				ArkInventory.db.profile.option.global["framehide"] = ArkInventory.db.profile.option.window.framehide
				ArkInventory.db.profile.option.window.framehide = nil
			end

			ArkInventory.db.profile.option.window["width"] = nil
			ArkInventory.db.profile.option.window["hideblizzard"] = nil

		end
		
		ArkInventory.db.profile.option["window"] = nil
		
		if ArkInventory.db.profile.option["bar"] then
			ArkInventory.db.profile.option["local"][ArkInventory.Const.Location.Bag]["bar"] = ArkInventory.db.profile.option.bar
			ArkInventory.db.profile.option.bar = nil
		end
	
		if ArkInventory.db.profile.option["slot"] then
			ArkInventory.db.profile.option["local"][ArkInventory.Const.Location.Bag]["slot"] = ArkInventory.db.profile.option.slot
			ArkInventory.db.profile.option.slot = nil
		end
	
		if ArkInventory.db.profile.option["sort"] then
			ArkInventory.db.profile.option["local"][ArkInventory.Const.Location.Bag]["sort"] = ArkInventory.db.profile.option.sort
			ArkInventory.db.profile.option.sort = nil
		end
	
		if ArkInventory.db.profile.option["category"] then
				
			if ArkInventory.db.profile.option.category["custom"] then
				ArkInventory.db.profile.option.global["category"]["custom"] = ArkInventory.db.profile.option.category.custom
				ArkInventory.db.profile.option.category.custom = nil
			end
			
			if ArkInventory.db.profile.option.category["next"] then
				ArkInventory.db.profile.option.global["category"]["next"] = ArkInventory.db.profile.option.category.next
				ArkInventory.db.profile.option.category.next = nil
			end
					
			if ArkInventory.db.profile.option.category["item"] then
			
				for k, v in pairs( ArkInventory.db.profile.option.category.item ) do
					if v == 0 then
						ArkInventory.db.profile.option.category.item[k] = nil
					end
				end
			
				ArkInventory.db.profile.option.global["category"]["item"] = ArkInventory.db.profile.option.category.item
				ArkInventory.db.profile.option.category.item = nil
			end
	
			if ArkInventory.db.profile.option.category["location"] then
				ArkInventory.db.profile.option["local"][ArkInventory.Const.Location.Bag]["category"] = ArkInventory.db.profile.option.category.location
				ArkInventory.db.profile.option.category.location = nil
			end
			
			--ArkInventory.db.profile.option.category = nil
			
		end
			
		if ArkInventory.db.profile.option["offline"] then
			ArkInventory.db.profile.option.offline = nil
		end
	
		ArkInventory.db.profile.option["sync"] = nil

		ArkInventory.db.profile.option.version = upgrade_version
		ArkInventory.db.account.option.version = upgrade_version
		
	end

	
	upgrade_version = 1.4
	if ArkInventory.db.profile.option.version < upgrade_version then

		ArkInventory:Print( format( "Upgrading profile %1$s to %2$.2f", ArkInventory:GetProfile(), upgrade_version ) )
		
		-- categories 36, 37, 38 need to be relocated to 25
		if ArkInventory.db.profile.option["global"] and ArkInventory.db.profile.option.global["category"] and ArkInventory.db.profile.option.global.category["item"] then
			for k, v in pairs( ArkInventory.db.profile.option.global.category.item ) do
				if v == 36 or v == 37 or v == 38 then
					ArkInventory.db.profile.option.global.category.item[k] = 25
				end
			end
		end

		ArkInventory.db.profile.option.version = upgrade_version
		ArkInventory.db.account.option.version = upgrade_version
	
	end

	
	upgrade_version = 2
	if ArkInventory.db.profile.option.version < upgrade_version then

		ArkInventory:Print( format( "Upgrading profile %1$s to %2$.2f", ArkInventory:GetProfile(), upgrade_version ) )
		
		if ArkInventory.db.profile.option["global"] then
		
			if ArkInventory.db.profile.option.global["remember"] then
				ArkInventory.db.profile.option.global.remember["bank"] = nil
				ArkInventory.db.profile.option.global.remember["alt"] = nil
				ArkInventory.db.profile.option.global.remember = nil
			end
		
			if ArkInventory.db.profile.option.global["auto"] then
				if ArkInventory.db.profile.option.global.auto["open"] then
					ArkInventory.db.profile.option.global.auto.open["bank"] = nil
					ArkInventory.db.profile.option.global.auto.open["mail"] = nil
					ArkInventory.db.profile.option.global.auto.open["trade"] = nil
					ArkInventory.db.profile.option.global.auto.open["merchant"] = nil
					ArkInventory.db.profile.option.global.auto.open["auction"] = nil
					ArkInventory.db.profile.option.global.auto.open = nil
				end
			
				if ArkInventory.db.profile.option.global.auto["close"] then
					ArkInventory.db.profile.option.global.auto.close["bank"] = nil
					ArkInventory.db.profile.option.global.auto.close["mail"] = nil
					ArkInventory.db.profile.option.global.auto.close["trade"] = nil
					ArkInventory.db.profile.option.global.auto.close["merchant"] = nil
					ArkInventory.db.profile.option.global.auto.close["auction"] = nil
					ArkInventory.db.profile.option.global.auto.close["combat"] = nil
					ArkInventory.db.profile.option.global.auto.close = nil
				end
				
				ArkInventory.db.profile.option.global.auto = nil
			
			end
		
			if ArkInventory.db.profile.option.global["framehide"] then
				ArkInventory.db.profile.option.global.framehide["blizzard"] = nil
				ArkInventory.db.profile.option.global.framehide["status"] = nil
				ArkInventory.db.profile.option.global.framehide["header"] = nil
				ArkInventory.db.profile.option.global.framehide["changer"] = nil
				ArkInventory.db.profile.option.global.framehide = nil
			end
	
			if ArkInventory.db.profile.option.global["useglobal"] then
				ArkInventory.db.profile.option.useglobal = ArkInventory.db.profile.option.global.useglobal
				ArkInventory.db.profile.option.global.useglobal = nil
			end
			
			if ArkInventory.db.profile.option.global["category"] then
	
				local rule_id
				local item_id
				local cat_id
				local sep = "!"
				local cat_rule = sep
		
				if ArkInventory.db.profile.option.global.category["next"] then
					ArkInventory.db.profile.option.global.category.next = nil
				end
			
				if ArkInventory.db.profile.option.global.category["pt"] then
				
					-- move pt categorires to rules
					di = 0
					for cat_id, cat_name in ArkInventory.spairs( ArkInventory.db.profile.option.global.category.pt, function(a,b) return ArkInventory.db.profile.option.global.category.pt[a] > ArkInventory.db.profile.option.global.category.pt[b] end ) do
				
						d = { ["enabled"] = true, ["order"] = 1000 + di, ["name"] = "converted pt " .. cat_name, ["formula"] = "pt( " .. cat_name .. " )" }
						rule_id = ArkInventory.db.account.option.nextrule
						ArkInventory.RuleEntryAdd( rule_id, d )
						ArkInventory.PrintPlus( { "moved pt category [", cat_id, "] to rule [", rule_id, "]" } )
						di = di + 1
			
						-- erase the pt category
						ArkInventory.db.profile.option.global.category.pt[cat_id] = nil
				
						-- bars that had the old number assigned need to use the new rule number
						for loc_id in pairs( ArkInventory.Global.Location ) do
							if ArkInventory.db.profile.option["local"][loc_id]["category"] then
								barnum = ArkInventory.db.profile.option["local"][loc_id]["category"][cat_id]
								if barnum then
									ArkInventory.db.profile.option["local"][loc_id]["rule"][rule_id] = barnum
								end
								ArkInventory.db.profile.option["local"][loc_id]["category"][cat_id] = nil
							end
						end
				
					end
				
					ArkInventory.db.profile.option.global.category.pt = nil
				
				end
		
				if ArkInventory.db.profile.option.global.category["custom"] then
			
					-- move custom categorires to rules
					for cat_id, cat_name in pairs( ArkInventory.db.profile.option.global.category.custom ) do
						d = { ["enabled"] = true, ["order"] = 500, ["name"] = "converted custom " .. cat_name, ["formula"] = "false" }
						rule_id = ArkInventory.db.account.option.nextrule
						cat_rule = cat_rule .. cat_id .. "=" .. rule_id .. sep
						ArkInventory.RuleEntryAdd( rule_id, d )
						ArkInventory.PrintPlus( { "moved custom category [", cat_id, "] to rule [", rule_id, "]" } )
		
						ArkInventory.db.profile.option.global.category.custom[cat_id] = nil
					
						for loc_id in pairs( ArkInventory.Global.Location ) do
							if ArkInventory.db.profile.option["local"][loc_id]["category"] then
								barnum = ArkInventory.db.profile.option["local"][loc_id]["category"][cat_id]
								if barnum then
									ArkInventory.db.profile.option["local"][loc_id]["rule"][rule_id] = barnum
								end
								ArkInventory.db.profile.option["local"][loc_id]["category"][cat_id] = nil
							end
						end
			
					end
				
					ArkInventory.db.profile.option.global.category.custom = nil
				
				end

				-- remove any remaining negative categories assigned to bars - deleted custom categories
				for loc_id in pairs( ArkInventory.Global.Location ) do
					if ArkInventory.db.profile.option["local"][loc_id]["category"] then
						for cat_id, barnum in pairs( ArkInventory.db.profile.option["local"][loc_id]["category"] ) do
							if cat_id < 0 then
								ArkInventory.db.profile.option["local"][loc_id]["category"][cat_id] = nil
							end
						end
					end
				end

		
				-- convert to new system category numbers
				ArkInventory.CategoryRenumber_145_200( 1, -402 )
				ArkInventory.CategoryRenumber_145_200( 11, -403 )
				ArkInventory.CategoryRenumber_145_200( 12, -404 )
				ArkInventory.CategoryRenumber_145_200( 13, -405 )
				ArkInventory.CategoryRenumber_145_200( 14, -406 )
				ArkInventory.CategoryRenumber_145_200( 15, -407 )
				ArkInventory.CategoryRenumber_145_200( 16, -408 )
				ArkInventory.CategoryRenumber_145_200( 17, -409 )
				ArkInventory.CategoryRenumber_145_200( 18, -410 )
				ArkInventory.CategoryRenumber_145_200( 19, -411 )
				ArkInventory.CategoryRenumber_145_200( 20, -412 )
				ArkInventory.CategoryRenumber_145_200( 22, -413 )
				ArkInventory.CategoryRenumber_145_200( 23, -414 )
				ArkInventory.CategoryRenumber_145_200( 24, -415 )
				ArkInventory.CategoryRenumber_145_200( 25, -416 )
				ArkInventory.CategoryRenumber_145_200( 26, -417 )
				ArkInventory.CategoryRenumber_145_200( 27, -418 )
				ArkInventory.CategoryRenumber_145_200( 28, -419 )
				ArkInventory.CategoryRenumber_145_200( 29, -420 )
				ArkInventory.CategoryRenumber_145_200( 32, -421 )
				ArkInventory.CategoryRenumber_145_200( 33, -422 )
				ArkInventory.CategoryRenumber_145_200( 34, -423 )
				ArkInventory.CategoryRenumber_145_200( 35, -901 )
				ArkInventory.CategoryRenumber_145_200( 39, -424 )
				ArkInventory.CategoryRenumber_145_200( 40, -902 )
				ArkInventory.CategoryRenumber_145_200( 50, -401 )
				ArkInventory.CategoryRenumber_145_200( 51, -425 )
				ArkInventory.CategoryRenumber_145_200( 51, -426 )
				ArkInventory.CategoryRenumber_145_200( 53, -427 )
				ArkInventory.CategoryRenumber_145_200( 54, -428 )
				
				ArkInventory.CategoryRenumber_145_200( 101, -108 )
				ArkInventory.CategoryRenumber_145_200( 102, -107 )
				ArkInventory.CategoryRenumber_145_200( 103, -111 )
				ArkInventory.CategoryRenumber_145_200( 104, -112 )
				ArkInventory.CategoryRenumber_145_200( 105, -101 )
				ArkInventory.CategoryRenumber_145_200( 106, -102 )
				ArkInventory.CategoryRenumber_145_200( 107, -103 )
				ArkInventory.CategoryRenumber_145_200( 108, -104 )
				ArkInventory.CategoryRenumber_145_200( 109, -110 )
				ArkInventory.CategoryRenumber_145_200( 110, -113 )
				ArkInventory.CategoryRenumber_145_200( 111, -105 )
				ArkInventory.CategoryRenumber_145_200( 112, -106 )
				ArkInventory.CategoryRenumber_145_200( 113, -109 )
		
				ArkInventory.CategoryRenumber_145_200( 201, -201 )
				ArkInventory.CategoryRenumber_145_200( 202, -202 )
				ArkInventory.CategoryRenumber_145_200( 203, -203 )
				ArkInventory.CategoryRenumber_145_200( 204, -204 )
				ArkInventory.CategoryRenumber_145_200( 205, -205 )
				ArkInventory.CategoryRenumber_145_200( 206, -206 )
				ArkInventory.CategoryRenumber_145_200( 207, -207 )
				ArkInventory.CategoryRenumber_145_200( 208, -208 )
				ArkInventory.CategoryRenumber_145_200( 209, -209 )
	
				ArkInventory.CategoryRenumber_145_200( 301, -301 )
				ArkInventory.CategoryRenumber_145_200( 2, -302 )
				ArkInventory.CategoryRenumber_145_200( 3, -303 )
				ArkInventory.CategoryRenumber_145_200( 4, -310 )
				ArkInventory.CategoryRenumber_145_200( 5, -304 )
				ArkInventory.CategoryRenumber_145_200( 6, -305 )
				ArkInventory.CategoryRenumber_145_200( 7, -306 )
				ArkInventory.CategoryRenumber_145_200( 8, -307 )
				ArkInventory.CategoryRenumber_145_200( 9, -308 )
				ArkInventory.CategoryRenumber_145_200( 10, -309 )
				ArkInventory.CategoryRenumber_145_200( 30, -310 )
				ArkInventory.CategoryRenumber_145_200( 31, -311 )
				ArkInventory.CategoryRenumber_145_200( 302, -312 )
				
				if not ArkInventory.db.profile.option["category"] then
					ArkInventory.db.profile.option["category"] = { }  -- why i have to do this i have no idea, acedb is supposed to take care of it??????
				end

				-- move the item system category assignments (not using rules for these)			
				if ArkInventory.db.profile.option.global.category["item"] then
					
					for k, cat_id in pairs( ArkInventory.db.profile.option.global.category.item ) do
						-- 1.45 format = id . soulbound . suffix . enchant
						nk1, nk2, nk3, nk4 = strmatch( k, "^(%-?%d+)%.(%-?%d+)%.(%-?%d+)%.(%-?%d+)$" )
						if nk1 and nk2 and nk3 and nk4 then
							-- 2.00 format = id : enchant : suffix : soulbound
							item_id = tostring( nk1 .. ":" .. nk4 .. ":" .. nk3 .. ":" .. nk2 )
							--ArkInventory.PrintPlus( { "moving [", k, "] to [", item_id, "] value is [", cat_id, "]" } )
							ArkInventory.db.profile.option.category[item_id] = cat_id
						else
							ArkInventory.PrintPlus( { "item id [", k, "] is invalid and has been ignored" } )
						end
						ArkInventory.db.profile.option.global.category.item[k] = nil
					end
					--ArkInventory.db.profile.option.global.category.item = nil

				end
	
				-- move system category bar assignments to the new rule bar assignments location
				for loc_id in pairs( ArkInventory.Global.Location ) do
					if ArkInventory.db.profile.option["local"][loc_id] then
						for k, v in pairs( ArkInventory.db.profile.option["local"][loc_id]["category"] ) do
							if k < 0 then
								ArkInventory.db.profile.option["local"][loc_id]["rule"][k] = v
								ArkInventory.db.profile.option["local"][loc_id]["category"][k] = nil
							end
						end
						
					end
				end
					
				ArkInventory.db.profile.option.global.category = nil
				
			end
			
			ArkInventory.db.profile.option.global = nil
			
		end
	
		ArkInventory.db.profile.option.version = upgrade_version
		ArkInventory.db.account.option.version = upgrade_version
	
	end


	upgrade_version = 2.08
	if ArkInventory.db.profile.option.version < upgrade_version then
	
		ArkInventory:Print( format( "Upgrading profile %1$s to %2$.2f", ArkInventory:GetProfile(), upgrade_version ) )
		
		-- cleans up the enabled/disabled value on the rules for this profile
		for k, v in pairs( ArkInventory.db.profile.option.rule ) do
			if v then
				ArkInventory.db.profile.option.rule[k] = true
			else
				ArkInventory.db.profile.option.rule[k] = nil
			end
		end


		-- move the categories back from ["rule"] to ["category"]
		for loc_id in pairs( ArkInventory.Global.Location ) do
			if ArkInventory.db.profile.option["local"][loc_id]["rule"] then
				for k, v in pairs( ArkInventory.db.profile.option["local"][loc_id]["rule"] ) do
					ArkInventory.db.profile.option["local"][loc_id]["category"][k] = v
					ArkInventory.db.profile.option["local"][loc_id]["rule"][k] = nil
				end
			end
		end
		
		ArkInventory.db.profile.option.version = upgrade_version
		ArkInventory.db.account.option.version = upgrade_version
	
	end



	upgrade_version = 2.09
	if ArkInventory.db.profile.option.version < upgrade_version then
	
		ArkInventory:Print( format( "Upgrading profile %1$s to %2$.2f", ArkInventory:GetProfile(), upgrade_version ) )
	
		if ArkInventory.db.account.cache.version < upgrade_version then
			ArkInventory.OfflineCacheErase()
		end
		
		ArkInventory.db.profile.option.version = upgrade_version
		ArkInventory.db.account.option.version = upgrade_version

	end
	
	
	-- update all rules to ensure they are compiled and not damaged (and in case we change anything in the rule code)
	for k, v in pairs( ArkInventory.db.account.option.rule ) do
		--if not v.damaged then
			v["enabled"] = ArkInventory.db.profile.option.rule[k]
			ArkInventory.RuleEntryUpdate( k, v )
		--end
	end
	
	-- check sort keys
	ArkInventory.ItemSortKeyCheck()
	
	-- set version to current mod version
	upgrade_version = ArkInventory.Const.Program.Version
	ArkInventory.db.profile.option.version = upgrade_version
	ArkInventory.db.account.option.version = upgrade_version
	ArkInventory.db.account.cache.version = upgrade_version	
	
end
